SUBROUTINE HIE_eq

use params

! use minimization_fcn1
use mod_dp
! need to specify next period value to be consistent with value

implicit none

LOGICAL ISNAN


INTEGER ind_type, ed_type, health_type, hi_type, firm_index, hi_firm_index, period, ins_status, new_firm_index, work_exp
INTEGER med_care
INTEGER next_health
INTEGER i, j, k, m,n, t, num_size
REAL(DP)  unemp_health(num_period, 2, num_health), emp_health(num_period, 3, num_health), hi_ehi, premium_all, all_ix, unemp_rate,unemp_ix, ix_insured_emp,eshi_emp, unins_emp, denom, denom_age(num_period), uninsured, uninsured_age(num_period), uninsured_emp(num_period), ix_emp(num_period), sum_1(num_period)

!define whether rating is age based or not
ix_insured_emp=0.0d0
eshi_emp=0.0d0
unins_emp=0.0d0
unemp_rate=sum (unemp_dist(:, :, :, :, :) )
unemp_ix=0.0d0
DO t=1, num_period
uninsured_age(t)=0.0d0 !sum (unemp_dist(:, :, :, :, t) ) !*cohort_weight(t)
denom_age(t)=0.0d0 ! sum (unemp_dist(:, :, :, 2, :, t) ) !*cohort_weight(t)

DO j=1, num_health
unemp_health(t,1,j)=0.0d0
unemp_health(t,2,j)=0.0d0
DO work_exp=1, t
DO ed_type=1, num_ed
DO ind_type=1, num_type
unemp_ix=unemp_ix+unemp_dist(ind_type, ed_type, j, work_exp, t)*(1.0d0-choice_ii_u(ind_type, ed_type, j, work_exp, t)) 
unemp_health(t,1,j)=unemp_health(t,1,j)+unemp_dist(ind_type, ed_type, j, work_exp, t)*choice_ii_u(ind_type, ed_type, j, work_exp, t)
unemp_health(t,2,j)=unemp_health(t,2,j)+unemp_dist(ind_type, ed_type, j, work_exp, t)*(1.0d0-choice_ii_u(ind_type, ed_type, j, work_exp, t)) 
END DO
END DO
END DO
END DO


uninsured_emp(t)=0.0d0
ix_emp(t)=0.0d0
sum_1(t)=0.0d0 !sum (unemp_dist(:, :, :, 2, :, t) )*t
DO i=1, num_firm
DO work_exp=1, t
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
ix_insured_emp=ix_insured_emp+emp_dist(ind_type, ed_type, health_type, 1, i,work_exp, t)*(1.0d0-choice_ii(ind_type, ed_type, health_type, i,work_exp, t))*(1.0d0-ehi_offer(i))*prob_meet(i)
eshi_emp=eshi_emp+emp_dist(ind_type, ed_type, health_type, 2, i,work_exp, t)*ehi_offer(i)*prob_meet(i)
uninsured_emp(t)=uninsured_emp(t)+emp_dist(ind_type, ed_type, health_type, 1, i,work_exp, t)*choice_ii(ind_type, ed_type, health_type, i,work_exp, t)*(1.0d0-ehi_offer(i))*prob_meet(i)
ix_emp(t)=ix_emp(t)+emp_dist(ind_type, ed_type, health_type, 1, i,work_exp, t)*(1.0d0-choice_ii(ind_type, ed_type, health_type, i,work_exp, t))*(1.0d0-ehi_offer(i))*prob_meet(i)
denom_age(t)=denom_age(t)+ emp_dist(ind_type, ed_type, health_type, 1, i,work_exp, t)*(1.0d0-choice_ii(ind_type, ed_type, health_type, i,work_exp, t))*(1.0d0-ehi_offer(i))*prob_meet(i) !*cohort_weight(t)
sum_1(t)=sum_1(t)+ emp_dist(ind_type, ed_type, health_type, 1, i,work_exp, t)*(1.0d0-choice_ii(ind_type, ed_type, health_type, i,work_exp, t))*(1.0d0-ehi_offer(i))*prob_meet(i)*t
uninsured_age(t)=uninsured_age(t)+emp_dist(ind_type, ed_type, health_type, 1, i,work_exp, t)*choice_ii(ind_type, ed_type, health_type, i,work_exp, t)*(1.0d0-ehi_offer(i))*prob_meet(i) !*cohort_weight(t)  
END DO
END DO
END DO
END DO
END DO

DO j=1, num_health
emp_health(t, 1, j)=0.0d0
emp_health(t, 2, j)=0.0d0
emp_health(t, 3, j)=0.0d0
DO i=1, num_firm
DO work_exp=1, t
DO ed_type=1, num_ed
DO ind_type=1, num_type
emp_health(t, 1, j)=emp_health(t, 1, j)+emp_dist(ind_type, ed_type, j, 1, i,work_exp, t)*choice_ii(ind_type, ed_type, j, i,work_exp, t)*(1.0d0-ehi_offer(i))*prob_meet(i)
emp_health(t, 2, j)=emp_health(t, 2, j)+emp_dist(ind_type, ed_type, j, 2, i,work_exp, t)*ehi_offer(i)*prob_meet(i)
emp_health(t, 3, j)=emp_health(t, 3, j)+emp_dist(ind_type, ed_type, j, 1, i,work_exp, t)*(1.0d0-choice_ii(ind_type, ed_type, j, i,work_exp, t))*(1.0d0-ehi_offer(i))*prob_meet(i)
END DO
END DO
END DO
END DO
END DO

END DO



unins_emp=unins_emp+sum(uninsured_emp(:))

uninsured=sum(uninsured_age(:))
 
  
  
premium_all=0.0d0 
all_ix=0.0d0
IF (rating==1) THEN
premium_all=0.0d0
DO t=1, num_period 
hie_premium_new(t)=0.0d0

hi_ehi=0.0d0
DO work_exp=1, num_exp
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type

DO firm_index=1, num_firm
hie_premium_new(t)=hie_premium_new(t)+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t) &
*(1.0d0-choice_ii(ind_type, ed_type, health_type, firm_index,work_exp, t))*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index) &
*ex_med_ii(ind_type, ed_type, health_type, firm_index, work_exp, t) !*cohort_weight(t)
END DO

END DO
END DO
END DO
END DO

premium_all=premium_all+hie_premium_new(t)

IF (denom_age(t)>0.0d0) THEN
hie_premium_new(t)=hie_premium_new(t)/denom_age(t)*hie_loading
ELSE
hie_premium_new(t)=hie_premium(t)
END IF

END DO ! t
 
premium_all=premium_all/sum(denom_age(:))
 
ELSE IF (rating==2) THEN
premium_all=0.0d0
DO t=1, num_period
DO work_exp=1, num_exp
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
DO firm_index=1, num_firm
premium_all=premium_all+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t) &
*(1.0d0-choice_ii(ind_type, ed_type, health_type, firm_index,work_exp, t))*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index) &
*ex_med_ii(ind_type, ed_type, health_type, firm_index, work_exp, t) !*cohort_weight(t)
END DO

END DO
END DO
END DO
END DO
END DO

IF (Medicaid==0) THEN
DO t=1, num_period
DO work_exp=1, num_exp
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type

premium_all=premium_all+unemp_dist(ind_type, ed_type, health_type, work_exp, t) &
*(1.0d0-Pr_Medicaid)*choice_m_u(ind_type, ed_type, health_type, work_exp, t) &
*ex_med_m_u(ind_type, ed_type, health_type,  work_exp, t) !*cohort_weight(t)

denom_age(t)=denom_age(t)+unemp_dist(ind_type, ed_type, health_type, work_exp, t) &
*(1.0d0-Pr_Medicaid)*choice_m_u(ind_type, ed_type, health_type, work_exp, t)

END DO

END DO
END DO
END DO
END DO
END IF


denom=sum(denom_age(:))

IF (denom>0.0d0) THEN
!premium_all=premium_all
hie_premium_new(1)=premium_all*hie_loading*(num_period-1.0d0)/ ( (num_period-1.0d0)*denom+(age_band-1.0d0)*(sum(sum_1(:))-denom) )  
DO t=2, num_period
hie_premium_new(t)=hie_premium_new(1)+hie_premium_new(1)*(age_band-1.0d0)/(num_period-1.0d0)*(t-1.0d0)
END DO
ELSE
DO t=1, num_period
hie_premium_new(t)=hie_premium(t)
END DO
END IF
 
premium_all=premium_all/sum(denom_age(:))


END IF
 
IF (data_mode==2) THEN 

OPEN(100, file="hie_premium_comparison.txt")
DO t=1, num_period
write(100, *) hie_premium_new(t), hie_premium(t)
END DO 
CLOSE (100)

OPEN(100, file="unins_ii_ratio.txt")
DO t=1, num_period
write(100, *) denom_age(t)/(uninsured_age(t)+denom_age(t))
END DO 
CLOSE (100)

OPEN(100, file="unins_ii_emp.txt")
DO t=1, num_period
write(100, *) ix_emp(t)/(uninsured_emp(t)+ix_emp(t))
END DO 
CLOSE (100)

OPEN(100, file="unemp.txt")
DO t=1, num_period
write(100, *) sum (unemp_dist(:, :, :, :, t) )/sum(cohort_weight(t,:))
END DO 
CLOSE (100)

!OPEN(100, file="totl_uninsured.txt")
!write(100, *) uninsured, 'uninsured'
!write(100, *) ix_insured_emp/(unins_emp+ix_insured_emp+eshi_emp), 'ratio'
!write(100, *) ix_insured_emp, 'ix'
!write(100, *) eshi_emp, 'eshi'
!write(100, *) unins_emp, 'unins_emp'
!write(100, *) unemp_rate, 'unemp'
!write(100, *) unemp_ix, 'unemp_ix'
!write(100, *) unemp_rate-unemp_ix, 'unemp_unins'
!CLOSE (100)

OPEN(100, file="totl_premium.txt")
write(100, *) premium_all
CLOSE (100)


OPEN(100, file="health_composition.txt")
write(100, *) 'employed'
DO t=1, num_period
write(100, *) emp_health(t, 1, 1)/(emp_health(t, 1, 1)+emp_health(t, 1, 2)),emp_health(t, 2, 1)/(emp_health(t, 2, 1)+emp_health(t, 2, 2)), emp_health(t, 3, 1)/(emp_health(t, 3, 1)+emp_health(t, 3, 2)) 
END DO
write(100, *) 'unemployed'
DO t=1, num_period
write(100, *) unemp_health(t,1,1)/(unemp_health(t,1,1)+unemp_health(t,1,2)),unemp_health(t,2,1)/(unemp_health(t,2,1)+unemp_health(t,2,2)) 
END DO
CLOSE (100)


OPEN(100, file="health_population_mean.txt")
DO t=1, num_period
write(100, *) (emp_health(t, 1, 1)+emp_health(t, 2, 1)+emp_health(t, 3, 1)+unemp_health(t,1,1)+unemp_health(t,2,1))/((emp_health(t, 1, 1)+emp_health(t, 2, 1)+emp_health(t, 3, 1)+unemp_health(t,1,1)+unemp_health(t,2,1))+(emp_health(t, 1, 2)+emp_health(t, 2, 2)+emp_health(t, 3, 2)+unemp_health(t,1,2)+unemp_health(t,2,2))   )
!print*, sum(emp_dist(:, :, :, 1, :,:, 2:num_period)), sum (unemp_dist(:, :, :, 1, :, 2:num_period) )
END DO
CLOSE (100)

END IF

END SUBROUTINE