


program main


 
 

use params
use mod_dp
use Nelder_Mead

implicit none

LOGICAL ISNAN

integer:: i,j,k,n,m,t, count 
integer t1, t2, t_rate, t_max, diff, cluster, counter
real(dp) criteria, weight, firm_mm
real(dp), parameter:: tol=0.001
INTEGER:: nop, nloop, maxfn_umpl, param_number          
REAL(DP), parameter:: stopcr=1.d-6, simp=1.d-6
INTEGER, parameter::maxfn=150000, iprint=1, iquad=1
INTEGER ifault
REAL(DP), Allocatable:: var(:), step(:), firm_param(:)   


!! HOPSPACK
CHARACTER 	:: inarg*100,outarg*100,tag1*100,tt
REAL(dp)	:: argc
REAL(dp)	:: hp_objective_value
!start counting the time
!call system_clock(t1)


num_param_est=59
ALLOCATE (param_est(num_param_est))

cluster=1 
optimal_dummy=5
ehi_tax_regime=1
uncomp=1
eshi_weight=1.00d0 !1.50d0


! read the parameter
call reading

!! CALL OPTIMAL POLICY PARAMETERS
IF (optimal_dummy==1) THEN
!READ policy parameter
!OPEN(1,file="policy_parameters.txt")
OPEN(1,file="policy_parameters2.txt")
READ(1,fmt=*)  age_band
READ(1,fmt=*)  alpha_s_0
READ(1,fmt=*)  alpha_s_1
READ(1,fmt=*)  alpha_s_2
READ(1,fmt=*)  beta_s_1
READ(1,fmt=*)  beta_s_2
READ(1,fmt=*)  alpha_im_0
READ(1,fmt=*)  alpha_im_1
READ(1,fmt=*)  alpha_im_2
READ(1,fmt=*)  beta_im_1
READ(1,fmt=*)  beta_im_2
CLOSE(1)
END IF 


!IF (optimal_dummy==2) THEN
!!READ policy parameter
!OPEN(1,file="policy_parameters1.txt")
!READ(1,fmt=*)  age_band
!READ(1,fmt=*)  exchange_subs_rate
!READ(1,fmt=*)  exchange_subs_max
!READ(1,fmt=*)  ind_penalty
!READ(1,fmt=*)  ind_penalty_rate
!READ(1,fmt=*)  fpl_100
!CLOSE(1)
!END IF 



!IF (optimal_dummy==4) THEN
!!READ policy parameter
!OPEN(1,file="policy_parameters4.txt")
!READ(1,fmt=*)  age_band
!CLOSE(1)
!END IF 

!IF (optimal_dummy==5) THEN
!!READ policy parameter
!!OPEN(1,file="policy_parameters.txt")
!OPEN(1,file="policy_parameters3.txt")
!READ(1,fmt=*)  age_band
!READ(1,fmt=*)  alpha_s_0
!READ(1,fmt=*)  alpha_s_1
!READ(1,fmt=*)  alpha_s_2
!READ(1,fmt=*)  beta_s_1
!READ(1,fmt=*)  beta_s_2
!!READ(1,fmt=*)  alpha_s_0_e
!!READ(1,fmt=*)  alpha_s_1_e
!!READ(1,fmt=*)  alpha_s_2_e
!!READ(1,fmt=*)  beta_s_1_e
!!READ(1,fmt=*)  beta_s_2_e
!CLOSE(1)
!END IF 

!age_band=3.00
!alpha_s_0=4.0750d0
!alpha_s_1=-3.8799
!alpha_s_2=-1.1549
!
!!alpha_s_0=-24.0750d0
!
!!
!!age_band=4.58d0
!!
!beta_s_1=0.00d0
!beta_s_2=0.00d0
!
!sub_welfare=0.0048d0
!sub_welfare=0.0d0
!
!!alpha_s_0=-26.61d0
!!alpha_s_1=0.0d0
!!alpha_s_2=0.0d0
!
!!alpha_s_1=-3.17d0
!!alpha_s_2=-0.20d0
!
!!! optimal policy (no im) !!!!!!!!!!!!!!!

!age_band=4.70
!alpha_s_0=3.85750d0
!alpha_s_1=-2.050
!alpha_s_2=-0.001
!beta_s_1=-0.0235
!beta_s_2=-0.0000



!!! optimal full !!!!!!!!!!!!!!!
age_band=4.94
alpha_s_0=3.47750d0
alpha_s_1=-1.750
alpha_s_2=-0.001
beta_s_1=-0.0215
beta_s_2=-0.0000
im_p(1)=0.031
im_p(2)=0.0d0
im_p(3)=0.000
im_p(4)=0.00d0
im_p(5)=0.000d0


!!!! optimal policy (no im age) !!!!!!!!!!!!!!!
!age_band=3.00
!alpha_s_0=4.05750d0
!alpha_s_1=-2.100
!alpha_s_2=-0.001
!beta_s_1=-0.026
!beta_s_2=-0.0000

!!! optimal full ESHi fixed !!!!!!!!!!!!!!!
!age_band=4.14
!alpha_s_0=2.900d0
!alpha_s_1=-1.350
!alpha_s_2=-0.301
!beta_s_1=-0.0155
!beta_s_2=-0.0000


!!! optimal full ESHi premium fixed !!!!!!!!!!!!!!!

!age_band=3.00
!alpha_s_0=3.67050d0
!alpha_s_1=-2.450
!alpha_s_2=-0.001
!beta_s_1=-0.0195
!beta_s_2=-0.0000




!!! optimal full premium fixed !!!!!!!!!!!!!!!

!age_band=3.00
!alpha_s_0=4.0050d0
!alpha_s_1=-2.090
!alpha_s_2=-0.001
!beta_s_1=-0.027
!beta_s_2=-0.0000
!
!im_p(1)=0.031
!im_p(2)=0.00
!im_p(3)=0.00
!im_p(4)=0.00d0
!im_p(5)=0.00d0

!!!! optimal HIX and ESHI subsidies !!!!!!!!!!!!!!!!!!!!!!!!!
!alpha_s_0_e=-1.105
!alpha_s_1_e=-0.02624
!alpha_s_2_e=-0.005
!beta_s_1_e=0.001
!beta_s_2_e=0.00
!!
!age_band=4.94
!alpha_s_0=4.3750d0
!alpha_s_1=-0.150
!alpha_s_2=-0.001
!beta_s_1=-0.0260
!beta_s_2=-0.0000
!im_p(1)=0.031
!im_p(2)=0.0d0
!im_p(3)=0.000
!im_p(4)=0.00d0
!im_p(5)=0.000d0

!!!! Optimal: uncompensated care !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!age_band=4.79
!alpha_s_0=4.47750d0
!alpha_s_1=-1.340
!alpha_s_2=-0.001
!beta_s_1=-0.02
!beta_s_2=-0.0000
!im_p(1)=0.0370
!im_p(2)=0.0d0
!im_p(3)=0.000
!im_p(4)=0.00d0
!im_p(5)=0.000d0


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!



coins_ii=0.2d0 
deduc_ii=0.02d0 



DO i=1, num_period
DO j=1, num_health
IF (j==2) THEN
p_ii(i,j)=0.089+(18+i/3)*0.0001
ELSE
p_ii(i,j)=0.069+(18+i/3)*(-0.0005)
END IF
END DO
END DO




DO i=1, num_period
reject(i)=0.00 !0.05+i/500d0
END DO



!
eta1_m(1)=0.00d0
eta1_m(2)=0.00d0
eta2_m(1)=1.00d0 
eta2_m(2)=1.00d0
data_mode=1



num_moment1=33
num_moment2=3
num_moment3=9
num_moment4=12

allocate(w_firm_mat(num_moment3), mat_weight(num_moment1*5*2+num_moment2*2+num_moment4*3+num_moment3,num_moment1*5*2+num_moment2*2+num_moment4*3+num_moment3))



CALL READ_DATA

!OPEN(1, file="parameter_value_update.txt")
!DO n=1, num_param_est
! READ(1,fmt=*)  param_est(n)
!END DO
!CLOSE (1) 



call read_param
!!!!!!!!!!!!



call draw_rn


call welfare





  
end program