SUBROUTINE sim_moments(mom_number)


use params
use mod_dp



!REAL(DP) moments_all()

implicit none

LOGICAL ISNAN

REAL(DP) mom_number
integer:: i,j,k,n,m,t, tt, count !index
integer, parameter:: c_size=7
REAL(DP) moments(36, 5, 2), moments1(3,2), moments2(16, 3, 2), moments3(12,3) 
! employment rate

!print*, wage_ii_sample, 'wage_ii_sample'
!print*, wage_average_ii_c, 'wage_ii_model'
!print*, w_wage_ii_sample, 'w_wage_ii_model'
!print*, eshi_rate_c, 'eshi_rate'
!print*, eshi_rate_sample, 'eshi_sample'
!print*, w_eshi_rate_sample, 'w_eshi_sample'
!print*, eshi_rate_c, 'eshi_rate_c'
!print*, eshi_rate_sample, 'eshi_rate_sample'
!print*, w_eshi_rate_sample, 'w_eshi_rate_'
!print*, ii_rate_c, 'ii_rate_c'
!print*, ii_rate_sample, 'ii_rate_sample'
!print*, w_ii_rate_sample, 'w_ii_rate_'
!print*, ii_u_rate_c, 'ii_u_rate_c'
!print*, ii_u_rate_sample, 'ii_u_rate_sample'
!print*, w_ii_u_rate_sample, 'w_ii_u_rate_'


DO n=1, 2

DO t=1, 5
moments(1,t,n)=(ump_rate_c(t,n)-ump_rate_sample(t,n))**2.0d0*w_ump_rate_sample(t,n)**(-1.0d0)
moments(2,t,n)=(ue_hi_c(t,n)-ue_hi_sample(t,n))**2.0d0*w_ue_hi_sample(t,n)**(-1.0d0)
moments(3,t,n)=(ue_nhi_c(t,n)-ue_nhi_sample(t,n))**2.0d0*w_ue_nhi_sample(t,n)**(-1.0d0)
moments(4,t,n)=(eu_c(t,n)-eu_sample(t,n))**2.0d0*w_eu_sample(t,n)**(-1.0d0)
moments(5,t,n)=(wage_average_hi_c(t,n)-wage_hi_sample(t,n))**2.0d0*w_wage_hi_sample(t,n)**(-1.0d0)
moments(6,t,n)=(wage_average_nhi_c(t,n)-wage_nhi_sample(t,n))**2.0d0*w_wage_nhi_sample(t,n)**(-1.0d0)
moments(7,t,n)=(wage_average_ii_c(t,n)-wage_ii_sample(t,n))**2.0d0*w_wage_ii_sample(t,n)**(-1.0d0)
moments(8,t,n)= (std_wage_average_hi_c(t,n)-std_wage_hi_sample(t,n))**2.0d0*w_std_wage_hi_sample(t,n)**(-1.0d0)
moments(9,t,n)= (std_wage_average_nhi_c(t,n)-std_wage_nhi_sample(t,n))**2.0d0*w_std_wage_nhi_sample(t,n)**(-1.0d0)
moments(10,t,n)= (std_wage_average_ii_c(t,n)-std_wage_ii_sample(t,n))**2.0d0*w_std_wage_ii_sample(t,n)**(-1.0d0)
moments(11,t,n)=(jj_rate_c(t,n)-jj_sample(t,n))**2.0d0*w_jj_sample(t,n)**(-1.0d0)
moments(12,t,n)=(jj_hihi_c(t,n)-jj_hihi_sample(t,n))**2.0d0*w_jj_hihi_sample(t,n)**(-1.0d0)
moments(13,t,n)=(jj_hinhi_c(t,n)-jj_hinhi_sample(t,n))**2.0d0*w_jj_hinhi_sample(t,n)**(-1.0d0)
moments(14,t,n)=(jj_nhihi_c(t,n)-jj_nhihi_sample(t,n))**2.0d0*w_jj_nhihi_sample(t,n)**(-1.0d0)
moments(15,t,n)=(jj_nhinhi_c(t,n)-jj_nhinhi_sample(t,n))**2.0d0*w_jj_nhinhi_sample(t,n)**(-1.0d0)
moments(16,t,n)=(wage_jj_hihi_c(t,n)-wage_change_jj_hihi_sample(t,n))**2.0d0*w_wage_change_jj_hihi_sample(t,n)**(-1.0d0)
moments(17,t,n)=(wage_jj_hinhi_c(t,n)-wage_change_jj_hinhi_sample(t,n))**2.0d0*w_wage_change_jj_hinhi_sample(t,n)**(-1.0d0)
moments(18,t,n)=(wage_jj_nhihi_c(t,n)-wage_change_jj_nhihi_sample(t,n))**2.0d0*w_wage_change_jj_nhihi_sample(t,n)**(-1.0d0)
moments(19,t,n)=(wage_jj_nhinhi_c(t,n)-wage_change_jj_nhinhi_sample(t,n))**2.0d0*w_wage_change_jj_nhinhi_sample(t,n)**(-1.0d0)
moments(20,t,n)=(std_wage_jj_hihi_c(t,n)-std_wage_change_jj_hihi_sample(t,n))**2.0d0*w_std_wage_change_jj_hihi_sample(t,n)**(-1.0d0)
moments(21,t,n)=(std_wage_jj_hinhi_c(t,n)-std_wage_change_jj_hinhi_sample(t,n))**2.0d0*w_std_wage_change_jj_hinhi_sample(t,n)**(-1.0d0)
moments(22,t,n)=(std_wage_jj_nhihi_c(t,n)-std_wage_change_jj_nhihi_sample(t,n))**2.0d0*w_std_wage_change_jj_nhihi_sample(t,n)**(-1.0d0)
moments(23,t,n)=(std_wage_jj_nhinhi_c(t,n)-std_wage_change_jj_nhinhi_sample(t,n))**2.0d0*w_std_wage_change_jj_nhinhi_sample(t,n)**(-1.0d0)
moments(24,t,n)=(wage_stay_hi_c(t,n)-wage_change_stay_hi_sample(t,n))**2.0d0*w_wage_change_stay_hi_sample(t,n)**(-1.0d0)
moments(25,t,n)=(wage_stay_nhi_c(t,n)-wage_change_stay_nhi_sample(t,n))**2.0d0*w_wage_change_stay_nhi_sample(t,n)**(-1.0d0)
moments(26,t,n)=(std_wage_stay_hi_c(t,n)-std_wage_change_stay_hi_sample(t,n))**2.0d0*w_std_wage_change_stay_hi_sample(t,n)**(-1.0d0)
moments(27,t,n)=(std_wage_stay_nhi_c(t,n)-std_wage_change_stay_nhi_sample(t,n))**2.0d0*w_std_wage_change_stay_nhi_sample(t,n)**(-1.0d0)
moments(28,t,n)=(wage_ue_hi_c(t,n)-wage_ue_hi_sample(t,n))**2.0d0*w_wage_ue_hi_sample(t,n)**(-1.0d0)
moments(29,t,n)=(wage_ue_nhi_c(t,n)-wage_ue_nhi_sample(t,n))**2.0d0*w_wage_ue_nhi_sample(t,n)**(-1.0d0)
moments(30,t,n)=(std_wage_ue_hi_c(t,n)-std_wage_ue_hi_sample(t,n))**2.0d0*w_std_wage_ue_hi_sample(t,n)**(-1.0d0)
moments(31,t,n)=(std_wage_ue_nhi_c(t,n)-std_wage_ue_nhi_sample(t,n))**2.0d0*w_std_wage_ue_nhi_sample(t,n)**(-1.0d0)
moments(32,t,n)=(eshi_rate_c(t,n)-eshi_rate_sample(t,n))**2.0d0*w_eshi_rate_sample(t,n)**(-1.0d0)
moments(33,t,n)=(ii_rate_c(t,n)-ii_rate_all_sample(t,n))**2.0d0*w_ii_rate_all_sample(t,n)**(-1.0d0)
moments(34,t,n)=(health_c(t,n)-health_sample(t,n))**2.0d0*w_health_sample(t,n)**(-1.0d0)
moments(35,t,n)=(health_transit_hh_c(t,n)-health_transition_hh_sample(t,n))**2.0d0*w_health_transition_hh_sample(t,n)**(-1.0d0)
moments(36,t,n)=(health_transit_uu_c(t,n)-health_transition_uu_sample(t,n))**2.0d0*w_health_transition_uu_sample(t,n)**(-1.0d0)
END DO

DO t=1, 3
moments2(1,t,n)=(med_exp_h_c(t,n)-med_exp_sample_h_sample(t,n))**2.0d0*w_med_exp_sample_h_sample(t,n)**(-1.0d0)
moments2(2,t,n)=(med_exp_u_c(t,n)-med_exp_sample_u_sample(t,n))**2.0d0*w_med_exp_sample_u_sample(t,n)**(-1.0d0)
moments2(3,t,n)=(std_med_exp_h_c(t,n)-std_med_exp_sample_h_sample(t,n))**2.0d0*w_std_med_exp_sample_h_sample(t,n)**(-1.0d0)
moments2(4,t,n)=(std_med_exp_u_c(t,n)-std_med_exp_sample_u_sample(t,n))**2.0d0*w_std_med_exp_sample_u_sample(t,n)**(-1.0d0)
moments2(5,t,n)=(med_exp_sample_h_hi(t,n,1,1)-med_exp_h_hi_c(t,n,1,1))**2.0d0*w_med_exp_sample_h_hi(t,n,1,1)**(-1.0d0)
moments2(6,t,n)=(med_exp_sample_h_hi(t,n,2,1)-med_exp_h_hi_c(t,n,2,1))**2.0d0*w_med_exp_sample_h_hi(t,n,2,1)**(-1.0d0)
moments2(7,t,n)=(med_exp_sample_h_hi(t,n,1,2)-med_exp_h_hi_c(t,n,1,2))**2.0d0*w_med_exp_sample_h_hi(t,n,1,2)**(-1.0d0)
moments2(8,t,n)=(med_exp_sample_h_hi(t,n,2,2)-med_exp_h_hi_c(t,n,2,2))**2.0d0*w_med_exp_sample_h_hi(t,n,2,2)**(-1.0d0)
moments2(9,t,n)=(std_med_exp_sample_h_hi(t,n,1,1)-std_med_exp_h_hi_c(t,n,1,1))**2.0d0*w_std_med_exp_sample_h_hi(t,n,1,1)**(-1.0d0)
moments2(10,t,n)=(std_med_exp_sample_h_hi(t,n,2,1)-std_med_exp_h_hi_c(t,n,2,1))**2.0d0*w_std_med_exp_sample_h_hi(t,n,2,1)**(-1.0d0)
moments2(11,t,n)=(std_med_exp_sample_h_hi(t,n,1,2)-std_med_exp_h_hi_c(t,n,1,2))**2.0d0*w_std_med_exp_sample_h_hi(t,n,1,2)**(-1.0d0)
moments2(12,t,n)=(std_med_exp_sample_h_hi(t,n,2,2)-std_med_exp_h_hi_c(t,n,2,2))**2.0d0*w_std_med_exp_sample_h_hi(t,n,2,2)**(-1.0d0)
moments2(13,t,n)=(positive_sample_h_hi(t,n,1,1)-positive_h_hi_c(t,n,1,1))**2.0d0*w_positive_sample_h_hi(t,n,1,1)**(-1.0d0)
moments2(14,t,n)=(positive_sample_h_hi(t,n,2,1)-positive_h_hi_c(t,n,2,1))**2.0d0*w_positive_sample_h_hi(t,n,2,1)**(-1.0d0)
moments2(15,t,n)=(positive_sample_h_hi(t,n,1,2)-positive_h_hi_c(t,n,1,2))**2.0d0*w_positive_sample_h_hi(t,n,1,2)**(-1.0d0)
moments2(16,t,n)=(positive_sample_h_hi(t,n,2,2)-positive_h_hi_c(t,n,2,2))**2.0d0*w_positive_sample_h_hi(t,n,2,2)**(-1.0d0)
! print*, w_std_med_exp_sample_h_hi(t,n,1,2)**(-1.0d0), w_std_med_exp_sample_h_hi(t,n,2,2)**(-1.0d0)
END DO

moments1(1, n)=(health_hi_sim(n)-health_hi(n))**2.0d0*w_health_hi(n)**(-1.0d0)
moments1(2, n)=(health_nhi_sim(n)-health_nhi(n))**2.0d0*w_health_nhi(n)**(-1.0d0)
moments1(3, n)=(health_unemp_sim(n)-health_unemp(n))**2.0d0*w_health_unemp(n)**(-1.0d0)

END DO


DO t=1, 3
moments3(1,t)= (sim_med_exp_sample_h_hi_1(t,1,1)-med_exp_sample_h_hi_1(t,1,1))**2.0d0*w_med_exp_sample_h_hi_1(t,1,1)**(-1.0d0)
moments3(2,t)= (sim_med_exp_sample_h_hi_1(t,2,1)-med_exp_sample_h_hi_1(t,2,1))**2.0d0*w_med_exp_sample_h_hi_1(t,2,1)**(-1.0d0)
moments3(3,t)= (sim_med_exp_sample_h_hi_1(t,1,2)-med_exp_sample_h_hi_1(t,1,2))**2.0d0*w_med_exp_sample_h_hi_1(t,1,2)**(-1.0d0)
moments3(4,t)= (sim_med_exp_sample_h_hi_1(t,2,2)-med_exp_sample_h_hi_1(t,2,2))**2.0d0*w_med_exp_sample_h_hi_1(t,2,2)**(-1.0d0)
moments3(5,t)= (sim_positive_sample_h_hi_1(t,1,1)-positive_sample_h_hi_1(t,1,1))**2.0d0*w_positive_sample_h_hi_1(t,1,1)**(-1.0d0)
moments3(6,t)= (sim_positive_sample_h_hi_1(t,2,1)-positive_sample_h_hi_1(t,2,1))**2.0d0*w_positive_sample_h_hi_1(t,2,1)**(-1.0d0)
moments3(7,t)= (sim_positive_sample_h_hi_1(t,1,2)-positive_sample_h_hi_1(t,1,2))**2.0d0*w_positive_sample_h_hi_1(t,1,2)**(-1.0d0)
moments3(8,t)= (sim_positive_sample_h_hi_1(t,2,2)-positive_sample_h_hi_1(t,2,2))**2.0d0*w_positive_sample_h_hi_1(t,2,2)**(-1.0d0)
moments3(9,t)= (sim_std_med_exp_sample_h_hi_1(t,1,1)-std_med_exp_sample_h_hi_1(t,1,1))**2.0d0*w_std_med_exp_sample_h_hi_1(t,1,1)**(-1.0d0)
moments3(10,t)= (sim_std_med_exp_sample_h_hi_1(t,2,1)-std_med_exp_sample_h_hi_1(t,2,1))**2.0d0*w_std_med_exp_sample_h_hi_1(t,2,1)**(-1.0d0)
moments3(11,t)=(sim_std_med_exp_sample_h_hi_1(t,1,2)-std_med_exp_sample_h_hi_1(t,1,2))**2.0d0*w_std_med_exp_sample_h_hi_1(t,1,2)**(-1.0d0)
moments3(12,t)= (sim_std_med_exp_sample_h_hi_1(t,2,2)-std_med_exp_sample_h_hi_1(t,2,2))**2.0d0*w_std_med_exp_sample_h_hi_1(t,2,2)**(-1.0d0)

END DO

! calculate moment
mom_number=0.0d0
DO n=1, 2

DO i=1, 36
DO j=1, 5
!print*, i,j,n, moments(i,j,n), 'moments'
IF (ISNAN(moments(i,j,n))) THEN
moments(i,j,n)=100.0d0
END IF
mom_number=mom_number+moments(i,j,n)

END DO
END DO

!DO i=1, 16
!DO j=1, 3
!! print*, i,j,n, moments2(i,j,n), 'moments'
!IF (ISNAN(moments2(i,j,n))) THEN
!moments2(i,j,n)=100.0d0
!END IF
!mom_number=mom_number+moments2(i,j,n)
!
!END DO
!END DO



DO i=1,3
!print*, i,n,moments1(i,n), 'moments1'
IF (ISNAN(moments1(i,n))) THEN
moments1(i,n)=100.0d0
END IF
mom_number=mom_number+moments1(i,n)
END DO



END DO

DO i=1, 12
DO j=1, 3
IF (ISNAN(moments3(i,j))) THEN
moments3(i,j)=100.0d0
END IF
mom_number=mom_number+moments3(i,j)

END DO
END DO

! print*, mom_number, 'mom_number'

IF (data_mode==2) THEN
OPEN(100, file="moment_value_estimate.txt")
DO n=1, 2
DO i=1, 37
DO j=1, 5
write(100, *) n,i,j,moments(i,j,n)
END DO
END DO
END DO
DO n=1, 2
DO i=1,3
write(100, *) n,i,moments1(i,n), 'moment1'
END DO
END DO
DO n=1, 2
DO i=1, 16
DO j=1, 3
write(100, *) n,i,j,moments2(i,j,n)
END DO
END DO
END DO
CLOSE (100)

END IF

END SUBROUTINE
