SUBROUTINE value_calculation_last
! obtain E-max value exept the last period


use params
! use minimization_fcn1
use mod_dp
USE olsroutines
USE Emax_approximation
USE probability
! need to specify next period value to be consistent with value

implicit none

LOGICAL ISNAN

INTEGER ind_type, ed_type, health_type, hi_type, firm_index, hi_firm_index, age, period, health_shock, ins_status, new_firm_index, work_exp
INTEGER ind_type1, ind_type2, ind_type3, ed_type1, ed_type2, health_type1, health_type2, health_type3, hi_type1, hi_type2, hi_type3
INTEGER ins_status1, firm_index1,work_exp1, med_pos_dummy
INTEGER med_care
INTEGER next_health 
integer i, j, k,m, t
integer, parameter:: constreg=1
real(dp):: stats(5)
integer max_exp 
REAL(DP) ind_subsidy, ind_tax, ins_cost, ind_subsidy1
REAL(DP) cons, oop, ii_p, util_flow(2), prob_health_next, income, med_shock, E_med_exp,E_med_exp_f, util_flow_ii(2), E_max_value_ii, E_health_next_ii, E_med_exp_ii , oop_ii
REAL(DP), parameter:: const=1.0d0
REAL(DP) next_value1, next_value2, next_value3, next_value4, next_value5, next_value6, next_value7, next_value8,value_next(2), E_max_value
REAL(DP) E_med_exp_m, E_max_value_m, cons_m, util_flow_m(2)
REAL(DP) v_hi_new, v_nhi_new, v_ehi_c, v_nhi_c, v_u_nhi, deduc_sub, coins_sub, cost_sub, E_uncomp

max_exp=num_exp
period=num_period

!$OMP PARALLEL NUM_THREADS(8) PRIVATE(E_uncomp, deduc_sub, coins_sub, cost_sub, firm_index, ins_status, health_type, ed_type, ind_type,income, ind_subsidy,  ins_cost, ind_subsidy1, ind_tax, next_health,next_value7, E_max_value, E_med_exp,E_med_exp_f,E_max_value_ii, E_med_exp_ii, health_shock,med_care,med_shock,value_next, med_pos_dummy,oop, oop_ii, cons, util_flow, util_flow_ii, prob_health_next   )
!$OMP DO
DO work_exp=1, period !emax_exp_e(i,num_period)
DO firm_index=1, num_firm !emax_firm_e(i,num_period)
DO ind_type=1, num_type !emax_ind_e(i,num_period)
DO ed_type=1, num_ed !emax_ed_e(i,num_period)
DO health_type=1, num_health !emax_health_e(i,num_period)
DO ins_status=1, 2 !emax_ins_e(i,num_period)




income=exp(alpha_w_1(ind_type)+alpha_w_1_ed(ed_type) &
       +(alpha_w_4(ind_type)+alpha_w_4_ed(ed_type))*(work_exp-1) &
       +(alpha_w_5(ind_type)+alpha_w_5_ed(ed_type))*((work_exp-1)**2.0)  )


income=income*(ins_status-1.0d0)*z_1(firm_index,ed_type) &
       +income*(2.0d0-ins_status)*z_0(firm_index,ed_type)                    

!!!! calculate cost-sharing susbsides !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
IF (income<=1.50*fpl_100 ) THEN
deduc_sub=deduc_ii
coins_sub=0.06d0
ELSE IF (income>1.50*fpl_100 .and. income<2.50*fpl_100) THEN
deduc_sub=(income-1.50*fpl_100)/fpl_100*deduc_ii
coins_sub=(income-1.50*fpl_100)/fpl_100*(coins_ii-0.06d0)+0.06d0
ELSE
deduc_sub=0.0d0
coins_sub=0.0d0
END IF       
       
       
       
       

!!!!!!!!!!!!!!! joint redesign of ESHI and HIX subsidies !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
IF (optimal_dummy==5) THEN
ind_subsidy=alpha_s_0+alpha_s_1*income+alpha_s_2*(income**2.0d0)+beta_s_1*period+beta_s_2*(period**2.0d0)
ind_subsidy=1.0d0/(1.0d0/exp(ind_subsidy)+1.0d0)*hie_premium(period)
!ind_tax=(1.0d0-ind_penalty_rate)*(income-tax_thres) 
!ind_tax=dmax1(ind_tax, ind_penalty)
ind_tax=im_p(1)+im_p(2)*income+im_p(3)*(income**2.0d0)+im_p(4)*period+im_p(5)*(period**2.0d0)
!ind_tax=dmin1(ind_tax, hie_premium(period))

income=income+sub_welfare

IF (ehi_tax_regime==1) THEN
IF (income>0) THEN
!income=income-(ltax0*(income-const*(income**(-ltax1)+ltax2)**(-1.0d0/ltax1)))
income=-ltax0/30000.0d0+(ltax1*(income*30000.0d0)**(ltax2+1.0d0)/(ltax2+1.0d0))/30000.0d0
END IF

ELSE IF (ehi_tax_regime==0) THEN
    IF (ins_status==1 ) THEN
    income=-ltax0/30000.0d0+(ltax1*(income*30000.0d0)**(ltax2+1.0d0)/(ltax2+1.0d0))/30000.0d0
    ! CASE OF TAX DEDUCTABILITY
        ELSE IF (ins_status==2) THEN
        ins_cost=ehi_premium(firm_index)
        ind_subsidy1=alpha_s_0_e+alpha_s_1_e*income+alpha_s_2_e*(income**2.0d0)+beta_s_1_e*period+beta_s_2_e*(period**2.0d0)
        ind_subsidy1=1.0d0/(1.0d0/exp(ind_subsidy1)+1.0d0)*ins_cost
        income=-ltax0/30000.0d0+(ltax1*((income+ins_cost)*30000.0d0)**(ltax2+1.0d0)/(ltax2+1.0d0))/30000.0d0-ins_cost
        income=income+ind_subsidy1+fixed_sub
            END IF
    END IF

END IF

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


E_med_exp=0.0d0
E_med_exp_f=0.0d0
E_max_value=0.0d0
E_med_exp_ii=0.0d0
E_max_value_ii=0.0d0

! The last period of E-max is merely function of health, type, education 
DO health_shock=1, num_health_shock



DO med_care=0,1

value_next(med_care+1)=0.0d0

med_shock=dmax1(exp(eta1_m(ind_type)+ alpha_m(health_type)+beta_m(health_type)*period+gamma_m(health_type)*(period**2.0d0)+eta2_m(ind_type)*sigma_m(health_type)*health_draw(health_shock))-kappa(health_type),0.0d0)
IF (med_shock>0.0d0) THEN
med_pos_dummy=1
ELSE
med_pos_dummy=0
END IF


IF (ins_status==2) THEN
    IF (med_shock<deduc) THEN
oop=med_care*med_shock 
    ELSE
        oop=med_care*(deduc+(med_shock-deduc)*coins)
    END IF
    cons=income-oop
util_flow(med_care+1)=-exp(-gamma(ind_type)*cons)/gamma(ind_type)-dmax1(period-age_dis,0.0d0)*eta-dmax1(period-age_dis,0.0d0)*eta_u*(health_type-1.0d0)-theta(health_type,ind_type)


ELSE 

oop=med_care*med_shock

IF (med_shock<=deduc_ii-deduc_sub) THEN
oop_ii=med_care*med_shock
ELSE
oop_ii=med_care*(deduc_ii-deduc_sub+(med_shock-deduc_ii-deduc_sub)*(coins_ii-coins_sub))
END IF




cons=income-oop_ii+ind_subsidy-hie_premium(period)

util_flow_ii(med_care+1)=-exp(-gamma(ind_type)*cons)/gamma(ind_type)-dmax1(period-age_dis,0.0d0)*eta-dmax1(period-age_dis,0.0d0)*eta_u*(health_type-1.0d0)-theta(health_type,ind_type)
cons=dmax1(income-oop-ind_tax,cons_floor)
util_flow(med_care+1)=-exp(-gamma(ind_type)*cons)/gamma(ind_type)-dmax1(period-age_dis,0.0d0)*eta-dmax1(period-age_dis,0.0d0)*eta_u*(health_type-1.0d0)-theta(health_type,ind_type)
END IF







! calculate the value from meeting
! NEXT PERIOD HEALTH
DO next_health=1, num_health


!calculate the probability that the next period health is next_health
prob_health_next=exp(alpha_1_k(next_health, health_type)+alpha_2_k(next_health, health_type)*med_care*med_pos_dummy+alpha_3_k(next_health, health_type)*med_shock &
+alpha_4_k(next_health, health_type)*period+alpha_5_k(next_health, ind_type)+alpha_6_k(next_health, health_type)*med_care*med_shock   ) &
/(exp(alpha_1_k(1, health_type)+alpha_2_k(1, health_type)*med_care*med_pos_dummy+alpha_3_k(1, health_type)*med_shock &
+alpha_4_k(1, health_type)*period+alpha_5_k(1, ind_type)+alpha_6_k(1, health_type)*med_care*med_shock ) &
+exp(alpha_1_k(2, health_type)+alpha_2_k(2, health_type)*med_care*med_pos_dummy+alpha_3_k(2, health_type)*med_shock &
+alpha_4_k(2, health_type)*period+alpha_5_k(2, ind_type)+alpha_6_k(2, health_type)*med_care*med_shock    ) )


!next_value7=term_type(ind_type)+term_ed(ed_type)+term_health(next_health)
next_value7=term_health(next_health)


value_next(med_care+1)=value_next(med_care+1)+beta*next_value7

END DO

END DO !medicare care

!evaluate maximum over medical care decision
IF (util_flow(1)+value_next(1)<=util_flow(2)+value_next(2)) THEN
E_max_value=E_max_value+util_flow(2)+value_next(2)
!E_max_value=E_max_value+util_flow(2)

IF (ins_status==2) THEN
    IF (med_shock<deduc) THEN
oop=med_care*med_shock 
    ELSE
        oop=med_care*(deduc+(med_shock-deduc)*coins)
    END IF
ELSE IF (ins_status==1) THEN
oop=med_care*med_shock
END IF

E_med_exp=E_med_exp+oop

E_med_exp_f=E_med_exp_f+(med_shock-oop)

E_uncomp=E_uncomp+dmin1(income-ind_tax-cons_floor, oop)

ELSE
E_max_value=E_max_value+util_flow(1)+value_next(1)

END IF

IF (ins_status==1) THEN !calculate utility for individual insurance holder

IF (util_flow_ii(2)+value_next(2)>=util_flow_ii(1)+value_next(1)) THEN
E_max_value_ii=E_max_value_ii+(util_flow_ii(2)+value_next(2))
 

IF (med_shock<=deduc_ii-deduc_sub) THEN
oop_ii=med_shock
cost_sub=0.0d0
ELSE
oop_ii=deduc_ii-deduc_sub+(med_shock-deduc_ii-deduc_sub)*(coins_ii-coins_sub)
cost_sub=deduc_sub+(med_shock-deduc_ii-deduc_sub)*coins_sub
END IF


E_med_exp_ii=E_med_exp_ii+med_shock-oop_ii !+cost_sub




ELSE IF (util_flow_ii(2)+value_next(2)<util_flow_ii(1)+value_next(1)) THEN
E_max_value_ii=E_max_value_ii+(util_flow_ii(1)+value_next(1))

END IF






END IF



!evaluate E-max

END DO ! health_shock


! Take average
IF (ins_status==1) THEN

choice_ii(ind_type, ed_type, health_type, firm_index, work_exp, period)=NORMCDF((E_max_value/num_health_shock-E_max_value_ii/num_health_shock)/pref_ii, 0.0d0, 1.0d0) 

choice_ii(ind_type, ed_type, health_type, firm_index, work_exp, period)=choice_ii(ind_type, ed_type, health_type, firm_index, work_exp, period) &
+(1.0d0-choice_ii(ind_type, ed_type, health_type, firm_index, work_exp, period))*reject(period)


E_max_value=choice_ii(ind_type, ed_type, health_type, firm_index, work_exp, period)*E_max_value &
+(1.0d0-choice_ii(ind_type, ed_type, health_type, firm_index, work_exp, period))*E_max_value_ii

E_med_exp=choice_ii(ind_type, ed_type, health_type, firm_index, work_exp, period)*E_med_exp &
+(1.0d0-choice_ii(ind_type, ed_type, health_type, firm_index, work_exp, period))*E_med_exp_ii

ex_med_ii(ind_type, ed_type, health_type, firm_index, work_exp, period)= E_med_exp_ii/num_health_shock

ex_uncomp(ind_type, ed_type, health_type, firm_index, work_exp, period)=E_uncomp/num_health_shock

END IF



value_emp(ind_type, ed_type, health_type, ins_status, firm_index, work_exp, num_period)=E_max_value/num_health_shock

ex_med(ind_type, ed_type, health_type, ins_status, firm_index, work_exp, num_period)=E_med_exp/num_health_shock

ex_med_f(ind_type, ed_type, health_type, ins_status, firm_index, work_exp, period)= &
E_med_exp_f/num_health_shock

END DO
END DO
END DO
END DO
END DO
END DO
!$OMP END DO
!$OMP END PARALLEL






!!!!!!!!!!!!!!!!!!!!!! Unemployment !!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!$OMP PARALLEL NUM_THREADS(8) PRIVATE(E_med_exp_m, E_max_value_m, cons_m, util_flow_m, health_type, ed_type, ind_type,income, next_health,next_value7,E_max_value, E_med_exp,E_max_value_ii, E_med_exp_ii,health_shock,med_care,med_shock,value_next, med_pos_dummy,oop, oop_ii, cons, util_flow, util_flow_ii, prob_health_next   )
!$OMP DO
DO work_exp=1, period !emax_exp_u(i,num_period)
DO ind_type=1, num_type !emax_ind_u(i,num_period)
DO ed_type=1, num_ed !emax_ed_u(i,num_period)
DO health_type=1, num_health !emax_health_u(i,num_period)


income=ump_flow

income=income+sub_welfare

E_max_value=0.0d0
E_max_value_ii=0.0d0
E_med_exp=0.0d0
E_med_exp_ii=0.0d0

E_max_value_m=0.0d0
E_med_exp_m=0.0d0

! HEALTH SPECIFIC SHOCK
DO health_shock=1, num_health_shock


! draw health shock
! MEDICAL CARE CHOICE
DO med_care=0,1

value_next(med_care+1)=0.0d0


!subtract insurance premium: ii
med_shock=dmax1(exp(eta1_m(ind_type)+ alpha_m(health_type)+beta_m(health_type)*period+gamma_m(health_type)*(period**2.0d0)+eta2_m(ind_type)*sigma_m(health_type)*health_draw(health_shock))-kappa(health_type),0.0d0)
IF (med_shock>0.0d0) THEN
med_pos_dummy=1
ELSE
med_pos_dummy=0
END IF



oop=med_care*med_shock


cons=dmax1(income,cons_floor)    

IF (Medicaid==0) THEN
IF (med_shock<=deduc_ii) THEN
oop_ii=med_care*med_shock
ELSE
oop_ii=med_care*(deduc_ii+(med_shock-deduc_ii)*coins_ii)
END IF

cons_m=income-oop_ii-hie_premium(period) 

END IF


util_flow_ii(med_care+1)=-exp(-gamma(ind_type)*cons)/gamma(ind_type)-theta(health_type,ind_type)
util_flow_m(med_care+1)=-exp(-gamma(ind_type)*cons_m)/gamma(ind_type)-theta(health_type,ind_type)


cons=dmax1(income-oop-ind_penalty,cons_floor)


util_flow(med_care+1)=-exp(-gamma(ind_type)*cons)/gamma(ind_type)-theta(health_type,ind_type)


! calculate the value from meeting
! NEXT PERIOD HEALTH
DO next_health=1, num_health
next_value7=0.0d0

!calculate the probability that the next period health is next_health
prob_health_next=exp(alpha_1_k(next_health, health_type)+alpha_2_k(next_health, health_type)*med_care*med_pos_dummy+alpha_3_k(next_health, health_type)*med_shock &
+alpha_4_k(next_health, health_type)*period+alpha_5_k(next_health, ind_type)+alpha_6_k(next_health, health_type)*med_care*med_shock   ) &
/(exp(alpha_1_k(1, health_type)+alpha_2_k(1, health_type)*med_care*med_pos_dummy+alpha_3_k(1, health_type)*med_shock &
+alpha_4_k(1, health_type)*period+alpha_5_k(1, ind_type)+alpha_6_k(1, health_type)*med_care*med_shock ) &
+exp(alpha_1_k(2, health_type)+alpha_2_k(2, health_type)*med_care*med_pos_dummy+alpha_3_k(2, health_type)*med_shock &
+alpha_4_k(2, health_type)*period+alpha_5_k(2, ind_type)+alpha_6_k(2, health_type)*med_care*med_shock    ) )






next_value7=term_health(next_health)

value_next(med_care+1)=value_next(med_care+1)+beta*next_value7

END DO ! HEALTH STATUS


END DO !medicare care


IF (util_flow(2)+value_next(2)>=util_flow(1)+value_next(1)) THEN
E_max_value=E_max_value+(util_flow(2)+value_next(2))

oop=med_care*med_shock 
E_med_exp=E_med_exp+oop

ELSE IF (util_flow(2)+value_next(2)<util_flow(1)+value_next(1)) THEN
E_max_value=E_max_value+(util_flow(1)+value_next(1))

END IF


IF (util_flow_ii(2)+value_next(2)>=util_flow_ii(1)+value_next(1)) THEN
E_max_value_ii=E_max_value_ii+(util_flow_ii(2)+value_next(2))
 
oop_ii=med_care*med_shock 

E_med_exp_ii=E_med_exp_ii+oop_ii



ELSE IF (util_flow_ii(2)+value_next(2)<util_flow_ii(1)+value_next(1)) THEN
E_max_value_ii=E_max_value_ii+(util_flow_ii(1)+value_next(1))
END IF


IF (util_flow_m(2)+value_next(2)>=util_flow_m(1)+value_next(1)) THEN
E_max_value_m=E_max_value_m+(util_flow_m(2)+value_next(2))
 

IF (med_shock<=deduc_ii) THEN
oop_ii=med_care*med_shock
ELSE
oop_ii=med_care*(deduc_ii+(med_shock-deduc_ii)*coins_ii)
END IF

E_med_exp_m=E_med_exp_m+oop_ii

ELSEIF (util_flow_m(2)+value_next(2)<util_flow_m(1)+value_next(1)) THEN
E_max_value_m=E_max_value_m+(util_flow_m(1)+value_next(1))


END IF




 

!evaluate E-max

END DO ! health_shock

IF (Medicaid==0) THEN
choice_ii_u(ind_type, ed_type, health_type, work_exp, period)=pr_Medicaid*NORMCDF((E_max_value/num_health_shock-E_max_value_ii/num_health_shock)/pref_ii, 0.0d0, 1.0d0) &
+(1.0d0-pr_Medicaid)*NORMCDF((E_max_value/num_health_shock-E_max_value_m/num_health_shock)/pref_ii, 0.0d0, 1.0d0)

choice_ii_u(ind_type, ed_type, health_type, work_exp, period)=choice_ii_u(ind_type, ed_type, health_type, work_exp, period) &
+(1.0d0-choice_ii_u(ind_type, ed_type, health_type, work_exp, period))*reject(period)

E_max_value=pr_Medicaid*NORMCDF((E_max_value/num_health_shock-E_max_value_ii/num_health_shock)/pref_ii, 0.0d0, 1.0d0)*E_max_value &
+(1.0d0-pr_Medicaid)*NORMCDF((E_max_value/num_health_shock-E_max_value_m/num_health_shock)/pref_ii, 0.0d0, 1.0d0)*E_max_value &
+pr_Medicaid*(1.0d0-NORMCDF((E_max_value/num_health_shock-E_max_value_ii/num_health_shock)/pref_ii, 0.0d0, 1.0d0))*E_max_value_ii &
+(1.0d0-pr_Medicaid)*(1.0d0-NORMCDF((E_max_value/num_health_shock-E_max_value_m/num_health_shock)/pref_ii, 0.0d0, 1.0d0))*E_max_value_m

E_med_exp=pr_Medicaid*NORMCDF((E_max_value/num_health_shock-E_max_value_ii/num_health_shock)/pref_ii, 0.0d0, 1.0d0)*E_med_exp &
+(1.0d0-pr_Medicaid)*NORMCDF((E_max_value/num_health_shock-E_max_value_m/num_health_shock)/pref_ii, 0.0d0, 1.0d0)*E_med_exp &
+pr_Medicaid*(1.0d0-NORMCDF((E_max_value/num_health_shock-E_max_value_ii/num_health_shock)/pref_ii, 0.0d0, 1.0d0))*E_med_exp_ii &
+(1.0d0-pr_Medicaid)*(1.0d0-NORMCDF((E_max_value/num_health_shock-E_max_value_m/num_health_shock)/pref_ii, 0.0d0, 1.0d0))*E_med_exp_m

choice_m_u(ind_type, ed_type, health_type, work_exp, period)=NORMCDF((E_max_value/num_health_shock-E_max_value_m/num_health_shock)/pref_ii, 0.0d0, 1.0d0)

ELSE




choice_ii_u(ind_type, ed_type, health_type, work_exp, period)=NORMCDF((E_max_value/num_health_shock-E_max_value_ii/num_health_shock)/pref_ii, 0.0d0, 1.0d0) 

choice_ii_u(ind_type, ed_type, health_type, work_exp, period)=choice_ii_u(ind_type, ed_type, health_type, work_exp, period) &
+(1.0d0-choice_ii_u(ind_type, ed_type, health_type, work_exp, period))*reject(period)




E_max_value=choice_ii_u(ind_type, ed_type, health_type, work_exp, period)*E_max_value &
+(1.0d0-choice_ii_u(ind_type, ed_type, health_type, work_exp, period))*E_max_value_ii

E_med_exp=choice_ii_u(ind_type, ed_type, health_type, work_exp, period)*E_med_exp &
+(1.0d0-choice_ii_u(ind_type, ed_type, health_type, work_exp, period))*E_med_exp_ii


END IF



ex_med_u(ind_type, ed_type, health_type, work_exp, period)=E_med_exp/num_health_shock
                                                                                                                                                
value_unemp(ind_type, ed_type, health_type, work_exp, period)=E_max_value/num_health_shock

ex_med_m_u(ind_type, ed_type, health_type, work_exp, period)=E_med_exp_m/num_health_shock


END DO
END DO
END DO
END DO
!$OMP END DO
!$OMP END PARALLEL

 
IF (data_mode==2) THEN 

OPEN(100, file="value_emp_last.txt")
 write(100, *) value_emp(1, 1, 1, 1, 5,20,num_period), value_emp(1, 1, 1, 2, 5,20,num_period)
CLOSE (100)

 
OPEN(100, file="value_unemp_age_1_last.txt") 
DO i=1, num_period
 write(100, *) value_unemp(1,1,2, i, period) 
END DO 
CLOSE (100) 


END IF







END SUBROUTINE