subroutine value_simulation
! obtain E-max value exept the last period




use params
use mod_dp
USE olsroutines
USE Emax_approximation
USE probability

implicit none

LOGICAL ISNAN

INTEGER ind_type, ed_type, health_type, hi_type, firm_index, hi_firm_index, age, period, health_shock, ins_status, new_firm_index
INTEGER med_care
INTEGER next_health, med_pos_dummy
INTEGER i, j, k, m,n, t
INTEGER ind_type1, ed_type1, health_type1, hi_type1, ind_type2, ed_type2, health_type2, hi_type2, ind_type3, ed_type3, health_type3, hi_type3
INTEGER work_exp
INTEGER ins_status1, firm_index1,work_exp1
REAL(DP) cons, oop, ii_p, util_flow(2), prob_health_next, income, E_health_next, util_flow_ii(2), E_max_value_ii, E_health_next_ii, E_med_exp_ii , oop_ii
REAL(DP) next_value1, next_value2, next_value3, next_value4, next_value5, next_value6, next_value7, next_value8, value_next(2), E_max_value

REAL(DP) v_hi_new, v_ii_new, v_nhi_new, v_ehi_c, v_nhi_c, v_ii_c, v_u_nhi, v_u_ii, v_ump, v_current, v_new, E_med_exp, E_med_exp_f
REAL(DP), parameter:: const=1.0d0
INTEGER exp_next, max_exp
integer, parameter:: constreg=1
real(dp):: stats(5)
REAL(DP) ex_transit, ex_transit1,ex_transit2, value_health(num_health), med_shock  
REAL(DP) ind_subsidy, ind_tax,  ins_cost, ind_subsidy1, deduc_sub, coins_sub, cost_sub     
     


DO period=num_period-1, 1, -1


! START FROM EMPLOYED
! STATE SPACE

!$OMP PARALLEL NUM_THREADS(8) PRIVATE(deduc_sub, coins_sub, cost_sub, ind_subsidy, ind_tax,  ins_cost, ind_subsidy1, work_exp, ins_status, health_type, ed_type, ind_type,income, exp_next,next_health,next_value7,v_current, v_ump,next_value1, new_firm_index, v_hi_new, v_nhi_new, next_value2,ex_transit1,next_value3, ex_transit2,v_new, ex_transit, next_value4, next_value5, next_value6,E_max_value, E_health_next, E_med_exp,E_med_exp_f,E_max_value_ii, E_health_next_ii, E_med_exp_ii, health_shock,med_care,med_shock,value_next, med_pos_dummy,oop, oop_ii, cons, util_flow, util_flow_ii, prob_health_next, value_health    )
!$OMP DO
! assign intiial type
DO firm_index=1, num_firm_sim
DO work_exp=1, period
DO ins_status=1, 2
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type

income=exp(alpha_w_1(ind_type)+alpha_w_1_ed(ed_type) &
       +(alpha_w_4(ind_type)+alpha_w_4_ed(ed_type))*(work_exp-1) &
       +(alpha_w_5(ind_type)+alpha_w_5_ed(ed_type))*((work_exp-1)**2.0)  )

       
income=income*(ins_status-1.0d0)*z_sim(firm_index) &
       +income*(2.0d0-ins_status)*z_sim(firm_index)                    

       
!!!! calculate cost-sharing susbsides !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
IF (income<=1.50*fpl_100 ) THEN
deduc_sub=deduc_ii
coins_sub=0.06d0
ELSE IF (income>1.50*fpl_100 .and. income<2.50*fpl_100) THEN
deduc_sub=(income-1.50*fpl_100)/fpl_100*deduc_ii
coins_sub=(income-1.50*fpl_100)/fpl_100*(coins_ii-0.06d0)+0.06d0
ELSE
deduc_sub=0.0d0
coins_sub=0.0d0
END IF       
       
       

!!!!!!!!!!!!!!! joint redesign of ESHI and HIX subsidies !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
IF (optimal_dummy==5) THEN
ind_subsidy=alpha_s_0+alpha_s_1*income+alpha_s_2*(income**2.0d0)+beta_s_1*period+beta_s_2*(period**2.0d0)
ind_subsidy=1.0d0/(1.0d0/exp(ind_subsidy)+1.0d0)*hie_premium(period)
!ind_tax=(1.0d0-ind_penalty_rate)*(income-tax_thres) 
!ind_tax=dmax1(ind_tax, ind_penalty)
ind_tax=im_p(1)+im_p(2)*income+im_p(3)*(income**2.0d0)+im_p(4)*period+im_p(5)*(period**2.0d0)
ind_tax=dmin1(ind_tax, hie_premium(period))

IF (ehi_tax_regime==1) THEN
IF (income>0) THEN
!income=income-(ltax0*(income-const*(income**(-ltax1)+ltax2)**(-1.0d0/ltax1)))
income=-ltax0/30000.0d0+(ltax1*(income*30000.0d0)**(ltax2+1.0d0)/(ltax2+1.0d0))/30000.0d0
END IF

ELSE IF (ehi_tax_regime==0) THEN
    IF (ins_status==1 ) THEN
    income=-ltax0/30000.0d0+(ltax1*(income*30000.0d0)**(ltax2+1.0d0)/(ltax2+1.0d0))/30000.0d0
    ! CASE OF TAX DEDUCTABILITY
        ELSE IF (ins_status==2) THEN
        ins_cost=ehi_premium(firm_index)
        ind_subsidy1=alpha_s_0_e+alpha_s_1_e*income+alpha_s_2_e*(income**2.0d0)+beta_s_1_e*period+beta_s_2_e*(period**2.0d0)
        ind_subsidy1=1.0d0/(1.0d0/exp(ind_subsidy1)+1.0d0)*ins_cost
        income=-ltax0/30000.0d0+(ltax1*((income+ins_cost)*30000.0d0)**(ltax2+1.0d0)/(ltax2+1.0d0))/30000.0d0-ins_cost
        income=income+ind_subsidy1+fixed_sub
            END IF
    END IF

END IF

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 

exp_next=min(work_exp+1,num_exp-1)


!calculate next period's choice specific value
DO next_health=1, num_health
next_value7=0.0d0


v_current=value_emp_sim(ind_type,ed_type,next_health,ins_status,firm_index,exp_next, period+1)

v_ump=value_unemp(ind_type,ed_type,next_health,exp_next, period+1)
!LAYOFF
next_value1=v_ump

next_value7=next_value7+delta(ed_type)*(1.0d0-lambda_e(ind_type,ed_type))*next_value1

! MEETING 
DO new_firm_index=1, num_firm  

! next_value 2 is MEETING WITHOUT LAYOFF and MEET job with HI


!use following variables for simplifying the notation

v_hi_new=value_emp(ind_type,ed_type,next_health,2,new_firm_index,exp_next, period+1)
v_nhi_new=value_emp(ind_type,ed_type,next_health,1,new_firm_index,exp_next, period+1)


! next_value 2 & 3 are MEETING WITHOUT LAYOFF 

next_value2=dmax1(v_hi_new, v_current)
IF (((-next_value2+v_ump)/pref_scale)>4.9d0 ) THEN
ex_transit1=0.0001d0
ELSE IF ((-next_value2+v_ump)/pref_scale<-4.9d0 ) THEN
ex_transit1=0.9999d0
ELSE
ex_transit1=NORMCDF((next_value2-v_ump)/pref_scale, 0.0d0, 1.0d0)      
END IF
next_value2=ex_transit1*next_value2+ (1.0d0-ex_transit1)*v_ump +pref_scale*NORMPDF((next_value2-v_ump)/pref_scale, 0.0d0, 1.0d0)


next_value3=dmax1(v_nhi_new, v_current)

IF (  (-next_value3+v_ump)/pref_scale>4.9d0 ) THEN
ex_transit2=0.0001d0
ELSE IF ( (-next_value3+v_ump)/pref_scale<-4.9d0 ) THEN
ex_transit2=0.9999d0
ELSE
ex_transit2= NORMCDF((next_value3-v_ump)/pref_scale, 0.0d0, 1.0d0)   
END IF

next_value3=ex_transit2*next_value3+ (1.0d0-ex_transit2)*v_ump +pref_scale*NORMPDF((next_value3-v_ump)/pref_scale, 0.0d0, 1.0d0)



v_new=ehi_offer(new_firm_index)*next_value2+(1.0d0-ehi_offer(new_firm_index))*next_value3
next_value7=next_value7+(1.0d0-delta(ed_type))*lambda_e(ind_type,ed_type)*prob_meet(new_firm_index)*v_new


! MEETING WITH LAYOFF

IF ( ((-v_hi_new+v_ump)/pref_scale)>4.9d0 ) THEN
ex_transit=0.0001d0
ELSE IF ((-v_hi_new+v_ump)/pref_scale<-4.9d0 ) THEN
ex_transit=0.9999d0
ELSE
ex_transit=NORMCDF((v_hi_new-v_ump)/pref_scale, 0.0d0, 1.0d0)   
END IF


next_value4=ex_transit*v_hi_new+ (1.0d0-ex_transit)*v_ump +pref_scale*NORMPDF((v_hi_new-v_ump)/pref_scale, 0.0d0, 1.0d0)

IF (((-v_nhi_new+v_ump)/pref_scale)>4.9d0 ) THEN
ex_transit=0.0001d0
ELSE IF ((-v_nhi_new+v_ump)/pref_scale<-4.9d0 ) THEN
ex_transit=0.9999d0
ELSE
ex_transit=NORMCDF((v_nhi_new-v_ump)/pref_scale, 0.0d0, 1.0d0)   
END IF

next_value5=ex_transit*v_nhi_new+ (1.0d0-ex_transit)*v_ump +pref_scale*NORMPDF((v_nhi_new-v_ump)/pref_scale, 0.0d0, 1.0d0)
 

v_new=ehi_offer(new_firm_index)*next_value4+(1.0d0-ehi_offer(new_firm_index))*next_value5

next_value7=next_value7+delta(ed_type)*lambda_e(ind_type,ed_type)*prob_meet(new_firm_index)*v_new

 
!sum up all utility
END DO !new_firm_index


! next value 6: STAY AT THE CURRENT JOB
IF (((-v_current+v_ump)/pref_scale)>4.9d0 ) THEN
ex_transit=0.0001d0
ELSE IF ((-v_current+v_ump)/pref_scale<-4.9d0 ) THEN
ex_transit=0.9999d0
ELSE
ex_transit=NORMCDF((v_current-v_ump)/pref_scale, 0.0d0, 1.0d0)   
END IF

next_value6=ex_transit*v_current+ (1.0d0-ex_transit)*v_ump +pref_scale*NORMPDF((v_current-v_ump)/pref_scale, 0.0d0, 1.0d0)

next_value7=next_value7+(1.0d0-delta(ed_type))*(1.0d0-lambda_e(ind_type,ed_type))*next_value6

value_health(next_health)=next_value7

END DO !next_health


!!!!!!!!!!!!!!!!!!  solve medical care decisions !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
E_max_value=0.0d0
E_health_next=0.0d0
E_med_exp=0.0d0
E_med_exp_f=0.0d0
E_max_value_ii=0.0d0
E_health_next_ii=0.0d0
E_med_exp_ii=0.0d0

DO health_shock=1, num_health_shock


DO med_care=0,1

value_next(med_care+1)=0.0d0

!income

med_shock=dmax1(exp(eta1_m(ind_type)+ alpha_m(health_type)+beta_m(health_type)*period+gamma_m(health_type)*(period**2.0d0)+eta2_m(ind_type)*sigma_m(health_type)*health_draw(health_shock))-kappa(health_type),0.0d0)
IF (med_shock>0.0d0) THEN
med_pos_dummy=1
ELSE
med_pos_dummy=0
END IF



IF (ins_status==2) THEN
    IF (med_shock<deduc) THEN
oop=med_care*med_shock 
    ELSE
        oop=med_care*(deduc+(med_shock-deduc)*coins)
    END IF
    cons=income-oop
util_flow(med_care+1)=-exp(-gamma(ind_type)*cons)/gamma(ind_type)-dmax1(period-age_dis,0.0d0)*eta-dmax1(period-age_dis,0.0d0)*eta_u*(health_type-1.0d0)-theta(health_type,ind_type)


ELSE 

oop=med_care*med_shock

IF (med_shock<=deduc_ii-deduc_sub) THEN
oop_ii=med_care*med_shock
ELSE
oop_ii=med_care*(deduc_ii-deduc_sub+(med_shock-deduc_ii-deduc_sub)*(coins_ii-coins_sub))
END IF





cons=income-oop_ii+ind_subsidy-hie_premium(period)

util_flow_ii(med_care+1)=-exp(-gamma(ind_type)*cons)/gamma(ind_type)-dmax1(period-age_dis,0.0d0)*eta-dmax1(period-age_dis,0.0d0)*eta_u*(health_type-1.0d0)-theta(health_type,ind_type)

cons=dmax1(income-oop-ind_tax,cons_floor)
util_flow(med_care+1)=-exp(-gamma(ind_type)*cons)/gamma(ind_type)-dmax1(period-age_dis,0.0d0)*eta-dmax1(period-age_dis,0.0d0)*eta_u*(health_type-1.0d0)-theta(health_type,ind_type)

END IF


! calculate the value from meeting


DO next_health=1, num_health
!calculate the probability that the next period health is next_health
prob_health_next=exp(alpha_1_k(next_health, health_type)+alpha_2_k(next_health, health_type)*med_care*med_pos_dummy+alpha_3_k(next_health, health_type)*med_shock &
+alpha_4_k(next_health, health_type)*period+alpha_5_k(next_health, ind_type)+alpha_6_k(next_health, health_type)*med_care*med_shock   ) &
/(exp(alpha_1_k(1, health_type)+alpha_2_k(1, health_type)*med_care*med_pos_dummy+alpha_3_k(1, health_type)*med_shock &
+alpha_4_k(1, health_type)*period+alpha_5_k(1, ind_type)+alpha_6_k(1, health_type)*med_care*med_shock ) &
+exp(alpha_1_k(2, health_type)+alpha_2_k(2, health_type)*med_care*med_pos_dummy+alpha_3_k(2, health_type)*med_shock &
+alpha_4_k(2, health_type)*period+alpha_5_k(2, ind_type)+alpha_6_k(2, health_type)*med_care*med_shock    ) )


! NEXT PERIOD EVENT

!multiply discount factor

value_next(med_care+1)=value_next(med_care+1)+value_health(next_health)*prob_health_next

END DO ! next_health

value_next(med_care+1)=beta*value_next(med_care+1)

END DO !medicare care

!evaluate maximum over medical care decision and expected health transition

IF (util_flow(2)+value_next(2)>=util_flow(1)+value_next(1)) THEN
E_max_value=E_max_value+(util_flow(2)+value_next(2))


IF (ins_status==2) THEN
    IF (med_shock<deduc) THEN
oop=med_care*med_shock 
    ELSE
        oop=med_care*(deduc+(med_shock-deduc)*coins)
    END IF
ELSE IF (ins_status==1) THEN
oop=med_care*med_shock
END IF

E_med_exp=E_med_exp+oop

E_med_exp_f=E_med_exp_f+(med_shock-oop)
    
    
ELSE 
E_max_value=E_max_value+(util_flow(1)+value_next(1))


END IF


IF (ins_status==1) THEN !calculate utility for individual insurance holder

IF (util_flow_ii(2)+value_next(2)>=util_flow_ii(1)+value_next(1)) THEN
E_max_value_ii=E_max_value_ii+(util_flow_ii(2)+value_next(2))
 


IF (med_shock<=deduc_ii-deduc_sub) THEN
oop_ii=med_shock
cost_sub=0.0d0
ELSE
oop_ii=deduc_ii-deduc_sub+(med_shock-deduc_ii-deduc_sub)*(coins_ii-coins_sub)
cost_sub=deduc_sub+(med_shock-deduc_ii-deduc_sub)*coins_sub
END IF


E_med_exp_ii=E_med_exp_ii+med_shock-oop_ii-cost_sub




ELSE 
E_max_value_ii=E_max_value_ii+(util_flow_ii(1)+value_next(1))



END IF






END IF




!evaluate expected health transition


END DO ! health_shock

IF (ins_status==1) THEN

choice_ii_sim(ind_type, ed_type, health_type, firm_index, work_exp, period)=NORMCDF((E_max_value/num_health_shock-E_max_value_ii/num_health_shock)/pref_ii, 0.0d0, 1.0d0) 

choice_ii_sim(ind_type, ed_type, health_type, firm_index, work_exp, period)=choice_ii_sim(ind_type, ed_type, health_type, firm_index, work_exp, period) &
+(1.0d0-choice_ii_sim(ind_type, ed_type, health_type, firm_index, work_exp, period))*reject(period)

E_max_value=choice_ii_sim(ind_type, ed_type, health_type,firm_index, work_exp, period)*E_max_value &
+(1.0d0-choice_ii_sim(ind_type, ed_type, health_type, firm_index, work_exp, period))*E_max_value_ii


E_med_exp=choice_ii_sim(ind_type, ed_type, health_type,firm_index,  work_exp, period)*E_med_exp &
+(1.0d0-choice_ii_sim(ind_type, ed_type, health_type,firm_index, work_exp, period))*E_med_exp_ii



END IF

 


value_emp_sim(ind_type, ed_type, health_type, ins_status, firm_index, work_exp, period)= &
E_max_value/num_health_shock


ex_med_sim(ind_type, ed_type, health_type, ins_status, firm_index, work_exp, period)= &
E_med_exp/num_health_shock

ex_med_sim_f(ind_type, ed_type, health_type, ins_status, firm_index, work_exp, period)= &
E_med_exp_f/num_health_shock

END DO
END DO
END DO
END DO
END DO
END DO
!$OMP END DO
!$OMP END PARALLEL

END DO



end subroutine value_simulation