module Emax_approximation

    
    
use params
use mod_dp

    contains
 
!! This subroutine was used for an interpolation method (Keane and Wolpin) in the early stage of this project.     
!real(dp) function Emax_e(bhat_e, ind_type,ed_type, health_type,ins_status, work_exp, firm_index)
!real(dp):: bhat_e(rank_reg_e)
!INTEGER:: ind_type,ed_type, health_type,ins_status,work_exp, firm_index
!INTEGER::  ind_type1, ind_type2, ind_type3, health_type1, health_type2, health_type3, ed_type1, ed_type2, hi_type1, hi_type2
!real(dp):: productivity 
!
!IF (ind_type==1) THEN
!ind_type1=1
!ELSE 
!ind_type1=0
!END IF
!IF (ind_type==2) THEN
!ind_type2=1
!ELSE 
!ind_type2=0
!END IF
!IF (ind_type==3) THEN
!ind_type3=1
!ELSE 
!ind_type3=0
!END IF
!IF (health_type==1) THEN
!health_type1=1
!ELSE 
!health_type1=0
!END IF
!IF (health_type==2) THEN
!health_type2=1
!ELSE 
!health_type2=0
!END IF
!IF (health_type==3) THEN
!health_type3=1
!ELSE 
!health_type3=0
!END IF
!IF (ed_type==1) THEN
!ed_type1=1
!ELSE 
!ed_type1=0
!END IF
!IF (ed_type==2) THEN
!ed_type2=1
!ELSE 
!ed_type2=0
!END IF
!IF (ins_status==1) THEN
!hi_type1=1
!ELSE 
!hi_type1=0
!END IF
!IF (ins_status==2) THEN
!hi_type2=1
!ELSE 
!hi_type2=0
!END IF
!
!productivity=z_1(firm_index,ed_type)*hi_type2+z_0(firm_index,ed_type)*hi_type1
!
!Emax_e=bhat_e(1)+bhat_e(2)*ind_type2+bhat_e(3)*ind_type2*productivity+bhat_e(4)*ind_type2*work_exp &
!+bhat_e(5)*health_type2+bhat_e(6)*health_type2*productivity+bhat_e(7)*health_type2*work_exp &
!+bhat_e(8)*hi_type2+bhat_e(9)*hi_type2*productivity+bhat_e(10)*hi_type2*work_exp+bhat_e(11)*hi_type2*productivity**2.0d0+bhat_e(12)*hi_type2*productivity**3.0d0 &
!+bhat_e(13)*ind_type2*health_type2+bhat_e(14)*ind_type2*health_type2*productivity+bhat_e(15)*ind_type2*health_type2*work_exp &
!+bhat_e(16)*ind_type2*hi_type2+bhat_e(17)*ind_type2*hi_type2*productivity+bhat_e(18)*ind_type2*hi_type2*work_exp &
!+bhat_e(19)*health_type2*hi_type2+bhat_e(20)*health_type2*hi_type2*productivity+bhat_e(21)*health_type2*hi_type2*work_exp  &
!+ bhat_e(22)*productivity+bhat_e(23)*productivity**2.0d0+bhat_e(24)*productivity**3.0d0 &
!+ bhat_e(25)*productivity**4.0d0   &
!+bhat_e(26)*work_exp+bhat_e(27)*work_exp**2.0d0+bhat_e(28)*work_exp**3.0d0 &
!+bhat_e(29)*work_exp**4.0d0 &
!+bhat_e(30)*ed_type2+bhat_e(31)*ed_type2*productivity+bhat_e(32)*ed_type2*work_exp &
!+bhat_e(33)*ed_type2*health_type2+bhat_e(34)*ed_type2*health_type2*productivity+bhat_e(35)*ed_type2*health_type2*work_exp &
!+bhat_e(36)*ed_type2*ind_type2+bhat_e(37)*ed_type2*ind_type2*productivity+bhat_e(38)*ed_type2*ind_type2*work_exp &
!+bhat_e(39)*ind_type2*hi_type2+bhat_e(40)*ind_type2*hi_type2*productivity+bhat_e(41)*ind_type2*hi_type2*work_exp 
!
!END function
!
!
!real(dp) function Emax_e_sim(bhat_e, ind_type,ed_type, health_type,ins_status, work_exp, firm_index)
!real(dp):: bhat_e(rank_reg_e)
!INTEGER:: ind_type,ed_type, health_type,ins_status,work_exp, firm_index
!INTEGER::  ind_type1, ind_type2, ind_type3, health_type1, health_type2, health_type3, ed_type1, ed_type2, hi_type1, hi_type2
!real(dp):: productivity 
!
!IF (ind_type==1) THEN
!ind_type1=1
!ELSE 
!ind_type1=0
!END IF
!IF (ind_type==2) THEN
!ind_type2=1
!ELSE 
!ind_type2=0
!END IF
!IF (ind_type==3) THEN
!ind_type3=1
!ELSE 
!ind_type3=0
!END IF
!IF (health_type==1) THEN
!health_type1=1
!ELSE 
!health_type1=0
!END IF
!IF (health_type==2) THEN
!health_type2=1
!ELSE 
!health_type2=0
!END IF
!IF (health_type==3) THEN
!health_type3=1
!ELSE 
!health_type3=0
!END IF
!IF (ed_type==1) THEN
!ed_type1=1
!ELSE 
!ed_type1=0
!END IF
!IF (ed_type==2) THEN
!ed_type2=1
!ELSE 
!ed_type2=0
!END IF
!IF (ins_status==1) THEN
!hi_type1=1
!ELSE 
!hi_type1=0
!END IF
!IF (ins_status==2) THEN
!hi_type2=1
!ELSE 
!hi_type2=0
!END IF
!
!productivity=z_sim(firm_index)
!
!Emax_e_sim=bhat_e(1)+bhat_e(2)*ind_type2+bhat_e(3)*ind_type2*productivity+bhat_e(4)*ind_type2*work_exp &
!+bhat_e(5)*health_type2+bhat_e(6)*health_type2*productivity+bhat_e(7)*health_type2*work_exp &
!+bhat_e(8)*hi_type2+bhat_e(9)*hi_type2*productivity+bhat_e(10)*hi_type2*work_exp+bhat_e(11)*hi_type2*productivity**2.0d0+bhat_e(12)*hi_type2*productivity**3.0d0 &
!+bhat_e(13)*ind_type2*health_type2+bhat_e(14)*ind_type2*health_type2*productivity+bhat_e(15)*ind_type2*health_type2*work_exp &
!+bhat_e(16)*ind_type2*hi_type2+bhat_e(17)*ind_type2*hi_type2*productivity+bhat_e(18)*ind_type2*hi_type2*work_exp &
!+bhat_e(19)*health_type2*hi_type2+bhat_e(20)*health_type2*hi_type2*productivity+bhat_e(21)*health_type2*hi_type2*work_exp  &
!+ bhat_e(22)*productivity+bhat_e(23)*productivity**2.0d0+bhat_e(24)*productivity**3.0d0 &
!+ bhat_e(25)*productivity**4.0d0   &
!+bhat_e(26)*work_exp+bhat_e(27)*work_exp**2.0d0+bhat_e(28)*work_exp**3.0d0 &
!+bhat_e(29)*work_exp**4.0d0  &
!+bhat_e(30)*ed_type2+bhat_e(31)*ed_type2*productivity+bhat_e(32)*ed_type2*work_exp &
!+bhat_e(33)*ed_type2*health_type2+bhat_e(34)*ed_type2*health_type2*productivity+bhat_e(35)*ed_type2*health_type2*work_exp &
!+bhat_e(36)*ed_type2*ind_type2+bhat_e(37)*ed_type2*ind_type2*productivity+bhat_e(38)*ed_type2*ind_type2*work_exp &
!+bhat_e(39)*ind_type2*hi_type2+bhat_e(40)*ind_type2*hi_type2*productivity+bhat_e(41)*ind_type2*hi_type2*work_exp 
!
!
!END function
!
!real(dp) function size_e_sim(bhat_e, firm_index)
!real(dp):: bhat_e(2)
!INTEGER:: ind_type,ed_type, health_type,ins_status,work_exp, firm_index
!INTEGER::  ind_type1, ind_type2, ind_type3, health_type1, health_type2, health_type3, ed_type1, ed_type2, hi_type1, hi_type2
!real(dp):: productivity 
!
!!size_e_sim=bhat_e(1)+bhat_e(2)*firm_index+bhat_e(3)*firm_index**2.0d0 !+bhat_e(4)*firm_index**3.0d0+bhat_e(5)*firm_index**4.0d0
!size_e_sim=bhat_e(1)+bhat_e(2)*firm_index**2.0d0
!
! 
!END function
!
! 
!
!
!real(dp) function Emax_u(bhat_u, ind_type,ed_type, health_type,work_exp)
!real(dp):: bhat_u(rank_reg_u)
!INTEGER:: ind_type,ed_type, health_type,ins_status,work_exp, firm_index
!INTEGER::  ind_type1, ind_type2, ind_type3, health_type1, health_type2, health_type3, ed_type1, ed_type2, hi_type1, hi_type2
!
!IF (ind_type==1) THEN
!ind_type1=1
!ELSE 
!ind_type1=0
!END IF
!IF (ind_type==2) THEN
!ind_type2=1
!ELSE 
!ind_type2=0
!END IF
!IF (ind_type==3) THEN
!ind_type3=1
!ELSE 
!ind_type3=0
!END IF
!IF (health_type==1) THEN
!health_type1=1
!ELSE 
!health_type1=0
!END IF
!IF (health_type==2) THEN
!health_type2=1
!ELSE 
!health_type2=0
!END IF
!IF (health_type==3) THEN
!health_type3=1
!ELSE 
!health_type3=0
!END IF
!IF (ed_type==1) THEN
!ed_type1=1
!ELSE 
!ed_type1=0
!END IF
!IF (ed_type==2) THEN
!ed_type2=1
!ELSE 
!ed_type2=0
!END IF
!IF (hi_type==1) THEN
!hi_type1=1
!ELSE 
!hi_type1=0
!END IF
!IF (hi_type==2) THEN
!hi_type2=1
!ELSE 
!hi_type2=0
!END IF
!
!
!Emax_u=bhat_u(1)+bhat_u(2)*ind_type2+bhat_u(3)*ind_type2*work_exp &
!+bhat_u(4)*health_type2+bhat_u(5)*health_type2*work_exp &
!+bhat_u(6)*health_type2*ind_type2+bhat_u(7)*health_type2*work_exp*ind_type2 &
!+bhat_u(8)*work_exp+bhat_u(9)*work_exp**2.0d0+bhat_u(10)*work_exp**3.0d0 &
!+bhat_u(11)*work_exp**4.0d0 &
!+bhat_u(12)*ed_type2+bhat_u(13)*ed_type2*work_exp &
!+bhat_u(14)*health_type2*ed_type2+bhat_u(15)*health_type2*work_exp*ed_type2 &
!+bhat_u(16)*ind_type2*ed_type2+bhat_u(17)*ind_type2*work_exp*ed_type2 
!
!END FUNCTION





END module