! This is the main program for SMM of Aizawa JMP using 2004 SIPP. 



program main

!******** IMSL ************
!**************************
 
 

use params
use mod_dp
use Nelder_Mead

implicit none

LOGICAL ISNAN

integer:: i,j,k,n,m,t, count !index
integer t1, t2, t_rate, t_max, diff, cluster
real(dp) criteria, weight, firm_mm
real(dp), parameter:: tol=0.001
INTEGER:: maxfn_umpl, param_number          
REAL(DP) stopcr, simp, func
REAL(DP), Allocatable:: var(:),firm_param(:)   
INTEGER:: nop, maxfn, iprint, nloop, iquad, nop1
INTEGER:: ifault

EXTERNAL ev_moments

!! HOPSPACK
CHARACTER 	:: inarg*100,outarg*100,tag1*100,tt
REAL(dp)	:: argc
REAL(dp)	:: hp_objective_value
!start counting the time
!call system_clock(t1)




num_param_est=59
ALLOCATE (param_est(num_param_est), var_est(num_param_est), step_est(num_param_est))

DO i=1, num_param_est
step_est(i)=0.10
END DO

maxfn=100000
iprint=1 
nloop=num_param_est+5
iquad=1
stopcr=0.01 
simp = 0.01


cluster=1
omp_mode=1
ehi_tax_regime=1
!!!!!!!!!!!!!!!!!!!! FOR HOPSPACK !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!********************************************
!! 1. This is the HOPSPACK instruction. Read the data from HOPSPACK

IF (cluster==2) THEN
argc=IARGC()
CALL getarg(1,inarg)
CALL getarg(2,outarg)
CALL getarg(3,tag1)
OPEN(unit=11, file=inarg)
READ(11,*)
READ(11,*)
DO j=1, num_param_est
  READ(11,*) param_est(j)
END DO
CLOSE(11)

END IF

! read the parameter
call reading

IF (cluster==2) THEN
call param_read
END IF




! update parameter
IF (cluster .ne. 2) THEN
!OPEN(1,file="parameter_value.txt")
OPEN(1,file="parameter_value_initial.txt")
READ(1,fmt=*) 	prob_type1(1)
READ(1,fmt=*) 	prob_type1(2)
READ(1,fmt=*) 	gamma(1)
READ(1,fmt=*) 	gamma(2)
READ(1,fmt=*) 	theta(2,1)
READ(1,fmt=*) 	theta(2,2)
READ(1,fmt=*) 	eta
READ(1,fmt=*) 	ump_flow
READ(1,fmt=*) 	alpha_m(1)
READ(1,fmt=*) 	alpha_m(2)
READ(1,fmt=*) 	beta_m(1)
READ(1,fmt=*) 	gamma_m(1)
READ(1,fmt=*) 	sigma_m(1)
READ(1,fmt=*) 	kappa(1)
READ(1,fmt=*) 	sigma_prod
READ(1,fmt=*) 	delta(1)
READ(1,fmt=*) 	lambda_u(1,1)
READ(1,fmt=*) 	lambda_e(1,1)
READ(1,fmt=*) 	delta(2)
READ(1,fmt=*) 	lambda_u(1,2)
READ(1,fmt=*) 	lambda_e(1,2)
READ(1,fmt=*) 	alpha_w_1(1)
READ(1,fmt=*) 	alpha_w_1_ed(1)
READ(1,fmt=*) 	alpha_w_1_ed(2)
READ(1,fmt=*) 	alpha_w_4(1)
READ(1,fmt=*) 	alpha_w_4_ed(1)
READ(1,fmt=*) 	alpha_w_4_ed(2)
READ(1,fmt=*) 	alpha_w_5(1)
READ(1,fmt=*) 	alpha_w_5_ed(1)
READ(1,fmt=*) 	alpha_w_5_ed(2)
READ(1,fmt=*) 	alpha_1_k(1,1)
READ(1,fmt=*) 	alpha_1_k(2,2)
READ(1,fmt=*) 	alpha_2_k(2,1)
READ(1,fmt=*) 	alpha_3_k(2,1)
READ(1,fmt=*) 	alpha_4_k(2,1)
READ(1,fmt=*) 	alpha_5_k(2,2)
READ(1,fmt=*) 	alpha_6_k(2,1)
READ(1,fmt=*) 	alpha_2_k(2,2)
READ(1,fmt=*) 	alpha_3_k(2,2)
READ(1,fmt=*) 	alpha_4_k(2,2)
READ(1,fmt=*) 	alpha_6_k(2,2)
READ(1,fmt=*) 	term_health(2)
READ(1,fmt=*) 	loading_ehi
READ(1,fmt=*) 	worker_size1
READ(1,fmt=*) 	scale_prof
READ(1,fmt=*) 	eta_u
READ(1,fmt=*) 	pref_scale
READ(1,fmt=*) 	alpha_w_6(2)
READ(1,fmt=*) 	beta_m(2)
READ(1,fmt=*) 	gamma_m(2)
READ(1,fmt=*) 	kappa(2)
READ(1,fmt=*) 	sigma_m(2)
READ(1,fmt=*) 	sigma_wage_error
READ(1,fmt=*) 	lambda_e(2,1)
READ(1,fmt=*) 	lambda_e(2,2)
READ(1,fmt=*) 	lambda_u(2,1)
READ(1,fmt=*) 	lambda_u(2,2)
READ(1,fmt=*) 	cons_floor
READ(1,fmt=*) 	pref_ii
CLOSE(1)
END IF


OPEN(100, file="parameter_input.txt")
 write(100, *) 	prob_type1(1)
 write(100, *) 	prob_type1(2)
 write(100, *) 	gamma(1)
 write(100, *) 	gamma(2)
 write(100, *) 	theta(2,1)
 write(100, *) 	theta(2,2)
 write(100, *) 	eta
 write(100, *) 	ump_flow
 write(100, *) 	 alpha_m(1)
 write(100, *) 	 alpha_m(2)
 write(100, *) 	 beta_m(1)
 write(100, *) 	gamma_m(1)
 write(100, *) 	sigma_m(1)
 write(100, *) 	kappa(1)
 write(100, *) 	sigma_prod
 write(100, *) 	 delta(1)
 write(100, *) 	 lambda_u(1,1)
 write(100, *) 	 lambda_e(1,1)
 write(100, *) 	 delta(2)
 write(100, *) 	 lambda_u(1,2)
 write(100, *) 	 lambda_e(1,2)
 write(100, *) 	 alpha_w_1(1) 
 write(100, *) 	 alpha_w_1_ed(1)
 write(100, *) 	 alpha_w_1_ed(2)
 write(100, *) 	 alpha_w_4(1)
 write(100, *) 	 alpha_w_4_ed(1)
 write(100, *) 	 alpha_w_4_ed(2)
 write(100, *) 	 alpha_w_5(1)
 write(100, *) 	 alpha_w_5_ed(1)
 write(100, *) 	 alpha_w_5_ed(2)
 write(100, *) 	 alpha_1_k(1,1)
 write(100, *) 	alpha_1_k(2,2)
 write(100, *) 	alpha_2_k(2,1)
 write(100, *) 	alpha_3_k(2,1)
 write(100, *) 	alpha_4_k(2,1)
 write(100, *) 	alpha_5_k(2,2)
 write(100, *) 	alpha_6_k(2,1)
 write(100, *) 	alpha_2_k(2,2)
 write(100, *) 	alpha_3_k(2,2)
 write(100, *) 	alpha_4_k(2,2)
 write(100, *) 	alpha_6_k(2,2)
 write(100, *) 	term_health(2)
 write(100, *) 	loading_ehi
 write(100, *) 	worker_size1
 write(100, *) 	scale_prof
 write(100, *) 	eta_u
 write(100, *) 	pref_scale
 write(100, *) 	 alpha_w_6(2)
 write(100, *) 	 beta_m(2)
 write(100, *) 	gamma_m(2)
 write(100, *) 	kappa(2)
 write(100, *) 	sigma_m(2)
write(100, *) 	sigma_wage_error
write(100, *) 	lambda_e(2,1)
write(100, *) 	lambda_e(2,2)
write(100, *) 	lambda_u(2,1)
write(100, *) 	lambda_u(2,2)
write(100, *) 	cons_floor
write(100, *) 	pref_ii

CLOSE (100)
 
 

  
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 


DO i=1, num_period
DO j=1, num_health
IF (j==2) THEN
p_ii(i,j)=0.089+(18+i/3)*0.00015
ELSE
p_ii(i,j)=0.069+(18+i/3)*(-0.00005)
END IF
!p_ii(i,j)=-0.00d0 !p_ii(i,j)*0.10d0
!p_ii(i,j)=p_ii(i,j)*0.1d0
END DO
END DO


DO i=1, num_period
reject(i)=0.093+0.0050*i/3.0d0
!reject(i)=0.0d0
END DO

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!



eta1_m(1)=0.00d0
eta1_m(2)=0.00d0
eta2_m(1)=1.00d0 
eta2_m(2)=1.00d0
data_mode=1 



num_moment1=36
num_moment2=3
num_moment3=7
num_moment4=12

moment_vector=num_moment1*5*2+num_moment2*2+num_moment4*3+num_moment3

allocate(w_firm_mat(num_moment3), mat_weight(num_moment1*5*2+num_moment2*2+num_moment4*3+num_moment3,num_moment1*5*2+num_moment2*2+num_moment4*3+num_moment3), residual_mat(num_moment1*5*2+num_moment2*2+num_moment4*3+num_moment3,num_moment1*5*2+num_moment2*2+num_moment4*3+num_moment3))

ALLOCATE(residual_mat_1(moment_vector, moment_vector), residual_mat_2(moment_vector, moment_vector))
ALLOCATE(residual_mat_3(num_param_est, moment_vector), residual_mat_4(num_param_est, num_param_est))
ALLOCATE(Hessian_inv_all(num_param_est, num_param_est))

ALLOCATE(ind_moments(sample_size,num_data_period_1,num_moment1,5,2), ind_moments1(sample_size,num_data_period_1,num_moment2, 2), ind_moments3(sample_size_meps,num_moment4,3), firm_moment_value(sample_size_firm,num_moment3))
ALLOCATE(ind_a_moments(sample_size,num_data_period_1,num_moment1*5*2 ), ind_a_moments1(sample_size,num_data_period_1, num_moment1*5*2+num_moment2*2), ind_a_moments3(sample_size_meps,num_moment1*5*2+num_moment2*2+num_moment4*3))
ALLOCATE(Sens_mat(num_param_est, moment_vector))

! parameters to assign
! call read_param






CALL READ_DATA
call draw_rn
! call param_reverse

!call solve_eq


OPEN(1, file="parameter_value_initial.txt")
DO n=1, num_param_est
READ(1,fmt=*) 	 param_est(n)
END DO
CLOSE (100)

cons_mode=0

!! evaluate the objective value !!
CALL ev_moments(param_est, func)


! Nelder_Mead
! call minim(param_est, step_est, num_param_est, func, maxfn, iprint, stopcr, nloop, iquad, simp, var_est, ev_moments, ifault)

!call welfare

!! calculate standard error
! call std_error
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


! print*, hp_objective_value
 


! 8. To finish, report to HOPSPACK
IF (cluster==2) THEN
hp_objective_value=func
    hp_objective_value=-hp_objective_value
    OPEN(unit=21, FILE=outarg)
WRITE(21,*)  1
  WRITE(21,*)  hp_objective_value
CLOSE(21)
END IF


  
end program