SUBROUTINE param_read

use params
use mod_dp

	!ALLOCATE ARRAYS
 
prob_type1(1)=param_est(1) !type 1 prob. for high educated
prob_type1(2)=param_est(2) !type 1 prob. for low educated
gamma(1)=param_est(3)	!-CARA high educated
gamma(2)=param_est(4)	!-CARA low educated
theta(2,1)=param_est(5)    !  -disutlity from bad health
theta(2,2)=param_est(6)    !  -disutlity from bad health
eta=param_est(7)  !, 	-disutility from labor
ump_flow=param_est(8) !, -disutility from working
 alpha_m(1)=param_est(9) !, 	-the coeff. in med_need shock: good health
 alpha_m(2)=param_est(10) !, 	-the coeff. in med_need shock: bad health
 beta_m(1)=param_est(11) !, 	-the coeff. in med_need shock 
gamma_m(1)=param_est(12)  !, 	-the coeff. in med_need shock 
sigma_m(1)=param_est(13)	 !-std. dev for medical needs shock
kappa(1)=param_est(14)	 !the medical expenditure shifter
sigma_prod=param_est(15) !std of prodctuvitiy dist.
 delta(1)=param_est(16) !, & 	-layoff probability (Kaplan, 20 year experience)
 lambda_u(1,1)=param_est(17)	!	arrival rate of job offer to unemployed
 lambda_e(1,1)=param_est(18)	!	arrival rate of job offer to employed
 delta(2)=param_est(19) !, & 	-layoff probability (Kaplan, 20 year experience)
 lambda_u(1,2)=param_est(20)	!	arrival rate of job offer to unemployed
 lambda_e(1,2)=param_est(21)	!	arrival rate of job offer to employed
 alpha_w_1(1)=param_est(22) ! 	-coeff. in const. term wage equation for type 1
 alpha_w_1_ed(1)=param_est(23) ! 	-coeff. in const. term wage equation for high skilled
 alpha_w_1_ed(2)=param_est(24) ! 	-coeff. in const. term wage equation for low skilled 
 alpha_w_4(1)=param_est(25) ! 	-coeff. in exp term wage equation for type 1
 alpha_w_4_ed(1)=param_est(26) ! 	-coeff. in exp term wage equation for high skilled
 alpha_w_4_ed(2)=param_est(27) ! 	-coeff. in exp term wage equation for low skilled
 alpha_w_5(1)=param_est(28) ! 	-coeff. in exp**2 term wage equation for type 1
 alpha_w_5_ed(1)=param_est(29) ! 	-coeff. in exp**2 term wage equation for high skilled
 alpha_w_5_ed(2)=param_est(30) ! 	-coeff. in exp**2 term wage equation for low skilled
 alpha_1_k(1,1)=param_est(31)  ! the coeff in health transition where current health is 1 and tomorrow is 1
alpha_1_k(2,2)=param_est(32)  ! the coeff in health transition where current health is 2 and tomorrow is 2
alpha_2_k(2,1)=param_est(33)  ! the coeff in health transition: medical care dummy
alpha_3_k(2,1)=param_est(34)  ! the coeff in health transition: idiosyncratic shock
alpha_4_k(2,1)=param_est(35)  ! the coeff in health transition: age
alpha_5_k(2,2)=param_est(36)  ! the coeff in health transition to next period unhealthy: type=1
alpha_6_k(2,1)=param_est(37)    !interaction between exp and shock 
alpha_2_k(2,2)=param_est(38)  ! the coeff in health transition: medical care dummy
alpha_3_k(2,2)=param_est(39)  ! the coeff in health transition: idiosyncratic shock
alpha_4_k(2,2)=param_est(40)  ! the coeff in health transition: age
alpha_6_k(2,2)=param_est(41)    !interaction between exp and shock 
term_health(2)=param_est(42)   !terminal value for unhealthy
loading_ehi=param_est(43)   ! loading factor for EHI
worker_size1=param_est(44) !worker size
scale_prof=param_est(45)  !scale param_esteter for choice specific shocks.
eta_u=param_est(46)  !, 	-disutility from labor
pref_scale=param_est(47)  !, 	-disutility from labor
alpha_w_6(2)=param_est(48) ! 	productivity effect of bad health
beta_m(2)=param_est(49)
gamma_m(2)=param_est(50)
kappa(2)=param_est(51)
sigma_m(2)=param_est(52)	 !-std. dev for medical needs shock
sigma_wage_error=param_est(53)
lambda_e(2,1)=param_est(54)
lambda_e(2,2)=param_est(55)
lambda_u(2,1)=param_est(56)
lambda_u(2,2)=param_est(57)
cons_floor=param_est(58)
pref_ii=param_est(59)


OPEN(100, file="parameter_value_update.txt")
DO n=1, num_param_est
 write(100, *) param_est(n)
END DO
CLOSE (100)

END SUBROUTINE