SUBROUTINE save_result

use params
use mod_dp
implicit none
LOGICAL ISNAN

REAL(DP) utility(2), income, ii_p, oop, denom, num_sim_ed(2), productivity, count_med(num_health, num_period, num_ed), med_shock
INTEGER i,j, n,m, k, t, x, y, ind_type, ed_type, health_type, hi_type, firm_index, health_shock, period, new_firm_index, med_care, next_health, work_exp
INTEGER band, ins_status
REAL(DP) health_hi_sim_denom(num_ed), health_nhi_sim_denom(num_ed), health_unemp_sim_denom(num_ed), quality1(5,2), quality2(5,2)
REAL(DP)	cohot_size(5, num_ed)
REAL(DP)	emp_denom(5, num_ed)
REAL(DP)	ue_hi_c_denom(5, num_ed)
REAL(DP)	ue_nhi_c_denom(5, num_ed)
REAL(DP)	wage_average_hi_c_denom(5, num_ed)
REAL(DP)	wage_average_nhi_c_denom(5, num_ed)
REAL(DP)	wage_average_ii_c_denom(5, num_ed)
REAL(DP)	wage_stay_hi_c_denom(5, num_ed)
REAL(DP)	wage_stay_nhi_c_denom(5, num_ed)
REAL(DP)	wage_jj_hihi_c_denom(5, num_ed)
REAL(DP)	wage_jj_nhihi_c_denom(5, num_ed)
REAL(DP)	wage_jj_hinhi_c_denom(5, num_ed)
REAL(DP)	wage_jj_nhinhi_c_denom(5, num_ed)
REAL(DP)	wage_ue_hi_c_denom(5, num_ed)
REAL(DP)	wage_ue_nhi_c_denom(5, num_ed)
REAL(DP)	health_transit_hh_c_denom(5, num_ed), health_transit_h_count_c(5, num_ed)
REAL(DP)	health_transit_uu_c_denom(5, num_ed), health_transit_u_count_c(5, num_ed)
REAL(DP)    count_med_c(2, 3, num_ed), count_sim_h_hi_c(3,2,2,2)
REAl(DP)    takeup_c(5, num_ed), health_ii_sim(num_ed), health_ii_sim_denom(num_ed), health_unins_sim(num_ed),health_unins_sim_denom(num_ed)  
DO n=1, 2
num_sim_ed(n)=0.0d0
DO i=1, num_sim
IF (ed_sim(i)==n) THEN	 
num_sim_ed(n)=num_sim_ed(n)+1.0d0
END IF
END DO
END DO

! simulate other statistics
DO t=1, num_period

DO n=1, 2
emp_uninsured(t,n)=0.0d0
emp_rate(t,n)=0.0d0
emp_hi_healthy(t,n)=0.0d0
emp_nhi_healthy(t,n)=0.0d0
unemp_healthy(t,n)=0.0d0
emp_rate(t,n)=0.0d0
emp_hinsured(t,n)=0.0d0
emp_iinsured(t,n)=0.0d0
med_care_sim_hi(1,t,n)=0.0d0
med_care_sim_hi(2,t,n)=0.0d0
unemp_iinsured(t,n)=0.0d0
    DO i=1, num_sim
    IF (ed_sim(i)==n) THEN
        IF (emp_sim(i,t)==1 .and. (hi_sim(i,t)==1 .and. ii_sim(i,t)==0) ) THEN
            emp_uninsured(t,n)=emp_uninsured(t,n)+1.0d0
        ELSE IF (emp_sim(i,t)==1 .and. hi_sim(i,t)==2) THEN
            emp_hinsured(t,n)=emp_hinsured(t,n)+1.0d0
        ELSE IF (emp_sim(i,t)==1 .and. (hi_sim(i,t)==1 .and. ii_sim(i,t)==1) ) THEN
            emp_iinsured(t,n)=emp_iinsured(t,n)+1.0d0
        END IF
        IF (emp_sim(i,t)==1) THEN
            emp_rate(t,n)=emp_rate(t,n)+1.0d0
            
        END IF
        IF (emp_sim(i,t)==0 .and. ii_sim(i,t)==1) THEN
            unemp_iinsured(t,n)=unemp_iinsured(t,n)+1.0d0
            
        END IF
        IF (emp_sim(i,t)==1 .and. med_care_sim(i,t)==1 .and. (hi_sim(i,t)==1 .and. ii_sim(i,t)==0)  ) THEN
            med_care_sim_hi(1,t,n)=med_care_sim_hi(1,t,n)+1.0d0
        ELSE IF (emp_sim(i,t)==1 .and. med_care_sim(i,t)==1 .and. (hi_sim(i,t)==2 .or. (hi_sim(i,t)==1 .and. ii_sim(i,t)==1) ) ) THEN
            med_care_sim_hi(2,t,n)=med_care_sim_hi(2,t,n)+1.0d0
        END IF
        IF (emp_sim(i,t)==1 .and. hi_sim(i,t)==2 .and. health_sim(i,t)==1 ) THEN
            emp_hi_healthy(t,n)=emp_hi_healthy(t,n)+1.0d0
        ELSE IF (emp_sim(i,t)==1 .and. hi_sim(i,t)==1   .and. health_sim(i,t)==1 ) THEN
            emp_nhi_healthy(t,n)=emp_nhi_healthy(t,n)+1.0d0  
        ELSE IF  (emp_sim(i,t)==0 .and. health_sim(i,t)==1 ) THEN
            unemp_healthy(t,n)=unemp_healthy(t,n)+1.0d0
        END IF      
    END IF
    END DO
        emp_hi_healthy(t,n)=emp_hi_healthy(t,n)/emp_hinsured(t,n)
        emp_nhi_healthy(t,n)=emp_nhi_healthy(t,n)/(emp_uninsured(t,n)+emp_iinsured(t,n))
        unemp_healthy(t,n)=unemp_healthy(t,n)/(num_sim_ed(n)-emp_rate(t,n))
        med_care_sim_hi(1,t,n)=med_care_sim_hi(1,t,n)/emp_uninsured(t,n)
        med_care_sim_hi(2,t,n)=med_care_sim_hi(2,t,n)/(emp_hinsured(t,n)+emp_iinsured(t,n))


END DO
END DO



! simulate productivity
denom=0.0d0
productivity=0.0d0
DO t=1, num_period
DO i=1, num_sim
IF (emp_sim(i, t)==1) THEN 
denom=denom+1.0d0     
productivity=productivity+wage_sim(i, t)
END IF
END DO !i
END DO !t
productivity=productivity/denom
! simulate statistics
DO t=1, num_period
 
emp_hinsured_s(t,1)=0.0d0
emp_hinsured_s(t,2)=0.0d0
emp_rate_s(t,1)=0.0d0
emp_rate_s(t,2)=0.0d0
firm_s(t,1)=0.0d0
firm_s(t,2)=0.0d0

    DO i=1, num_sim/2
        IF (emp_sim(i,t)==1 .and. hi_sim(i,t)==2) THEN
            emp_hinsured_s(t,1)=emp_hinsured_s(t,1)+1
            firm_s(t,1)=firm_s(t,1)+firm_sim(i,t)
        END IF
        IF (emp_sim(i,t)==1) THEN
            emp_rate_s(t,1)=emp_rate_s(t,1)+1.0d0
        END IF
    END DO
        emp_hinsured_s(t,1)=emp_hinsured_s(t,1)/emp_rate_s(t,1)
        firm_s(t,1)=firm_s(t,1)/emp_rate_s(t,1)
    DO i=num_sim/2+1, num_sim
        IF (emp_sim(i,t)==1 .and. hi_sim(i,t)==2) THEN
            emp_hinsured_s(t,2)=emp_hinsured_s(t,2)+1
            firm_s(t,2)=firm_s(t,2)+firm_sim(i,t)
        END IF
        IF (emp_sim(i,t)==1) THEN
            emp_rate_s(t,2)=emp_rate_s(t,2)+1.0d0
        END IF
    END DO
        emp_hinsured_s(t,2)=emp_hinsured_s(t,2)/emp_rate_s(t,2)
        firm_s(t,2)=firm_s(t,2)/emp_rate_s(t,2)


END DO


DO n=1, 2



! transition and wage mobility data
DO t=1, num_period-1



ump_rate(t,n)=0.0d0
ue_hi(t,n)=0.0d0
ue_nhi(t,n)=0.0d0
jj_hihi(t,n)=0.0d0
jj_hinhi(t,n)=0.0d0
jj_nhinhi(t,n)=0.0d0
jj_nhihi(t,n)=0.0d0
jj_rate(t,n)=0.0d0
eu(t,n)=0.0d0
wage_ue_hi(t,n)=0.0d0
wage_ue_nhi(t,n)=0.0d0
wage_average(t,n)=0.0d0
wage_average_hi(t,n)=0.0d0
wage_average_nhi(t,n)=0.0d0
wage_average_ii(t,n)=0.0d0
wage_stay_hi(t,n)=0.0d0
wage_stay_nhi(t,n)=0.0d0
wage_stay_hi_count(t,n)=0.0d0
wage_stay_nhi_count(t,n)=0.0d0
wage_jj_hihi(t,n)=0.0d0
wage_jj_hinhi(t,n)=0.0d0
wage_jj_nhinhi(t,n)=0.0d0
wage_jj_nhihi(t,n)=0.0d0
std_wage_ue_hi(t,n)=0.0d0
std_wage_ue_nhi(t,n)=0.0d0
std_wage_average(t,n)=0.0d0
std_wage_average_hi(t,n)=0.0d0
std_wage_average_nhi(t,n)=0.0d0
std_wage_average_ii(t,n)=0.0d0
std_wage_stay_hi(t,n)=0.0d0
std_wage_stay_nhi(t,n)=0.0d0
std_wage_jj_hihi(t,n)=0.0d0
std_wage_jj_hinhi(t,n)=0.0d0
std_wage_jj_nhihi(t,n)=0.0d0
std_wage_jj_nhinhi(t,n)=0.0d0



DO i=1, num_sim
    
IF (ed_sim(i)==n) THEN	   
	
    IF (emp_sim(i,t)==0) THEN
        ump_rate(t,n)=ump_rate(t,n)+1.0d0
    END IF    
    IF (emp_sim(i,t)==1) THEN
        wage_average(t,n)=wage_average(t,n)+wage_sim(i,t)
    END IF
    IF (emp_sim(i,t)==1 .and. hi_sim(i,t)==2) THEN
        wage_average_hi(t,n)=wage_average_hi(t,n)+wage_sim(i,t)
    END IF
    IF (emp_sim(i,t)==1 .and. (hi_sim(i,t)==1 .and. ii_sim(i,t)==0) ) THEN
        wage_average_nhi(t,n)=wage_average_nhi(t,n)+wage_sim(i,t)
    END IF
    IF (emp_sim(i,t)==1 .and. (hi_sim(i,t)==1 .and. ii_sim(i,t)==1) ) THEN
        wage_average_ii(t,n)=wage_average_ii(t,n)+wage_sim(i,t)
        !print*, ed_sim(i), firm_sim(i,t), t
    END IF
    IF (emp_sim(i,t)==1 .and. emp_sim(i,t+1)==1 .and. hi_sim(i,t)==2 .and. firm_sim(i,t)==firm_sim(i,t+1) ) THEN
        wage_stay_hi(t,n)=wage_stay_hi(t,n)+wage_sim(i,t+1)-wage_sim(i,t)
        wage_stay_hi_count(t,n)=wage_stay_hi_count(t,n)+1.0d0
    ELSE IF (emp_sim(i,t)==1 .and. emp_sim(i,t+1)==1 .and. hi_sim(i,t)==1 .and. firm_sim(i,t)==firm_sim(i,t+1) ) THEN    
        wage_stay_nhi(t,n)=wage_stay_nhi(t,n)+wage_sim(i,t+1)-wage_sim(i,t)
        wage_stay_nhi_count(t,n)=wage_stay_nhi_count(t,n)+1.0d0
    END IF
        
    IF (emp_sim(i,t)==0 .and. emp_sim(i,t+1)==1 .and. hi_sim(i,t+1)==2) THEN
    ! transit to insured
       ue_hi(t,n)=ue_hi(t,n)+1.0d0
       wage_ue_hi(t,n)=wage_ue_hi(t,n)+wage_sim(i,t+1)
    ELSE IF (emp_sim(i,t)==0 .and. emp_sim(i,t+1)==1 .and. hi_sim(i,t+1)==1 ) THEN     
        ue_nhi(t,n)=ue_nhi(t,n)+1.0d0
        wage_ue_nhi(t,n)=wage_ue_nhi(t,n)+wage_sim(i,t+1)

       
     ELSE IF (emp_sim(i,t)==1 .and. emp_sim(i,t+1)==1 .and. firm_sim(i,t) .ne. firm_sim(i,t+1) .and. & 
     hi_sim(i,t)==2 .and. hi_sim(i,t+1)==2) THEN
       jj_hihi(t,n)=jj_hihi(t,n)+1.0d0
       wage_jj_hihi(t,n)=wage_jj_hihi(t,n)+wage_sim(i,t+1)-wage_sim(i,t)
     ELSE IF (emp_sim(i,t)==1 .and. emp_sim(i,t+1)==1 .and. firm_sim(i,t) .ne. firm_sim(i,t+1) .and. & 
     hi_sim(i,t)==2 .and. hi_sim(i,t+1)==1 ) THEN       
        jj_hinhi(t,n)=jj_hinhi(t,n)+1.0d0
        wage_jj_hinhi(t,n)=wage_jj_hinhi(t,n)+wage_sim(i,t+1)-wage_sim(i,t)
     ELSE IF (emp_sim(i,t)==1 .and. emp_sim(i,t+1)==1 .and. firm_sim(i,t) .ne. firm_sim(i,t+1) .and. & 
     hi_sim(i,t)==1  .and. hi_sim(i,t+1)==1   ) THEN       
        jj_nhinhi(t,n)=jj_nhinhi(t,n)+1.0d0
        wage_jj_nhinhi(t,n)=wage_jj_nhinhi(t,n)+wage_sim(i,t+1)-wage_sim(i,t)    
       ELSE IF (emp_sim(i,t)==1 .and. emp_sim(i,t+1)==1 .and. firm_sim(i,t) .ne. firm_sim(i,t+1) .and. & 
     hi_sim(i,t)==1  .and. hi_sim(i,t+1)==2) THEN       
        jj_nhihi(t,n)=jj_nhihi(t,n)+1.0d0    
        wage_jj_nhihi(t,n)=wage_jj_nhihi(t,n)+wage_sim(i,t+1)-wage_sim(i,t)
       ELSE IF (emp_sim(i,t)==1 .and. emp_sim(i,t+1)==0) THEN     
       eu(t,n)=eu(t,n)+1.0d0
    END IF

END IF !simulation
        
END DO

! calculate mean
unemp_iinsured(t,n)=unemp_iinsured(t,n)/(ump_rate(t,n))
ump_rate(t,n)=ump_rate(t,n)/num_sim_ed(n)
wage_ue_hi(t,n)=wage_ue_hi(t,n)/ue_hi(t,n)
wage_ue_nhi(t,n)=wage_ue_nhi(t,n)/ue_nhi(t,n)
wage_average(t,n)=wage_average(t,n)/emp_rate(t,n)
wage_average_hi(t,n)=wage_average_hi(t,n)/emp_hinsured(t,n)
wage_average_nhi(t,n)=wage_average_nhi(t,n)/emp_uninsured(t,n)
IF (emp_iinsured(t,n)>0.0d0) THEN
wage_average_ii(t,n)=wage_average_ii(t,n)/emp_iinsured(t,n)
ELSE
wage_average_ii(t,n)=0.0d0
END IF
wage_stay_hi(t,n)=wage_stay_hi(t,n)/wage_stay_hi_count(t,n)
wage_stay_nhi(t,n)=wage_stay_nhi(t,n)/wage_stay_nhi_count(t,n)
wage_jj_hihi(t,n)=wage_jj_hihi(t,n)/jj_hihi(t,n)
wage_jj_nhihi(t,n)=wage_jj_nhihi(t,n)/jj_nhihi(t,n)
wage_jj_hinhi(t,n)=wage_jj_hinhi(t,n)/jj_hinhi(t,n)
wage_jj_nhinhi(t,n)=wage_jj_nhinhi(t,n)/jj_nhinhi(t,n)
!print*, wage_ue_nhi(t,n)
emp_uninsured(t,n)=emp_uninsured(t,n)/emp_rate(t,n)
emp_hinsured(t,n)=emp_hinsured(t,n)/emp_rate(t,n)
emp_iinsured(t,n)=emp_iinsured(t,n)/emp_rate(t,n)
emp_rate(t,n)=emp_rate(t,n)/num_sim_ed(n)

! calculate standard deviation
DO i=1, num_sim

IF (ed_sim(i)==n) THEN	   


   IF (emp_sim(i,t)==1) THEN
        std_wage_average(t,n)=wage_average(t,n)+wage_sim(i,t)
    END IF
    IF (emp_sim(i,t)==1 .and. hi_sim(i,t)==2) THEN
        std_wage_average_hi(t,n)=std_wage_average_hi(t,n)+(wage_sim(i,t)-wage_average_hi(t,n))**2.0d0
    END IF
    IF (emp_sim(i,t)==1 .and. (hi_sim(i,t)==1 .and. ii_sim(i,t)==0) ) THEN
        std_wage_average_nhi(t,n)=std_wage_average_nhi(t,n)+(wage_sim(i,t)-wage_average_nhi(t,n))**2.0d0
    END IF
    IF (emp_sim(i,t)==1 .and. (hi_sim(i,t)==1 .and. ii_sim(i,t)==1) ) THEN
        std_wage_average_ii(t,n)=std_wage_average_ii(t,n)+(wage_sim(i,t)-wage_average_ii(t,n))**2.0d0
    END IF
    IF (emp_sim(i,t)==1 .and. emp_sim(i,t+1)==1 .and. hi_sim(i,t)==2 .and. firm_sim(i,t)==firm_sim(i,t+1) ) THEN
        std_wage_stay_hi(t,n)=std_wage_stay_hi(t,n)+(wage_sim(i,t+1)-wage_sim(i,t)-wage_stay_hi(t,n))**2.0d0
    END IF    
    IF (emp_sim(i,t)==1 .and. emp_sim(i,t+1)==1 .and. hi_sim(i,t)==1  .and. firm_sim(i,t)==firm_sim(i,t+1) ) THEN    
        std_wage_stay_nhi(t,n)=std_wage_stay_nhi(t,n)+(wage_sim(i,t+1)-wage_sim(i,t)-wage_stay_nhi(t,n))**2.0d0
    END IF        
    IF (emp_sim(i,t)==0 .and. emp_sim(i,t+1)==1 .and. hi_sim(i,t+1)==2) THEN
    ! transit to insured
       std_wage_ue_hi(t,n)=std_wage_ue_hi(t,n)+(wage_sim(i,t)-wage_ue_hi(t,n))**2.0d0
    END IF
    IF (emp_sim(i,t)==0 .and. emp_sim(i,t+1)==1 .and. (hi_sim(i,t+1)==1 .or. hi_sim(i,t+1)==3)) THEN     
        std_wage_ue_nhi(t,n)=std_wage_ue_nhi(t,n)+(wage_sim(i,t)-wage_ue_nhi(t,n))**2.0d0
    END IF    
     IF (emp_sim(i,t)==1 .and. emp_sim(i,t+1)==1 .and. firm_sim(i,t) .ne. firm_sim(i,t+1) .and. & 
     hi_sim(i,t)==2 .and. hi_sim(i,t+1)==2) THEN
       std_wage_jj_hihi(t,n)=std_wage_jj_hihi(t,n)+(wage_sim(i,t+1)-wage_sim(i,t)-wage_jj_hihi(t,n))**2.0d0
     END IF  
     IF (emp_sim(i,t)==1 .and. emp_sim(i,t+1)==1 .and. firm_sim(i,t) .ne. firm_sim(i,t+1) .and. & 
     hi_sim(i,t)==2 .and. hi_sim(i,t+1)==1) THEN       
        std_wage_jj_hinhi(t,n)=std_wage_jj_hinhi(t,n)+(wage_sim(i,t+1)-wage_sim(i,t)-wage_jj_hinhi(t,n))**2.0d0
     END IF
     IF (emp_sim(i,t)==1 .and. emp_sim(i,t+1)==1 .and. firm_sim(i,t) .ne. firm_sim(i,t+1) .and. & 
     hi_sim(i,t)==1 .and. hi_sim(i,t+1)==1  ) THEN       
        std_wage_jj_nhinhi(t,n)=std_wage_jj_nhinhi(t,n)+(wage_sim(i,t+1)-wage_sim(i,t)-wage_jj_nhinhi(t,n))**2.0d0   
     END IF
     IF (emp_sim(i,t)==1 .and. emp_sim(i,t+1)==1 .and. firm_sim(i,t) .ne. firm_sim(i,t+1) .and. & 
     hi_sim(i,t)==1  .and. hi_sim(i,t+1)==2) THEN       
        std_wage_jj_nhihi(t,n)=std_wage_jj_nhihi(t,n)+(wage_sim(i,t+1)-wage_sim(i,t)-wage_jj_nhihi(t,n))**2.0d0  
    END IF

END IF !education

END DO    

!standard deviation
std_wage_ue_hi(t,n)=(std_wage_ue_hi(t,n)/ue_hi(t,n))**0.50d0
std_wage_ue_nhi(t,n)=(std_wage_ue_nhi(t,n)/ue_nhi(t,n))**0.50d0
std_wage_average(t,n)=(std_wage_average(t,n)/(emp_rate(t,n)*num_sim_ed(n)))**0.50d0
std_wage_average_hi(t,n)=(std_wage_average_hi(t,n)/(emp_hinsured(t,n)*emp_rate(t,n)*num_sim_ed(n)))**0.50d0
std_wage_average_nhi(t,n)=(std_wage_average_nhi(t,n)/(emp_uninsured(t,n)*emp_rate(t,n)*num_sim_ed(n)))**0.50d0
IF (emp_iinsured(t,n)>0.0d0) THEN
std_wage_average_ii(t,n)=(std_wage_average_ii(t,n)/(emp_iinsured(t,n)*emp_rate(t,n)*num_sim_ed(n)))**0.50d0
ELSE
std_wage_average_ii(t,n)=0.0d0
END IF
std_wage_stay_hi(t,n)=(std_wage_stay_hi(t,n)/wage_stay_hi_count(t,n))**0.50d0
std_wage_stay_nhi(t,n)=(std_wage_stay_nhi(t,n)/wage_stay_nhi_count(t,n))**0.50d0
std_wage_jj_hihi(t,n)=(std_wage_jj_hihi(t,n)/jj_hihi(t,n))**0.50d0
std_wage_jj_nhihi(t,n)=(std_wage_jj_nhihi(t,n)/jj_nhihi(t,n))**0.50d0
std_wage_jj_hinhi(t,n)=(std_wage_jj_hinhi(t,n)/jj_hinhi(t,n))**0.50d0
std_wage_jj_nhinhi(t,n)=(std_wage_jj_nhinhi(t,n)/jj_nhinhi(t,n))**0.50d0

IF (ISNAN(std_wage_ue_hi(t,n))) THEN
std_wage_ue_hi(t,n)=0.0d0
END IF
IF (ISNAN(std_wage_ue_nhi(t,n))) THEN
std_wage_ue_nhi(t,n)=0.0d0
END IF
IF (ISNAN(std_wage_average(t,n))) THEN
std_wage_average(t,n)=0.0d0
END IF
IF (ISNAN(std_wage_average_hi(t,n))) THEN
std_wage_average_hi(t,n)=0.0d0
END IF
IF (ISNAN(std_wage_average_nhi(t,n))) THEN
std_wage_average_nhi(t,n)=0.0d0
END IF
IF (ISNAN(std_wage_stay_hi(t,n))) THEN
std_wage_stay_hi(t,n)=0.0d0
END IF
IF (ISNAN(std_wage_stay_nhi(t,n))) THEN
std_wage_stay_nhi(t,n)=0.0d0
END IF
IF (ISNAN(std_wage_jj_hihi(t,n))) THEN
std_wage_jj_hihi(t,n)=0.0d0
END IF
IF (ISNAN(std_wage_jj_nhihi(t,n))) THEN
std_wage_jj_nhihi(t,n)=0.0d0
END IF
IF (ISNAN(std_wage_jj_hinhi(t,n))) THEN
std_wage_jj_hinhi(t,n)=0.0d0
END IF
IF (ISNAN(std_wage_jj_nhinhi(t,n))) THEN
std_wage_jj_nhinhi(t,n)=0.0d0
END IF



! transiton
ue_nhi(t,n)=ue_nhi(t,n)/(ump_rate(t,n)*num_sim_ed(n))
ue_hi(t,n)=ue_hi(t,n)/(ump_rate(t,n)*num_sim_ed(n))
jj_rate(t,n)=jj_hihi(t,n)+jj_nhihi(t,n)+jj_hinhi(t,n)+jj_nhinhi(t,n)
jj_rate(t,n)=jj_rate(t,n)/(emp_rate(t,n)*num_sim_ed(n))
jj_hihi(t,n)=jj_hihi(t,n)/(emp_rate(t,n)*num_sim_ed(n))
jj_nhihi(t,n)=jj_nhihi(t,n)/(emp_rate(t,n)*num_sim_ed(n))
jj_hinhi(t,n)=jj_hinhi(t,n)/(emp_rate(t,n)*num_sim_ed(n))
jj_nhinhi(t,n)=jj_nhinhi(t,n)/(emp_rate(t,n)*num_sim_ed(n))
eu(t,n)=eu(t,n)/(emp_rate(t,n)*num_sim_ed(n))

END DO !t

!health transition and medical expenditure
DO t=1, 36
j=(t-1)*3+22
health_transit_hh(t,n)=0.0d0
health_transit_uu(t,n)=0.0d0
health_transit_h_count(t,n)=0.0d0
health_transit_u_count(t,n)=0.0d0
med_exp_h(t,n)=0.0d0
med_exp_u(t,n)=0.0d0
std_med_exp_h(t,n)=0.0d0
std_med_exp_u(t,n)=0.0d0
count_med(1, t, n)=0.0d0
count_med(2, t, n)=0.0d0

DO y=1, 2
DO x=1, 2
med_exp_h_hi(t,n, y,x)=0.0d0
std_med_exp_h_hi(t,n, y,x)=0.0d0
positive_h_hi(t,n, y,x)=0.0d0
count_sim_h_hi(t,n, y,x)=0.0d0
END DO
END DO


DO i=1, num_sim

IF (ed_sim(i)==n) THEN	   



IF (health_sim(i,j)==1) THEN
health_transit_h_count(t,n)=health_transit_h_count(t,n)+1.0d0
ELSE IF (health_sim(i,j)==2) THEN
health_transit_u_count(t,n)=health_transit_u_count(t,n)+1.0d0
END IF
IF (health_sim(i,j)==1 .and. health_sim(i,j+3)==1) THEN
health_transit_hh(t,n)=health_transit_hh(t,n)+1

ELSE IF (health_sim(i,j)==2 .and. health_sim(i,j+3)==2) THEN
health_transit_uu(t,n)=health_transit_uu(t,n)+1
END IF
IF (health_sim(i,j)==1 .and. health_sim(i,j+1)==1 .and. health_sim(i,j+2)==1) THEN
count_med(1, t, n)=count_med(1, t, n)+1
med_exp_h(t,n)=med_exp_h(t,n)+med_care_sim(i,j)*dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,j))+beta_m(health_sim(i,j))*j+gamma_m(health_sim(i,j))*(j**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,j))*health_draw_sim(i,j))-kappa(health_sim(i,j)),0.0d0) &
+ med_care_sim(i,j+1)*dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,j+1))+beta_m(health_sim(i,j+1))*j+gamma_m(health_sim(i,j+1))*((j+1)**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,j+1))*health_draw_sim(i,j+1))-kappa(health_sim(i,j+1)),0.0d0) &
+ med_care_sim(i,j+2)*dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,j+2))+beta_m(health_sim(i,j+2))*j+gamma_m(health_sim(i,j+2))*((j+2)**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,j+2))*health_draw_sim(i,j+2))-kappa(health_sim(i,j+2)),0.0d0)
END IF
IF (health_sim(i,j)==2 .and. health_sim(i,j+1)==2 .and. health_sim(i,j+2)==2) THEN
count_med(2, t, n)=count_med(2, t, n)+1
med_exp_u(t,n)=med_exp_u(t,n)+med_care_sim(i,j)*dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,j))+beta_m(health_sim(i,j))*j+gamma_m(health_sim(i,j))*(j**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,j))*health_draw_sim(i,j))-kappa(health_sim(i,j)),0.0d0) &
+ med_care_sim(i,j+1)*dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,j+1))+beta_m(health_sim(i,j+1))*j+gamma_m(health_sim(i,j+1))*((j+1)**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,j+1))*health_draw_sim(i,j+1))-kappa(health_sim(i,j+1)),0.0d0) &
+ med_care_sim(i,j+2)*dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,j+2))+beta_m(health_sim(i,j+2))*j+gamma_m(health_sim(i,j+2))*((j+2)**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,j+2))*health_draw_sim(i,j+2))-kappa(health_sim(i,j+2)),0.0d0)
END IF

IF ((hi_sim(i,j)==2 .and. hi_sim(i,j+1)==2 .and. hi_sim(i,j+2)==2) .or. (hi_sim(i,j)==1 .and. hi_sim(i,j+1)==1 .and. hi_sim(i,j+2)==1 .and. ii_sim(i,j)==1 .and. ii_sim(i,j+1)==1 .and. ii_sim(i,j+2)==1)    ) THEN
ins_status=2
ELSE IF (hi_sim(i,j)==1 .and. hi_sim(i,j+1)==1 .and. hi_sim(i,j+2)==1 .and. ii_sim(i,j)==0 .and. ii_sim(i,j+1)==0 .and. ii_sim(i,j+2)==0) THEN
ins_status=1
END IF
DO x=1, 2
DO y=1, 2
IF (health_sim(i,j)==x .and. health_sim(i,j+1)==x .and. health_sim(i,j+2)==x .and. ins_status==y ) THEN
count_sim_h_hi(t,n,y,x)=count_sim_h_hi(t,n,y,x)+1.0d0
med_exp_h_hi(t,n,y,x)=med_exp_h_hi(t,n,y,x)+med_care_sim(i,j)*dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,j))+beta_m(health_sim(i,j))*j+eta2_m(ind_type_sim(i))*gamma_m(health_sim(i,j))*(j**2.0d0)+sigma_m(health_sim(i,j))*health_draw_sim(i,j))-kappa(health_sim(i,j)),0.0d0) &
+ med_care_sim(i,j+1)*dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,j+1))+beta_m(health_sim(i,j+1))*j+gamma_m(health_sim(i,j+1))*((j+1)**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,j+1))*health_draw_sim(i,j+1))-kappa(health_sim(i,j+1)),0.0d0) &
+ med_care_sim(i,j+2)*dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,j+2))+beta_m(health_sim(i,j+2))*j+gamma_m(health_sim(i,j+2))*((j+2)**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,j+2))*health_draw_sim(i,j+2))-kappa(health_sim(i,j+2)),0.0d0)

    IF (med_care_sim(i,j)*dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,j))+beta_m(health_sim(i,j))*j+gamma_m(health_sim(i,j))*(j**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,j))*health_draw_sim(i,j))-kappa(health_sim(i,j)),0.0d0) &
+ med_care_sim(i,j+1)*dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,j+1))+beta_m(health_sim(i,j+1))*j+gamma_m(health_sim(i,j+1))*((j+1)**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,j+1))*health_draw_sim(i,j+1))-kappa(health_sim(i,j+1)),0.0d0) &
+ med_care_sim(i,j+2)*dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,j+2))+beta_m(health_sim(i,j+2))*j+gamma_m(health_sim(i,j+2))*((j+2)**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,j+2))*health_draw_sim(i,j+2))-kappa(health_sim(i,j+2)),0.0d0)>0.0d0 ) THEN
        positive_h_hi(t,n,y,x)=positive_h_hi(t,n,y,x)+1.0d0
    END IF    

END IF

END DO
END DO
END IF !education

END DO

health_transit_hh(t,n)=health_transit_hh(t,n)/health_transit_h_count(t,n)
health_transit_uu(t,n)=health_transit_uu(t,n)/health_transit_u_count(t,n)

med_exp_h(t,n)=med_exp_h(t,n)/count_med(1, t, n)
med_exp_u(t,n)=med_exp_u(t,n)/count_med(2, t, n)

DO x=1, 2
DO y=1, 2
med_exp_h_hi(t,n,y,x)=med_exp_h_hi(t,n,y,x)/count_sim_h_hi(t,n,y,x)
positive_h_hi(t,n,y,x)=positive_h_hi(t,n,y,x)/count_sim_h_hi(t,n,y,x)
END DO
END DO



DO i=1, num_sim

IF (ed_sim(i)==n) THEN	   


IF (health_sim(i,j)==1 .and. health_sim(i,j+1)==1 .and. health_sim(i,j+2)==1) THEN
std_med_exp_h(t,n)=std_med_exp_h(t,n)+(med_care_sim(i,j)*dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,j))+beta_m(health_sim(i,j))*j+gamma_m(health_sim(i,j))*(j**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,j))*health_draw_sim(i,j))-kappa(health_sim(i,j)),0.0d0) &
+ med_care_sim(i,j+1)*dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,j+1))+beta_m(health_sim(i,j+1))*j+gamma_m(health_sim(i,j+1))*((j+1)**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,j+1))*health_draw_sim(i,j+1))-kappa(health_sim(i,j+1)),0.0d0) &
+ med_care_sim(i,j+2)*dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,j+2))+beta_m(health_sim(i,j+2))*j+gamma_m(health_sim(i,j+2))*((j+2)**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,j+2))*health_draw_sim(i,j+2))-kappa(health_sim(i,j+2)),0.0d0) &
-med_exp_h(t,n))**2.0d0
END IF
IF (health_sim(i,j)==2 .and. health_sim(i,j+1)==2 .and. health_sim(i,j+2)==2) THEN
std_med_exp_u(t,n)=std_med_exp_u(t,n)+(med_care_sim(i,j)*dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,j))+beta_m(health_sim(i,j))*j+gamma_m(health_sim(i,j))*(j**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,j))*health_draw_sim(i,j))-kappa(health_sim(i,j)),0.0d0) &
+ med_care_sim(i,j+1)*dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,j+1))+beta_m(health_sim(i,j+1))*j+gamma_m(health_sim(i,j+1))*((j+1)**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,j+1))*health_draw_sim(i,j+1))-kappa(health_sim(i,j+1)),0.0d0) &
+ med_care_sim(i,j+2)*dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,j+2))+beta_m(health_sim(i,j+2))*j+gamma_m(health_sim(i,j+2))*((j+2)**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,j+2))*health_draw_sim(i,j+2))-kappa(health_sim(i,j+2)),0.0d0) &
-med_exp_u(t,n))**2.0d0
END IF

IF ((hi_sim(i,j)==2 .and. hi_sim(i,j+1)==2 .and. hi_sim(i,j+2)==2) .or. (hi_sim(i,j)==1 .and. hi_sim(i,j+1)==1 .and. hi_sim(i,j+2)==1 .and. ii_sim(i,j)==1 .and. ii_sim(i,j+1)==1 .and. ii_sim(i,j+2)==1)    ) THEN
ins_status=2
ELSE IF (hi_sim(i,j)==1 .and. hi_sim(i,j+1)==1 .and. hi_sim(i,j+2)==1 .and. ii_sim(i,j)==0 .and. ii_sim(i,j+1)==0 .and. ii_sim(i,j+2)==0) THEN
ins_status=1
END IF

DO x=1, 2
DO y=1, 2
IF (health_sim(i,j)==x .and. health_sim(i,j+1)==x .and. health_sim(i,j+2)==x .and. ins_status==y ) THEN
std_med_exp_h_hi(t,n,y,x)=std_med_exp_h_hi(t,n,y,x)+(med_care_sim(i,j)*dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,j))+beta_m(health_sim(i,j))*j+gamma_m(health_sim(i,j))*(j**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,j))*health_draw_sim(i,j))-kappa(health_sim(i,j)),0.0d0) &
+ med_care_sim(i,j+1)*dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,j+1))+beta_m(health_sim(i,j+1))*j+gamma_m(health_sim(i,j+1))*((j+1)**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,j+1))*health_draw_sim(i,j+1))-kappa(health_sim(i,j+1)),0.0d0) &
+ med_care_sim(i,j+2)*dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,j+2))+beta_m(health_sim(i,j+2))*j+gamma_m(health_sim(i,j+2))*((j+2)**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,j+2))*health_draw_sim(i,j+2))-kappa(health_sim(i,j+2)),0.0d0) &
-med_exp_h_hi(t,n,y,x))**2.0d0
END IF
END DO
END DO



END IF !education

END DO

std_med_exp_h(t,n)=(std_med_exp_h(t,n)/count_med(1, t, n))**0.50d0
std_med_exp_u(t,n)=(std_med_exp_u(t,n)/count_med(2, t, n))**0.50d0

DO x=1, 2
DO y=1, 2
std_med_exp_h_hi(t,n,y,x)=(std_med_exp_h_hi(t,n,y,x)/count_sim_h_hi(t,n,y,x))**0.50d0
END DO
END DO


END DO !t



!health status
DO t=1, num_period
health_sim_mean(t,n)=0.0d0
health_sim_var(t,n)=0.0d0
DO i=1, num_sim

IF (ed_sim(i)==n) THEN	   



IF (health_sim(i,t)==1) THEN
health_sim_mean(t,n)=health_sim_mean(t,n)+1.0d0
END IF

END IF !education

END DO
health_sim_mean(t,n)=health_sim_mean(t,n)/num_sim_ed(n)
DO i=1, num_sim

IF (ed_sim(i)==n) THEN	   


IF (health_sim(i,t)==1) THEN
health_sim_var(t,n)=health_sim_var(t,n)+(1.0d0-health_sim_mean(t,n))**2.0d0
ELSE IF (health_sim(i,t)==2) THEN
health_sim_var(t,n)=health_sim_var(t,n)+(0.0d0-health_sim_mean(t,n))**2.0d0
END IF

END IF !education

END DO
health_sim_var(t,n)=health_sim_var(t,n)/num_sim_ed(n)
END DO



!aggregate by cohort
DO t=1, 5
j=22+21*(t-1)
denom=0.0d0
ii_u_rate_c(t,n)=0.0d0
eshi_rate_c(t,n)=0.0d0
ii_rate_c(t,n)=0.0d0
ump_rate_c(t,n)=0.0d0
hi_rate_c(t,n)=0.0d0
ue_hi_c(t,n)=0.0d0
ue_nhi_c(t,n)=0.0d0
jj_hihi_c(t,n)=0.0d0
jj_hinhi_c(t,n)=0.0d0
jj_nhinhi_c(t,n)=0.0d0
jj_nhihi_c(t,n)=0.0d0
jj_rate_c(t,n)=0.0d0
eu_c(t,n)=0.0d0
wage_ue_hi_c(t,n)=0.0d0
wage_ue_nhi_c(t,n)=0.0d0
wage_average_c(t,n)=0.0d0
wage_average_hi_c(t,n)=0.0d0
wage_average_nhi_c(t,n)=0.0d0
wage_average_ii_c(t,n)=0.0d0
wage_stay_hi_c(t,n)=0.0d0
wage_stay_nhi_c(t,n)=0.0d0
wage_stay_hi_count_c(t,n)=0.0d0
wage_stay_nhi_count_c(t,n)=0.0d0
wage_jj_hihi_c(t,n)=0.0d0
wage_jj_hinhi_c(t,n)=0.0d0
wage_jj_nhinhi_c(t,n)=0.0d0
wage_jj_nhihi_c(t,n)=0.0d0
std_wage_ue_hi_c(t,n)=0.0d0
std_wage_ue_nhi_c(t,n)=0.0d0
std_wage_average_c(t,n)=0.0d0
std_wage_average_hi_c(t,n)=0.0d0
std_wage_average_nhi_c(t,n)=0.0d0
std_wage_stay_hi_c(t,n)=0.0d0
std_wage_stay_nhi_c(t,n)=0.0d0
std_wage_jj_hihi_c(t,n)=0.0d0
std_wage_jj_hinhi_c(t,n)=0.0d0
std_wage_jj_nhihi_c(t,n)=0.0d0
std_wage_jj_nhinhi_c(t,n)=0.0d0
health_transit_hh_c(t,n)=0.0d0
health_transit_uu_c(t,n)=0.0d0
health_c(t,n)=0.0d0

cohot_size(t,n)=0.0d0
emp_denom(t,n)=0.0d0
ue_hi_c_denom(t,n)=0.0d0
ue_nhi_c_denom(t,n)=0.0d0
wage_average_hi_c_denom(t,n)=0.0d0
wage_average_nhi_c_denom(t,n)=0.0d0
wage_average_ii_c_denom(t,n)=0.0d0
wage_stay_hi_c_denom(t,n)=0.0d0
wage_stay_nhi_c_denom(t,n)=0.0d0
wage_jj_hihi_c_denom(t,n)=0.0d0
wage_jj_nhihi_c_denom(t,n)=0.0d0
wage_jj_hinhi_c_denom(t,n)=0.0d0
wage_jj_nhinhi_c_denom(t,n)=0.0d0
wage_ue_hi_c_denom(t,n)=0.0d0
wage_ue_nhi_c_denom(t,n)=0.0d0
health_transit_hh_c_denom(t,n)=0.0d0
health_transit_uu_c_denom(t,n)=0.0d0
quality1(t,n)=0.0d0
quality2(t,n)=0.0d0
DO i=0, 20
DO k=1, num_sim



IF (ed_sim(k)==n) THEN

cohot_size(t,n)=cohot_size(t,n)+1.0d0*cohort_weight(j+i,n)
	  
IF (emp_sim(k,j+i)==0) THEN
ump_rate_c(t,n)=ump_rate_c(t,n)+cohort_weight(j+i,n)



IF (ii_sim(k,j+i)==1) THEN
takeup_c(t,n)=takeup_c(t,n)+cohort_weight(j+i,n)
END IF

END IF

IF (emp_sim(k,j+i)==0 .and. emp_sim(k, j+i+1)==1 .and. hi_sim(k, j+i+1)==2) THEN
wage_ue_hi_c(t,n)=wage_ue_hi_c(t,n)+wage_sim(k, j+i+1)*cohort_weight(j+i,n)
ue_hi_c(t,n)=ue_hi_c(t,n)+cohort_weight(j+i,n)

ELSE IF (emp_sim(k,j+i)==0 .and. emp_sim(k, j+i+1)==1 .and. hi_sim(k, j+i+1)==1  ) THEN     
wage_ue_nhi_c(t,n)=wage_ue_nhi_c(t,n)+wage_sim(k, j+i+1)*cohort_weight(j+i,n)
ue_nhi_c(t,n)=ue_nhi_c(t,n)+cohort_weight(j+i,n)
END IF

IF (emp_sim(k,j+i)==1) THEN
wage_average_c(t,n)=wage_average_c(t,n)+wage_sim(k, j+i)*cohort_weight(j+i,n)
emp_denom(t,n)=emp_denom(t,n)+cohort_weight(j+i,n)


IF (hi_sim(k, j+i)==2) THEN
wage_average_hi_c(t,n)=wage_average_hi_c(t,n)+wage_sim(k, j+i)*cohort_weight(j+i,n)
wage_average_hi_c_denom(t,n)=wage_average_hi_c_denom(t,n)+cohort_weight(j+i,n)
quality1(t,n)=quality1(t,n)+ind_type_sim(k)*cohort_weight(j+i,n)
ELSE IF (hi_sim(k, j+i)==1 .and. ii_sim(k,j+i)==0 )   THEN
wage_average_nhi_c(t,n)=wage_average_nhi_c(t,n)+wage_sim(k, j+i)*cohort_weight(j+i,n)
wage_average_nhi_c_denom(t,n)=wage_average_nhi_c_denom(t,n)+cohort_weight(j+i,n)

ELSE IF (hi_sim(k, j+i)==1 .and. ii_sim(k,j+i)==1 )   THEN
wage_average_ii_c(t,n)=wage_average_ii_c(t,n)+wage_sim(k, j+i)*cohort_weight(j+i,n)
wage_average_ii_c_denom(t,n)=wage_average_ii_c_denom(t,n)+cohort_weight(j+i,n)
quality2(t,n)=quality2(t,n)+ind_type_sim(k)*cohort_weight(j+i,n)
!IF ((t==4 .or. t==5) .and. ed_sim(k)==2 ) THEN
!print*, wage_sim(k,j+i), firm_sim(k, j+i), ind_type_sim(k)
!END IF

IF (ii_sim(k,j+i)==1) THEN
takeup_c(t,n)=takeup_c(t,n)+cohort_weight(j+i,n)
END IF

END IF

END IF

IF (emp_sim(k,j+i)==1 .and. emp_sim(k, j+i+1)==1 .and. hi_sim(k,j+i)==2 .and. firm_sim(k,j+i)==firm_sim(k, j+i+1) ) THEN
wage_stay_hi_c(t,n)=wage_stay_hi_c(t,n)+(wage_sim(k, j+i+1)-wage_sim(k, j+i))*cohort_weight(j+i,n)
wage_stay_hi_c_denom(t,n)=wage_stay_hi_c_denom(t,n)+cohort_weight(j+i,n)


ELSE IF (emp_sim(k,j+i)==1 .and. emp_sim(k, j+i+1)==1 .and. hi_sim(k, j+i)==1  .and. firm_sim(k,j+i)==firm_sim(k, j+i+1) ) THEN   
wage_stay_nhi_c(t,n)=wage_stay_nhi_c(t,n)+(wage_sim(k, j+i+1)-wage_sim(k, j+i))*cohort_weight(j+i,n)
wage_stay_nhi_c_denom(t,n)=wage_stay_nhi_c_denom(t,n)+cohort_weight(j+i,n)

END IF

IF (emp_sim(k,j+i)==1 .and. emp_sim(k, j+i+1)==1 .and. firm_sim(k,j+i) .ne. firm_sim(k, j+i+1) .and. & 
     hi_sim(k,j+i)==2 .and. hi_sim(k, j+i+1)==2) THEN
wage_jj_hihi_c(t,n)=wage_jj_hihi_c(t,n)+(wage_sim(k, j+i+1)-wage_sim(k, j+i))*cohort_weight(j+i,n)
jj_hihi_c(t,n)=jj_hihi_c(t,n)+cohort_weight(j+i,n)
END IF

IF (emp_sim(k,j+i)==1 .and. emp_sim(k, j+i+1)==1 .and. firm_sim(k,j+i) .ne. firm_sim(k, j+i+1) .and. & 
     hi_sim(k, j+i)==1  .and. hi_sim(k, j+i+1)==2) THEN  
wage_jj_nhihi_c(t,n)=wage_jj_nhihi_c(t,n)+(wage_sim(k, j+i+1)-wage_sim(k, j+i))*cohort_weight(j+i,n)
jj_nhihi_c(t,n)=jj_nhihi_c(t,n)+cohort_weight(j+i,n)
END IF

IF (emp_sim(k,j+i)==1 .and. emp_sim(k, j+i+1)==1 .and. firm_sim(k,j+i) .ne. firm_sim(k, j+i+1) .and. & 
     hi_sim(k,j+i)==2 .and. hi_sim(k, j+i+1)==1   ) THEN
wage_jj_hinhi_c(t,n)=wage_jj_hinhi_c(t,n)+(wage_sim(k, j+i+1)-wage_sim(k, j+i))*cohort_weight(j+i,n)
jj_hinhi_c(t,n)=jj_hinhi_c(t,n)+cohort_weight(j+i,n)
END IF

IF (emp_sim(k,j+i)==1 .and. emp_sim(k, j+i+1)==1 .and. firm_sim(k,j+i) .ne. firm_sim(k, j+i+1) .and. & 
     hi_sim(k,j+i)==1 .and. hi_sim(k, j+i+1)==1    ) THEN 
wage_jj_nhinhi_c(t,n)=wage_jj_nhinhi_c(t,n)+(wage_sim(k, j+i+1)-wage_sim(k, j+i))*cohort_weight(j+i,n)
jj_nhinhi_c(t,n)=jj_nhinhi_c(t,n)+cohort_weight(j+i,n)
END IF

IF (emp_sim(k,j+i)==1 .and. hi_sim(k, j+i)==2) THEN
eshi_rate_c(t,n)=eshi_rate_c(t,n)+cohort_weight(j+i,n)
END IF

IF ((emp_sim(k,j+i)==1 .and. hi_sim(k, j+i)==1. .and. ii_sim(k,j+i)==1) .or. (emp_sim(k,j+i)==0 .and. ii_sim(k,j+i)==1)  ) THEN
ii_rate_c(t,n)=ii_rate_c(t,n)+cohort_weight(j+i,n)
END IF


IF (emp_sim(k,j+i)==0 .and. ii_sim(k,j+i)==1) THEN
ii_u_rate_c(t,n)=ii_u_rate_c(t,n)+cohort_weight(j+i,n)
END IF

IF (health_sim(k,j+i)==1) THEN
health_c(t,n)=health_c(t,n)+cohort_weight(j+i,n)
END IF


IF (emp_sim(k,j+i)==1 .and. hi_sim(k, j+i)==2) THEN
emp_hinsured_c(t,n)=emp_hinsured_c(t,n)+cohort_weight(j+i,n)
END IF

IF (emp_sim(k,j+i)==1 .and. emp_sim(k, j+i+1)==1 .and. firm_sim(k,j+i) .ne. firm_sim(k, j+i+1) ) THEN 
jj_rate_c(t,n)=jj_rate_c(t,n)+cohort_weight(j+i,n)
END IF


IF (emp_sim(k,j+i)==1 .and. emp_sim(k, j+i+1)==0) THEN
eu_c(t,n)=eu_c(t,n)+cohort_weight(j+i,n)
END IF


END IF !education

END DO
END DO


!! devide by the size
wage_ue_hi_c(t,n)=wage_ue_hi_c(t,n)/ue_hi_c(t,n)
wage_ue_nhi_c(t,n)=wage_ue_nhi_c(t,n)/ue_nhi_c(t,n)
wage_ue_hi_c_denom(t,n)=ue_hi_c(t,n)
wage_ue_nhi_c_denom(t,n)=ue_nhi_c(t,n)
ue_nhi_c(t,n)=ue_nhi_c(t,n)/ump_rate_c(t,n)
ue_hi_c(t,n)=ue_hi_c(t,n)/ump_rate_c(t,n)
ii_u_rate_c(t,n)=ii_u_rate_c(t,n)/ump_rate_c(t,n)
ump_rate_c(t,n)=ump_rate_c(t,n)/cohot_size(t,n)
wage_average_c(t,n)=wage_average_c(t,n)/emp_denom(t,n)
wage_average_hi_c(t,n)=wage_average_hi_c(t,n)/wage_average_hi_c_denom(t,n)
quality1(t,n)=quality1(t,n)/wage_average_hi_c_denom(t,n)
wage_average_nhi_c(t,n)=wage_average_nhi_c(t,n)/wage_average_nhi_c_denom(t,n)
IF (wage_average_ii_c_denom(t,n)>0.0d0) THEN
wage_average_ii_c(t,n)=wage_average_ii_c(t,n)/wage_average_ii_c_denom(t,n)
quality2(t,n)=quality2(t,n)/wage_average_ii_c_denom(t,n)
ELSE
wage_average_ii_c(t,n)=0.0d0
END IF
wage_stay_hi_c(t,n)=wage_stay_hi_c(t,n)/wage_stay_hi_c_denom(t,n)
wage_stay_nhi_c(t,n)=wage_stay_nhi_c(t,n)/wage_stay_nhi_c_denom(t,n)
wage_jj_hihi_c(t,n)=wage_jj_hihi_c(t,n)/jj_hihi_c(t,n)
wage_jj_nhihi_c(t,n)=wage_jj_nhihi_c(t,n)/jj_nhihi_c(t,n)
wage_jj_hinhi_c(t,n)=wage_jj_hinhi_c(t,n)/jj_hinhi_c(t,n)
wage_jj_nhinhi_c(t,n)=wage_jj_nhinhi_c(t,n)/jj_nhinhi_c(t,n)
wage_jj_hihi_c_denom(t,n)=jj_hihi_c(t,n)
wage_jj_nhihi_c_denom(t,n)=jj_nhihi_c(t,n)
wage_jj_hinhi_c_denom(t,n)=jj_hinhi_c(t,n)
wage_jj_nhinhi_c_denom(t,n)=jj_nhinhi_c(t,n)

jj_hihi_c(t,n)=jj_hihi_c(t,n)/emp_denom(t,n)
jj_nhihi_c(t,n)=jj_nhihi_c(t,n)/emp_denom(t,n)
jj_hinhi_c(t,n)=jj_hinhi_c(t,n)/emp_denom(t,n)
jj_nhinhi_c(t,n)=jj_nhinhi_c(t,n)/emp_denom(t,n)
jj_rate_c(t,n)=jj_rate_c(t,n)/emp_denom(t,n)
eu_c(t,n)=eu_c(t,n)/emp_denom(t,n)
eshi_rate_c(t,n)=eshi_rate_c(t,n)/cohot_size(t,n)
ii_rate_c(t,n)=ii_rate_c(t,n)/cohot_size(t,n)
health_c(t,n)=health_c(t,n)/cohot_size(t,n)
emp_hinsured_c(t,n)=emp_hinsured_c(t,n)/cohot_size(t,n)

takeup_c(t,n)=takeup_c(t,n)/((1.0-hi_rate_c(t,n))*emp_denom(t,n)+ump_rate_c(t,n))

! standard deviaiton
DO i=0, 20
DO k=1, num_sim



IF (ed_sim(k)==n) THEN	   


   IF (emp_sim(k,j+i)==1) THEN
        std_wage_average_c(t,n)=std_wage_average_c(t,n)+(wage_sim(k,j+i)-wage_average_c(t,n))**2.0d0*cohort_weight(j+i,n)
    END IF
    IF (emp_sim(k,j+i)==1 .and. hi_sim(k,j+i)==2) THEN
        std_wage_average_hi_c(t,n)=std_wage_average_hi_c(t,n)+(wage_sim(k,j+i)-wage_average_hi_c(t,n))**2.0d0*cohort_weight(j+i,n)
    END IF
    IF (emp_sim(k,j+i)==1 .and. (hi_sim(k, j+i)==1 .and. ii_sim(k,j+i)==0)  ) THEN
        std_wage_average_nhi_c(t,n)=std_wage_average_nhi_c(t,n)+(wage_sim(k,j+i)-wage_average_nhi_c(t,n))**2.0d0*cohort_weight(j+i,n)
    END IF
    IF (emp_sim(k,j+i)==1 .and. (hi_sim(k, j+i)==1 .and. ii_sim(k,j+i)==1)  ) THEN
        std_wage_average_ii_c(t,n)=std_wage_average_ii_c(t,n)+(wage_sim(k,j+i)- wage_average_ii_c(t,n))**2.0d0*cohort_weight(j+i,n)
    END IF
    IF (emp_sim(k,j+i)==1 .and. emp_sim(k,j+i+1)==1 .and. hi_sim(k,j+i)==2 .and. firm_sim(k,j+i)==firm_sim(k,j+i+1) ) THEN
        std_wage_stay_hi_c(t,n)=std_wage_stay_hi_c(t,n)+(wage_sim(k,j+i+1)-wage_sim(k,j+i)-wage_stay_hi_c(t,n))**2.0d0*cohort_weight(j+i,n)
    END IF    
    IF (emp_sim(k,j+i)==1 .and. emp_sim(k,j+i+1)==1 .and. hi_sim(k, j+i)==1  .and. firm_sim(k,j+i)==firm_sim(k,j+i+1) ) THEN    
        std_wage_stay_nhi_c(t,n)=std_wage_stay_nhi_c(t,n)+(wage_sim(k,j+i+1)-wage_sim(k,j+i)-wage_stay_nhi_c(t,n))**2.0d0*cohort_weight(j+i,n)
    END IF        
    IF (emp_sim(k,j+i)==0 .and. emp_sim(k,j+i+1)==1 .and. hi_sim(k,j+i+1)==2) THEN
    ! transit to insured
       std_wage_ue_hi_c(t,n)=std_wage_ue_hi_c(t,n)+(wage_sim(k,j+i)-wage_ue_hi_c(t,n))**2.0d0*cohort_weight(j+i,n)
    END IF
    IF (emp_sim(k,j+i)==0 .and. emp_sim(k,j+i+1)==1 .and. hi_sim(k, j+i+1)==1  ) THEN     
        std_wage_ue_nhi_c(t,n)=std_wage_ue_nhi_c(t,n)+(wage_sim(k,j+i)-wage_ue_nhi_c(t,n))**2.0d0*cohort_weight(j+i,n)
    END IF    
     IF (emp_sim(k,j+i)==1 .and. emp_sim(k,j+i+1)==1 .and. firm_sim(k,j+i) .ne. firm_sim(k,j+i+1) .and. & 
     hi_sim(k,j+i)==2 .and. hi_sim(k,j+i+1)==2) THEN
       std_wage_jj_hihi_c(t,n)=std_wage_jj_hihi_c(t,n)+(wage_sim(k,j+i+1)-wage_sim(k,j+i)-wage_jj_hihi_c(t,n))**2.0d0*cohort_weight(j+i,n)
     END IF  
     IF (emp_sim(k,j+i)==1 .and. emp_sim(k,j+i+1)==1 .and. firm_sim(k,j+i) .ne. firm_sim(k,j+i+1) .and. & 
     hi_sim(k,j+i)==2 .and. hi_sim(k, j+i+1)==1  ) THEN       
        std_wage_jj_hinhi_c(t,n)=std_wage_jj_hinhi_c(t,n)+(wage_sim(k,j+i+1)-wage_sim(k,j+i)-wage_jj_hinhi_c(t,n))**2.0d0*cohort_weight(j+i,n)
     END IF
     IF (emp_sim(k,j+i)==1 .and. emp_sim(k,j+i+1)==1 .and. firm_sim(k,j+i) .ne. firm_sim(k,j+i+1) .and. & 
     hi_sim(k, j+i)==1  .and. hi_sim(k, j+i+1)==1  ) THEN       
        std_wage_jj_nhinhi_c(t,n)=std_wage_jj_nhinhi_c(t,n)+(wage_sim(k,j+i+1)-wage_sim(k,j+i)-wage_jj_nhinhi_c(t,n))**2.0d0*cohort_weight(j+i,n)   
     END IF
     IF (emp_sim(k,j+i)==1 .and. emp_sim(k,j+i+1)==1 .and. firm_sim(k,j+i) .ne. firm_sim(k,j+i+1) .and. & 
     hi_sim(k, j+i)==1  .and. hi_sim(k,j+i+1)==2) THEN       
        std_wage_jj_nhihi_c(t,n)=std_wage_jj_nhihi_c(t,n)+(wage_sim(k,j+i+1)-wage_sim(k,j+i)-wage_jj_nhihi_c(t,n))**2.0d0*cohort_weight(j+i,n)  
    END IF

END IF !education

END DO  

END DO

! devide by the size
std_wage_ue_hi_c(t,n)=(std_wage_ue_hi_c(t,n)/wage_ue_hi_c_denom(t,n))**0.50d0
std_wage_ue_nhi_c(t,n)=(std_wage_ue_nhi_c(t,n)/wage_ue_nhi_c_denom(t,n))**0.50d0
std_wage_jj_hihi_c(t,n)=(std_wage_jj_hihi_c(t,n)/wage_jj_hihi_c_denom(t,n))**0.50d0
std_wage_jj_nhihi_c(t,n)=(std_wage_jj_nhihi_c(t,n)/wage_jj_nhihi_c_denom(t,n))**0.50d0
std_wage_jj_hinhi_c(t,n)=(std_wage_jj_hinhi_c(t,n)/wage_jj_hinhi_c_denom(t,n))**0.50d0
std_wage_jj_nhinhi_c(t,n)=(std_wage_jj_nhinhi_c(t,n)/wage_jj_nhinhi_c_denom(t,n))**0.50d0
std_wage_stay_hi_c(t,n)=(std_wage_stay_hi_c(t,n)/wage_stay_hi_c_denom(t,n))**0.50d0
std_wage_stay_nhi_c(t,n)=(std_wage_stay_nhi_c(t,n)/wage_stay_nhi_c_denom(t,n))**0.50d0
std_wage_average_hi_c(t,n)=(std_wage_average_hi_c(t,n)/wage_average_hi_c_denom(t,n))**0.50d0
std_wage_average_nhi_c(t,n)=(std_wage_average_nhi_c(t,n)/wage_average_nhi_c_denom(t,n))**0.50d0
IF (wage_average_ii_c_denom(t,n)>0.0d0) THEN
std_wage_average_ii_c(t,n)=(std_wage_average_ii_c(t,n)/wage_average_ii_c_denom(t,n))**0.50d0
ELSE
std_wage_average_ii_c(t,n)=0.0d0
END IF

health_transit_hh_c(t,n)=0.0d0
health_transit_uu_c(t,n)=0.0d0
health_transit_h_count_c(t,n)=0.0d0
health_transit_u_count_c(t,n)=0.0d0
health_transit_hh_c_denom(t,n)=0.0d0
health_transit_uu_c_denom(t,n)=0.0d0


!health transition
!j=7*(t-1)+1
j=22+21*(t-1)
denom=0.0d0
DO i=0, 6
denom=denom+cohort_weight(21+j+i*3,n)
DO k=1, num_sim

IF (ed_sim(k)==n) THEN

IF (health_sim(k,j+i)==1 ) THEN
health_transit_hh_c_denom(t,n)=health_transit_hh_c_denom(t,n)+cohort_weight(21+j+i*3,n)
ELSE IF (health_sim(k,j+i)==2 ) THEN
health_transit_uu_c_denom(t,n)=health_transit_uu_c_denom(t,n)+cohort_weight(21+j+i*3,n)
END IF

IF (health_sim(k,j+i)==1 .and. health_sim(k,j+i+3)==1) THEN
health_transit_hh_c(t,n)=health_transit_hh_c(t,n)+cohort_weight(21+j+i*3,n)
END IF
IF (health_sim(k,j+i)==2 .and. health_sim(k,j+i+3)==2) THEN
health_transit_uu_c(t,n)=health_transit_uu_c(t,n)+cohort_weight(21+j+i*3,n)
END IF

END IF !education

END DO !k

END DO !i


health_transit_hh_c(t,n)=health_transit_hh_c(t,n)/health_transit_hh_c_denom(t,n)
health_transit_uu_c(t,n)=health_transit_uu_c(t,n)/health_transit_uu_c_denom(t,n)



END DO !t

! medical expenditure !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


DO t=1, 3

med_exp_h_c(t,n)=0.0d0
med_exp_u_c(t,n)=0.0d0
std_med_exp_h_c(t,n)=0.0d0
std_med_exp_u_c(t,n)=0.0d0
emp_hinsured_c(t,n)=0.0d0
count_med_c(1, t, n)=0.0d0
count_med_c(2, t, n)=0.0d0




DO x=1, 2
DO y=1, 2
count_sim_h_hi_c(t,n,y,x)=0.0d0
med_exp_h_hi_c(t,n,y,x)=0.0d0
std_med_exp_h_hi_c(t,n,y,x)=0.0d0
positive_h_hi_c(t,n,y,x)=0.0d0
END DO
END DO

IF (t==1) THEN
j=22
band=15
ELSE IF (t==2) THEN
j=68
band=10

ELSE IF (t==3) THEN
j=99
band=10
END IF
! t=1


denom=0.0d0
DO i=1, band
denom=denom+cohort_weight(j+(i-1)*3,n)

DO k=1, num_sim

IF (ed_sim(k)==n) THEN

IF (health_sim(k,j+(i-1)*3)==1 .and. health_sim(k,j+(i-1)*3+1)==1 .and. health_sim(k,j+(i-1)*3+2)==1) THEN
count_med_c(1, t, n)=count_med_c(1, t, n)+cohort_weight(j+(i-1)*3,n)+cohort_weight(j+(i-1)*3+1,n)+cohort_weight(j+(i-1)*3+2,n)
med_exp_h_c(t,n)=med_exp_h_c(t,n)+(med_care_sim(k,j+(i-1)*3)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3))+beta_m(health_sim(k,j+(i-1)*3))*(j+(i-1)*3)+gamma_m(health_sim(k,j+(i-1)*3))*((j+(i-1)*3)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3))*health_draw_sim(k,j+(i-1)*3))-kappa(health_sim(k,j+(i-1)*3)),0.0d0) &
+ med_care_sim(k,j+(i-1)*3+1)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3+1))+beta_m(health_sim(k,j+(i-1)*3+1))*(j+(i-1)*3+1)+gamma_m(health_sim(k,j+(i-1)*3+1))*((j+(i-1)*3+1)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+1))*health_draw_sim(k,j+(i-1)*3+1))-kappa(health_sim(k,j+(i-1)*3+1)),0.0d0) &
+ med_care_sim(k,j+(i-1)*3+2)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3+2))+beta_m(health_sim(k,j+(i-1)*3+2))*(j+(i-1)*3+2)+gamma_m(health_sim(k,j+(i-1)*3+2))*((j+(i-1)*3+2)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+2))*health_draw_sim(k,j+(i-1)*3+2))-kappa(health_sim(k,j+(i-1)*3+2)),0.0d0)) &
*(cohort_weight(j+(i-1)*3,n)+cohort_weight(j+(i-1)*3+1,n)+cohort_weight(j+(i-1)*3+2,n))
END IF
IF (health_sim(k,j+(i-1)*3)==2 .and. health_sim(k,j+(i-1)*3+1)==2 .and. health_sim(k,j+(i-1)*3+2)==2) THEN
count_med_c(2, t, n)=count_med_c(2, t, n)+cohort_weight(j+(i-1)*3,n)+cohort_weight(j+(i-1)*3+1,n)+cohort_weight(j+(i-1)*3+2,n)
med_exp_u_c(t,n)=med_exp_u_c(t,n)+(med_care_sim(k,j+(i-1)*3)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3))+beta_m(health_sim(k,j+(i-1)*3))*(j+(i-1)*3)+gamma_m(health_sim(k,j+(i-1)*3))*((j+(i-1)*3)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3))*health_draw_sim(k,j+(i-1)*3))-kappa(health_sim(k,j+(i-1)*3)),0.0d0) &
+ med_care_sim(k,j+(i-1)*3+1)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3+1))+beta_m(health_sim(k,j+(i-1)*3+1))*(j+(i-1)*3+1)+gamma_m(health_sim(k,j+(i-1)*3+1))*((j+(i-1)*3+1)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+1))*health_draw_sim(k,j+(i-1)*3+1))-kappa(health_sim(k,j+(i-1)*3+1)),0.0d0) &
+ med_care_sim(k,j+(i-1)*3+2)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3+2))+beta_m(health_sim(k,j+(i-1)*3+2))*(j+(i-1)*3+2)+gamma_m(health_sim(k,j+(i-1)*3+2))*((j+(i-1)*3+2)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+2))*health_draw_sim(k,j+(i-1)*3+2))-kappa(health_sim(k,j+(i-1)*3+2)),0.0d0) ) &
* (cohort_weight(j+(i-1)*3,n)+cohort_weight(j+(i-1)*3+1,n)+cohort_weight(j+(i-1)*3+2,n))
END IF

ins_status=0


!IF ((hi_sim(k,j+(i-1)*3)==2 .and. hi_sim(k,j+(i-1)*3+1)==2 .and. hi_sim(k,j+(i-1)*3+2)==2) .or. (hi_sim(k,j+(i-1)*3)==1 .and. hi_sim(k,j+(i-1)*3+1)==1 .and. hi_sim(k,j+(i-1)*3+2)==1 .and. ii_sim(k,j+(i-1)*3)==1 .and. ii_sim(k,j+(i-1)*3+1)==1 .and. ii_sim(k,j+(i-1)*3+2)==1)    ) THEN
IF ((hi_sim(k,j+(i-1)*3)==2 ) .or. (hi_sim(k,j+(i-1)*3)==1  .and. ii_sim(k,j+(i-1)*3)==1 )    ) THEN
ins_status=2
!ELSE IF (hi_sim(k,j+(i-1)*3)==1 .and. hi_sim(k,j+(i-1)*3+1)==1 .and. hi_sim(k,j+(i-1)*3+2)==1 .and. ii_sim(k,j+(i-1)*3)==0 .and. ii_sim(k,j+(i-1)*3+1)==0 .and. ii_sim(k,j+(i-1)*3+2)==0) THEN
ELSE IF (hi_sim(k,j+(i-1)*3)==1  .and. ii_sim(k,j+(i-1)*3)==0 ) THEN
ins_status=1

END IF
DO x=1, 2
DO y=1, 2
!IF (health_sim(k,j+(i-1)*3)==x .and. health_sim(k,j+(i-1)*3+1)==x .and. health_sim(k,j+(i-1)*3+2)==x .and. ins_status==y ) THEN
IF (health_sim(k,j+(i-1)*3)==x .and. ins_status==y ) THEN
count_sim_h_hi_c(t,n,y,x)=count_sim_h_hi_c(t,n,y,x)+cohort_weight(j+(i-1)*3,n)+cohort_weight(j+(i-1)*3+1,n)+cohort_weight(j+(i-1)*3+2,n)

IF (y==1) THEN
med_shock=0.0d0
IF (emp_sim(k,j+(i-1)*3)==0) THEN
income=ump_flow
ELSE
income=wage_sim(k,j+(i-1)*3)
END IF
med_shock=med_shock &
+med_care_sim(k,j+(i-1)*3)* &
dmin1(income-cons_floor,   dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3))+beta_m(health_sim(k,j+(i-1)*3))*(j+(i-1)*3)+gamma_m(health_sim(k,j+(i-1)*3))*((j+(i-1)*3)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3))*health_draw_sim(k,j+(i-1)*3))-kappa(health_sim(k,j+(i-1)*3)),0.0d0))

IF (emp_sim(k,j+(i-1)*3+1)==0) THEN
income=ump_flow
ELSE
income=wage_sim(k,j+(i-1)*3+1)
END IF
IF (hi_sim(k,j+(i-1)*3+1)==1  .and. ii_sim(k,j+(i-1)*3+1)==0 ) THEN
med_shock=med_shock &
+med_care_sim(k,j+(i-1)*3+1)* &
dmin1(income-cons_floor, dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3+1))+beta_m(health_sim(k,j+(i-1)*3+1))*(j+(i-1)*3+1)+gamma_m(health_sim(k,j+(i-1)*3+1))*((j+(i-1)*3+1)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+1))*health_draw_sim(k,j+(i-1)*3+1))-kappa(health_sim(k,j+(i-1)*3+1)),0.0d0) )  
ELSE
med_shock=med_shock &
+med_care_sim(k,j+(i-1)*3+1)* &
dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3+1))+beta_m(health_sim(k,j+(i-1)*3+1))*(j+(i-1)*3+1)+gamma_m(health_sim(k,j+(i-1)*3+1))*((j+(i-1)*3+1)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+1))*health_draw_sim(k,j+(i-1)*3+1))-kappa(health_sim(k,j+(i-1)*3+1)),0.0d0) 
END IF

IF (emp_sim(k,j+(i-1)*3+2)==0) THEN
income=ump_flow
ELSE
income=wage_sim(k,j+(i-1)*3+2)
END IF
IF (hi_sim(k,j+(i-1)*3+2)==1  .and. ii_sim(k,j+(i-1)*3+2)==0 ) THEN
med_shock=med_shock &
+med_care_sim(k,j+(i-1)*3+2)* &
dmin1(income-cons_floor, dmax1(exp(eta1_m(ind_type_sim(k))+alpha_m(health_sim(k,j+(i-1)*3+2))+beta_m(health_sim(k,j+(i-1)*3+2))*(j+(i-1)*3+2)+gamma_m(health_sim(k,j+(i-1)*3+2))*((j+(i-1)*3+2)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+2))*health_draw_sim(k,j+(i-1)*3+2))-kappa(health_sim(k,j+(i-1)*3+2)),0.0d0) ) 
ELSE
med_shock=med_shock &
+med_care_sim(k,j+(i-1)*3+2)* &
dmax1(exp(eta1_m(ind_type_sim(k))+alpha_m(health_sim(k,j+(i-1)*3+2))+beta_m(health_sim(k,j+(i-1)*3+2))*(j+(i-1)*3+2)+gamma_m(health_sim(k,j+(i-1)*3+2))*((j+(i-1)*3+2)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+2))*health_draw_sim(k,j+(i-1)*3+2))-kappa(health_sim(k,j+(i-1)*3+2)),0.0d0) 
END IF


med_exp_h_hi_c(t,n,y,x)=med_exp_h_hi_c(t,n,y,x)+med_shock*(cohort_weight(j+(i-1)*3,n)+cohort_weight(j+(i-1)*3+1,n)+cohort_weight(j+(i-1)*3+2,n))

ELSE


med_exp_h_hi_c(t,n,y,x)=med_exp_h_hi_c(t,n,y,x) &
+(med_care_sim(k,j+(i-1)*3)* &
dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3))+beta_m(health_sim(k,j+(i-1)*3))*(j+(i-1)*3)+gamma_m(health_sim(k,j+(i-1)*3))*((j+(i-1)*3)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3))*health_draw_sim(k,j+(i-1)*3))-kappa(health_sim(k,j+(i-1)*3)),0.0d0) &
+ med_care_sim(k,j+(i-1)*3+1)* &
dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3+1))+beta_m(health_sim(k,j+(i-1)*3+1))*(j+(i-1)*3+1)+gamma_m(health_sim(k,j+(i-1)*3+1))*((j+(i-1)*3+1)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+1))*health_draw_sim(k,j+(i-1)*3+1))-kappa(health_sim(k,j+(i-1)*3+1)),0.0d0) &
+ med_care_sim(k,j+(i-1)*3+2)* &
dmax1(exp(eta1_m(ind_type_sim(k))+alpha_m(health_sim(k,j+(i-1)*3+2))+beta_m(health_sim(k,j+(i-1)*3+2))*(j+(i-1)*3+2)+gamma_m(health_sim(k,j+(i-1)*3+2))*((j+(i-1)*3+2)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+2))*health_draw_sim(k,j+(i-1)*3+2))-kappa(health_sim(k,j+(i-1)*3+2)),0.0d0) ) &
* (cohort_weight(j+(i-1)*3,n)+cohort_weight(j+(i-1)*3+1,n)+cohort_weight(j+(i-1)*3+2,n))


END IF


IF (cohort_weight(j+(i-1)*3,n)*med_care_sim(k,j+(i-1)*3)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3))+beta_m(health_sim(k,j+(i-1)*3))*(j+(i-1)*3)+gamma_m(x)*((j+(i-1)*3)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3))*health_draw_sim(k,j+(i-1)*3))-kappa(health_sim(k,j+(i-1)*3)),0.0d0) &
+ cohort_weight(j+(i-1)*3+1,n)*med_care_sim(k,j+(i-1)*3+1)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3+1))+beta_m(health_sim(k,j+(i-1)*3+1))*(j+(i-1)*3+1)+gamma_m(x)*((j+(i-1)*3+1)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+1))*health_draw_sim(k,j+(i-1)*3+1))-kappa(health_sim(k,j+(i-1)*3+1)),0.0d0) &
+ cohort_weight(j+(i-1)*3+2,n)*med_care_sim(k,j+(i-1)*3+2)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3+2))+beta_m(health_sim(k,j+(i-1)*3+2))*(j+(i-1)*3+2)+gamma_m(health_sim(k,j+(i-1)*3+2))*((j+(i-1)*3+2)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+2))*health_draw_sim(k,j+(i-1)*3+2))-kappa(health_sim(k,j+(i-1)*3+2)),0.0d0)>0.0d0 ) THEN
        positive_h_hi_c(t,n,y,x)=positive_h_hi_c(t,n,y,x)+cohort_weight(j+(i-1)*3,n)+cohort_weight(j+(i-1)*3+1,n)+cohort_weight(j+(i-1)*3+2,n)
END IF    
END IF
END DO
END DO

END IF
END DO

END DO !i





med_exp_h_c(t,n)=med_exp_h_c(t,n)/count_med_c(1, t, n)
med_exp_u_c(t,n)=med_exp_u_c(t,n)/count_med_c(2, t, n)
DO x=1, 2
DO y=1, 2
med_exp_h_hi_c(t,n,y,x)=med_exp_h_hi_c(t,n,y,x)/count_sim_h_hi_c(t,n,y,x)

positive_h_hi_c(t,n,y,x)=positive_h_hi_c(t,n,y,x)/count_sim_h_hi_c(t,n,y,x)
END DO
END DO



! standard deviation
IF (t==1) THEN
band=15
ELSE IF (t==2) THEN
j=68
band=10

ELSE IF (t==3) THEN
j=99
band=10
END IF
! t=1


DO i=1, band


DO k=1, num_sim

IF (ed_sim(k)==n) THEN

IF (health_sim(k,j+(i-1)*3)==1 .and. health_sim(k,j+(i-1)*3+1)==1 .and. health_sim(k,j+(i-1)*3+2)==1 ) THEN
std_med_exp_h_c(t,n)=std_med_exp_h_c(t,n)+(med_care_sim(k,j+(i-1)*3)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3))+beta_m(health_sim(k,j+(i-1)*3))*(j+(i-1)*3)+gamma_m(health_sim(k,j+(i-1)*3))*((j+(i-1)*3)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3))*health_draw_sim(k,j+(i-1)*3))-kappa(health_sim(k,j+(i-1)*3)),0.0d0) &
+ med_care_sim(k,j+(i-1)*3+1)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3+1))+beta_m(health_sim(k,j+(i-1)*3+1))*(j+(i-1)*3+1)+gamma_m(health_sim(k,j+(i-1)*3+1))*((j+(i-1)*3+1)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+1))*health_draw_sim(k,j+(i-1)*3+1))-kappa(health_sim(k,j+(i-1)*3+1)),0.0d0) &
+ med_care_sim(k,j+(i-1)*3+2)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3+2))+beta_m(health_sim(k,j+(i-1)*3+2))*(j+(i-1)*3+2)+gamma_m(health_sim(k,j+(i-1)*3+2))*((j+(i-1)*3+2)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+2))*health_draw_sim(k,j+(i-1)*3+2))-kappa(health_sim(k,j+(i-1)*3+2)),0.0d0)- &
-med_exp_h_c(t,n))**2.0d0*(cohort_weight(j+(i-1)*3,n)+cohort_weight(j+(i-1)*3+1,n)+cohort_weight(j+(i-1)*3+2,n))
END IF

IF (health_sim(k,j+(i-1)*3)==2 .and. health_sim(k,j+(i-1)*3+1)==2 .and. health_sim(k,j+(i-1)*3+2)==2 ) THEN
std_med_exp_u_c(t,n)=std_med_exp_u_c(t,n)+(med_care_sim(k,j+(i-1)*3)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3))+beta_m(health_sim(k,j+(i-1)*3))*(j+(i-1)*3)+gamma_m(health_sim(k,j+(i-1)*3))*((j+(i-1)*3)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3))*health_draw_sim(k,j+(i-1)*3))-kappa(health_sim(k,j+(i-1)*3)),0.0d0) &
+ med_care_sim(k,j+(i-1)*3+1)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3+1))+beta_m(health_sim(k,j+(i-1)*3+1))*(j+(i-1)*3+1)+gamma_m(health_sim(k,j+(i-1)*3+1))*((j+(i-1)*3+1)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+1))*health_draw_sim(k,j+(i-1)*3+1))-kappa(health_sim(k,j+(i-1)*3+1)),0.0d0) &
+ med_care_sim(k,j+(i-1)*3+2)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3+2))+beta_m(health_sim(k,j+(i-1)*3+2))*(j+(i-1)*3+2)+gamma_m(health_sim(k,j+(i-1)*3+2))*((j+(i-1)*3+2)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+2))*health_draw_sim(k,j+(i-1)*3+2))-kappa(health_sim(k,j+(i-1)*3+2)),0.0d0)- &
-med_exp_u_c(t,n))**2.0d0*(cohort_weight(j+(i-1)*3,n)+cohort_weight(j+(i-1)*3+1,n)+cohort_weight(j+(i-1)*3+2,n))
END IF

ins_status=0

!IF ((hi_sim(k,j+(i-1)*3)==2 .and. hi_sim(k,j+(i-1)*3+1)==2 .and. hi_sim(k,j+(i-1)*3+2)==2) .or. (hi_sim(k,j+(i-1)*3)==1 .and. hi_sim(k,j+(i-1)*3+1)==1 .and. hi_sim(k,j+(i-1)*3+2)==1 .and. ii_sim(k,j+(i-1)*3)==1 .and. ii_sim(k,j+(i-1)*3+1)==1 .and. ii_sim(k,j+(i-1)*3+2)==1)    ) THEN
!ins_status=2
!ELSE IF (hi_sim(k,j+(i-1)*3)==1 .and. hi_sim(k,j+(i-1)*3+1)==1 .and. hi_sim(k,j+(i-1)*3+2)==1 .and. ii_sim(k,j+(i-1)*3)==0 .and. ii_sim(k,j+(i-1)*3+1)==0 .and. ii_sim(k,j+(i-1)*3+2)==0) THEN
!ins_status=1
!END IF
!DO x=1, 2
!DO y=1, 2
!IF (health_sim(k,j+(i-1)*3)==x .and. health_sim(k,j+(i-1)*3+1)==x .and. health_sim(k,j+(i-1)*3+2)==x .and. ins_status==y) THEN
!std_med_exp_h_hi_c(t,n,y,x)=std_med_exp_h_hi_c(t,n,y,x)+(med_care_sim(k,j+(i-1)*3)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3))+beta_m(health_sim(k,j+(i-1)*3))*(j+(i-1)*3)+gamma_m(health_sim(k,j+(i-1)*3))*((j+(i-1)*3)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3))*health_draw_sim(k,j+(i-1)*3))-kappa(health_sim(k,j+(i-1)*3)),0.0d0) &
!+ med_care_sim(k,j+(i-1)*3+1)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3+1))+beta_m(health_sim(k,j+(i-1)*3+1))*(j+(i-1)*3+1)+gamma_m(health_sim(k,j+(i-1)*3+1))*((j+(i-1)*3+1)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+1))*health_draw_sim(k,j+(i-1)*3+1))-kappa(health_sim(k,j+(i-1)*3+1)),0.0d0) &
!+ med_care_sim(k,j+(i-1)*3+2)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3+2))+beta_m(health_sim(k,j+(i-1)*3+2))*(j+(i-1)*3+2)+gamma_m(health_sim(k,j+(i-1)*3+2))*((j+(i-1)*3+2)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+2))*health_draw_sim(k,j+(i-1)*3+2))-kappa(health_sim(k,j+(i-1)*3+2)),0.0d0)- &
!-med_exp_h_hi_c(t,n,y,x))**2.0d0*(cohort_weight(j+(i-1)*3,n)+cohort_weight(j+(i-1)*3+1,n)+cohort_weight(j+(i-1)*3+2,n))
!
!END IF
!END DO
!END DO

IF ((hi_sim(k,j+(i-1)*3)==2) .or. (hi_sim(k,j+(i-1)*3)==1  .and. ii_sim(k,j+(i-1)*3)==1 )    ) THEN
ins_status=2
ELSE IF (hi_sim(k,j+(i-1)*3)==1  .and. ii_sim(k,j+(i-1)*3)==0 ) THEN
ins_status=1
END IF
DO x=1, 2
DO y=1, 2
IF (health_sim(k,j+(i-1)*3)==x .and. ins_status==y) THEN

IF (y==1) THEN
med_shock=0.0d0
IF (emp_sim(k,j+(i-1)*3)==0) THEN
income=ump_flow
ELSE
income=wage_sim(k,j+(i-1)*3)
END IF
med_shock=med_shock &
+med_care_sim(k,j+(i-1)*3)* &
dmin1(income-cons_floor,   dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3))+beta_m(health_sim(k,j+(i-1)*3))*(j+(i-1)*3)+gamma_m(health_sim(k,j+(i-1)*3))*((j+(i-1)*3)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3))*health_draw_sim(k,j+(i-1)*3))-kappa(health_sim(k,j+(i-1)*3)),0.0d0))

IF (emp_sim(k,j+(i-1)*3+1)==0) THEN
income=ump_flow
ELSE
income=wage_sim(k,j+(i-1)*3+1)
END IF
IF (hi_sim(k,j+(i-1)*3+1)==1  .and. ii_sim(k,j+(i-1)*3+1)==0 ) THEN
med_shock=med_shock &
+med_care_sim(k,j+(i-1)*3+1)* &
dmin1(income-cons_floor, dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3+1))+beta_m(health_sim(k,j+(i-1)*3+1))*(j+(i-1)*3+1)+gamma_m(health_sim(k,j+(i-1)*3+1))*((j+(i-1)*3+1)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+1))*health_draw_sim(k,j+(i-1)*3+1))-kappa(health_sim(k,j+(i-1)*3+1)),0.0d0) )  
ELSE
med_shock=med_shock &
+med_care_sim(k,j+(i-1)*3+1)* &
dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3+1))+beta_m(health_sim(k,j+(i-1)*3+1))*(j+(i-1)*3+1)+gamma_m(health_sim(k,j+(i-1)*3+1))*((j+(i-1)*3+1)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+1))*health_draw_sim(k,j+(i-1)*3+1))-kappa(health_sim(k,j+(i-1)*3+1)),0.0d0) 
END IF

IF (emp_sim(k,j+(i-1)*3+2)==0) THEN
income=ump_flow
ELSE
income=wage_sim(k,j+(i-1)*3+2)
END IF
IF (hi_sim(k,j+(i-1)*3+2)==1  .and. ii_sim(k,j+(i-1)*3+2)==0 ) THEN
med_shock=med_shock &
+med_care_sim(k,j+(i-1)*3+2)* &
dmin1(income-cons_floor, dmax1(exp(eta1_m(ind_type_sim(k))+alpha_m(health_sim(k,j+(i-1)*3+2))+beta_m(health_sim(k,j+(i-1)*3+2))*(j+(i-1)*3+2)+gamma_m(health_sim(k,j+(i-1)*3+2))*((j+(i-1)*3+2)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+2))*health_draw_sim(k,j+(i-1)*3+2))-kappa(health_sim(k,j+(i-1)*3+2)),0.0d0) ) 
ELSE
med_shock=med_shock &
+med_care_sim(k,j+(i-1)*3+2)* &
dmax1(exp(eta1_m(ind_type_sim(k))+alpha_m(health_sim(k,j+(i-1)*3+2))+beta_m(health_sim(k,j+(i-1)*3+2))*(j+(i-1)*3+2)+gamma_m(health_sim(k,j+(i-1)*3+2))*((j+(i-1)*3+2)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+2))*health_draw_sim(k,j+(i-1)*3+2))-kappa(health_sim(k,j+(i-1)*3+2)),0.0d0) 
END IF


std_med_exp_h_hi_c(t,n,y,x)=std_med_exp_h_hi_c(t,n,y,x)+(med_shock-med_exp_h_hi_c(t,n,y,x))**2.0d0*(cohort_weight(j+(i-1)*3,n)+cohort_weight(j+(i-1)*3+1,n)+cohort_weight(j+(i-1)*3+2,n))



ELSE
std_med_exp_h_hi_c(t,n,y,x)=std_med_exp_h_hi_c(t,n,y,x)+(med_care_sim(k,j+(i-1)*3)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3))+beta_m(health_sim(k,j+(i-1)*3))*(j+(i-1)*3)+gamma_m(health_sim(k,j+(i-1)*3))*((j+(i-1)*3)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3))*health_draw_sim(k,j+(i-1)*3))-kappa(health_sim(k,j+(i-1)*3)),0.0d0) &
+ med_care_sim(k,j+(i-1)*3+1)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3+1))+beta_m(health_sim(k,j+(i-1)*3+1))*(j+(i-1)*3+1)+gamma_m(health_sim(k,j+(i-1)*3+1))*((j+(i-1)*3+1)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+1))*health_draw_sim(k,j+(i-1)*3+1))-kappa(health_sim(k,j+(i-1)*3+1)),0.0d0) &
+ med_care_sim(k,j+(i-1)*3+2)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3+2))+beta_m(health_sim(k,j+(i-1)*3+2))*(j+(i-1)*3+2)+gamma_m(health_sim(k,j+(i-1)*3+2))*((j+(i-1)*3+2)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+2))*health_draw_sim(k,j+(i-1)*3+2))-kappa(health_sim(k,j+(i-1)*3+2)),0.0d0)- &
-med_exp_h_hi_c(t,n,y,x))**2.0d0*(cohort_weight(j+(i-1)*3,n)+cohort_weight(j+(i-1)*3+1,n)+cohort_weight(j+(i-1)*3+2,n))
END IF



END IF
END DO
END DO



END IF !education
END DO ! simulation

END DO !i


std_med_exp_h_c(t,n)=(std_med_exp_h_c(t,n)/count_med_c(1, t, n))**0.50d0
std_med_exp_u_c(t,n)=(std_med_exp_u_c(t,n)/count_med_c(2, t, n))**0.50d0

DO x=1, 2
DO y=1, 2
std_med_exp_h_hi_c(t,n,y,x)=(std_med_exp_h_hi_c(t,n,y,x)/count_sim_h_hi_c(t,n,y,x))**0.50d0
END DO
END DO





END DO !t for med

!health composition
denom=0.0d0
health_hi_sim(n)=0.0d0
health_nhi_sim(n)=0.0d0
health_unemp_sim(n)=0.0d0
health_ii_sim(n)=0.0d0
health_unins_sim(n)=0.0d0


health_hi_sim_denom(n)=0.0d0
health_nhi_sim_denom(n)=0.0d0
health_unemp_sim_denom(n)=0.0d0
health_ii_sim_denom(n)=0.0d0
health_unins_sim_denom(n)=0.0d0

DO t=19, num_period-6
DO k=1, num_sim

IF (ed_sim(k)==n) THEN

IF (emp_sim(k, t)==1 .and. hi_sim(k, t)==2 ) THEN
health_hi_sim_denom(n)=health_hi_sim_denom(n)+cohort_weight(t,n)
IF (health_sim(k, t)==1) THEN
health_hi_sim(n)=health_hi_sim(n)+cohort_weight(t,n)
END IF
END IF

IF (emp_sim(k, t)==1 .and. hi_sim(k, t)==1 ) THEN
health_nhi_sim_denom(n)=health_nhi_sim_denom(n)+cohort_weight(t,n)
IF (health_sim(k, t)==1) THEN
health_nhi_sim(n)=health_nhi_sim(n)+cohort_weight(t,n)
END IF
END IF

IF (emp_sim(k, t)==0 ) THEN
health_unemp_sim_denom(n)=health_unemp_sim_denom(n)+cohort_weight(t,n)
IF (health_sim(k, t)==1) THEN
health_unemp_sim(n)=health_unemp_sim(n)+cohort_weight(t,n)
END IF
END IF


IF (ii_sim(k, t)==1 .and. ((emp_sim(k,t)==1 .and. hi_sim(k,t)==1) .or. emp_sim(k,t)==0)  ) THEN
health_ii_sim_denom(n)=health_ii_sim_denom(n)+cohort_weight(t,n)
IF (health_sim(k, t)==1) THEN
health_ii_sim(n)=health_ii_sim(n)+cohort_weight(t,n)
END IF
END IF

IF (ii_sim(k, t)==0 .and. ((emp_sim(k,t)==1 .and. hi_sim(k,t)==1) .or. emp_sim(k,t)==0)  ) THEN
health_unins_sim_denom(n)=health_unins_sim_denom(n)+cohort_weight(t,n)
IF (health_sim(k, t)==1) THEN
health_unins_sim(n)=health_unins_sim(n)+cohort_weight(t,n)
END IF
END IF

END IF !education
END DO ! simulation


END DO

health_hi_sim(n)=health_hi_sim(n)/health_hi_sim_denom(n)
health_nhi_sim(n)=health_nhi_sim(n)/health_nhi_sim_denom(n)
health_unemp_sim(n)=health_unemp_sim(n)/health_unemp_sim_denom(n)

health_ii_sim(n)=health_ii_sim(n)/health_ii_sim_denom(n)

health_unins_sim(n)=health_unins_sim(n)/health_unins_sim_denom(n)

!end of education
END DO !n

! aggregate medical expenditure    
DO t=1, 3

DO x=1, 2
DO y=1, 2
sim_med_exp_sample_h_hi_1(t,x,y)=0.0d0
sim_count_sample_h_hi_1(t,x,y)=0.0d0
sim_positive_sample_h_hi_1(t,x,y)=0.0d0
END DO
END DO

DO x=1, 2
DO y=1, 2
DO n=1, 2
sim_med_exp_sample_h_hi_1(t,x,y)=sim_med_exp_sample_h_hi_1(t,x,y)+med_exp_h_hi_c(t,n,x,y)*count_sim_h_hi_c(t,n,x,y)
sim_count_sample_h_hi_1(t,x,y)=sim_count_sample_h_hi_1(t,x,y)+count_sim_h_hi_c(t,n,x,y)
sim_positive_sample_h_hi_1(t,x,y)=sim_positive_sample_h_hi_1(t,x,y)+positive_h_hi_c(t,n,x,y)*count_sim_h_hi_c(t,n,x,y)
END DO
sim_med_exp_sample_h_hi_1(t,x,y)=sim_med_exp_sample_h_hi_1(t,x,y)/sim_count_sample_h_hi_1(t,x,y)
sim_positive_sample_h_hi_1(t,x,y)=sim_positive_sample_h_hi_1(t,x,y)/sim_count_sample_h_hi_1(t,x,y)

END DO
END DO

! calculate standard error
 

IF (t==1) THEN
j=22
band=15
ELSE IF (t==2) THEN
j=68
band=10

ELSE IF (t==3) THEN
j=99
band=10
END IF
! t=1


DO i=1, band

DO n=1, num_ed

DO k=1, num_sim
IF (ed_sim(k)==n) THEN

ins_status=0

IF ((hi_sim(k,j+(i-1)*3)==2 .and. hi_sim(k,j+(i-1)*3+1)==2 .and. hi_sim(k,j+(i-1)*3+2)==2) .or. (hi_sim(k,j+(i-1)*3)==1 .and. hi_sim(k,j+(i-1)*3+1)==1 .and. hi_sim(k,j+(i-1)*3+2)==1 .and. ii_sim(k,j+(i-1)*3)==1 .and. ii_sim(k,j+(i-1)*3+1)==1 .and. ii_sim(k,j+(i-1)*3+2)==1)    ) THEN
ins_status=2
ELSE IF (hi_sim(k,j+(i-1)*3)==1 .and. hi_sim(k,j+(i-1)*3+1)==1 .and. hi_sim(k,j+(i-1)*3+2)==1 .and. ii_sim(k,j+(i-1)*3)==0 .and. ii_sim(k,j+(i-1)*3+1)==0 .and. ii_sim(k,j+(i-1)*3+2)==0) THEN
ins_status=1
END IF
DO x=1, 2
DO y=1, 2
IF (health_sim(k,j+(i-1)*3)==x .and. health_sim(k,j+(i-1)*3+1)==x .and. health_sim(k,j+(i-1)*3+2)==x .and. ins_status==y) THEN
sim_std_med_exp_sample_h_hi_1(t,y,x)=sim_std_med_exp_sample_h_hi_1(t,y,x)+(med_care_sim(k,j+(i-1)*3)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3))+beta_m(health_sim(k,j+(i-1)*3))*j+gamma_m(health_sim(k,j+(i-1)*3))*(j**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3))*health_draw_sim(k,j+(i-1)*3))-kappa(health_sim(k,j+(i-1)*3)),0.0d0) &
+ med_care_sim(k,j+(i-1)*3+1)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3+1))+beta_m(health_sim(k,j+(i-1)*3+1))*j+gamma_m(health_sim(k,j+(i-1)*3+1))*((j+1)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+1))*health_draw_sim(k,j+(i-1)*3+1))-kappa(health_sim(k,j+(i-1)*3+1)),0.0d0) &
+ med_care_sim(k,j+(i-1)*3+2)*dmax1(exp(eta1_m(ind_type_sim(k))+ alpha_m(health_sim(k,j+(i-1)*3+2))+beta_m(health_sim(k,j+(i-1)*3+2))*j+gamma_m(health_sim(k,j+(i-1)*3+2))*((j+2)**2.0d0)+eta2_m(ind_type_sim(k))*sigma_m(health_sim(k,j+(i-1)*3+2))*health_draw_sim(k,j+(i-1)*3+2))-kappa(health_sim(k,j+(i-1)*3+2)),0.0d0)- &
-sim_med_exp_sample_h_hi_1(t,y,x))**2.0d0*(cohort_weight(j+(i-1)*3,n)+cohort_weight(j+(i-1)*3+1,n)+cohort_weight(j+(i-1)*3+2,n))

END IF
END DO
END DO

END IF
END DO !k 

END DO !n

END DO !i

DO x=1, 2
DO y=1, 2
sim_std_med_exp_sample_h_hi_1(t,y,x)=(sim_std_med_exp_sample_h_hi_1(t,y,x)/sim_count_sample_h_hi_1(t,y,x))**0.50d0

END DO
END DO

END DO ! t

IF (data_mode==2) THEN 

OPEN(100, file="emp_rate.txt")
DO t=1, num_period
DO n=1, 2
 write(100, *) emp_rate(t,n)
END DO 
END DO
CLOSE (100)

END IF



DO i=1, num_firm
firm_age(i)=0.0d0
DO work_exp=1, num_exp
DO hi_type=1, 2
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
DO t=1, num_period-9
firm_age(i)=firm_age(i)+t*emp_dist(ind_type, ed_type, health_type, hi_type, i,work_exp, t)
END DO
END DO
END DO
END DO
END DO
END DO
firm_age(i)=firm_age(i)/sum(emp_dist(:, :, :, :, i,:, 1:num_period-9))
END DO

!OPEN(100, file="firm_age.txt")
!DO i=1, num_firm
! write(100, *) firm_age(i), firm_prod(i)
!END DO 
!CLOSE (100)



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
IF (data_mode==2) THEN 

! record moment_coparsion

OPEN(100, file="sim_takeup.txt")
DO n=1, 2
DO t=1, 5
 write(100, *) takeup_c(t,n)
END DO 
END DO
CLOSE (100)


OPEN(100, file="sim_std_wage_hi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) std_wage_hi_sample(t,n), std_wage_average_hi_c(t,n)
END DO 
END DO
CLOSE (100)

OPEN(100, file="sim_std_wage_nhi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) std_wage_nhi_sample(t,n), std_wage_average_nhi_c(t,n)
END DO 
END DO
CLOSE (100)


OPEN(100, file="sim_ue_hi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) ue_hi_sample(t,n), ue_hi_c(t,n)
END DO 
END DO
CLOSE (100)

OPEN(100, file="sim_ue_nhi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) ue_nhi_sample(t,n), ue_nhi_c(t,n)
END DO 
END DO
CLOSE (100)
    
OPEN(100, file="sim_eu.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) eu_sample(t,n), eu_c(t,n)
END DO 
END DO
CLOSE (100)
    
OPEN(100, file="sim_jj.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) jj_sample(t,n), jj_rate_c(t,n)
END DO 
END DO
CLOSE (100)    

OPEN(100, file="sim_jj_hihi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) jj_hihi_sample(t,n), jj_hihi_c(t,n)
END DO 
END DO
CLOSE (100)    

OPEN(100, file="sim_jj_nhihi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) jj_nhihi_sample(t,n), jj_nhihi_c(t,n)
END DO 
END DO
CLOSE (100)    

OPEN(100, file="sim_jj_hinhi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) jj_hinhi_sample(t,n), jj_hinhi_c(t,n)
END DO
END DO 
CLOSE (100)    

OPEN(100, file="sim_jj_nhinhi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) jj_nhinhi_sample(t,n), jj_nhinhi_c(t,n)
END DO
END DO 
CLOSE (100)    


OPEN(100, file="sim_wage_change_jj_hihi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) wage_change_jj_hihi_sample(t,n), wage_jj_hihi_c(t,n)
END DO 
END DO
CLOSE (100)    

OPEN(100, file="sim_wage_change_jj_nhihi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) wage_change_jj_nhihi_sample(t,n), wage_jj_nhihi_c(t,n)
END DO 
END DO
CLOSE (100)    

OPEN(100, file="sim_wage_change_jj_hinhi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) wage_change_jj_hinhi_sample(t,n), wage_jj_hinhi_c(t,n)
END DO 
END DO
CLOSE (100)    

OPEN(100, file="sim_wage_change_jj_nhinhi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) wage_change_jj_nhinhi_sample(t,n), wage_jj_nhinhi_c(t,n)
END DO 
END DO
CLOSE (100)


OPEN(100, file="sim_wage_change_stay_hi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) wage_change_stay_hi_sample(t,n), wage_stay_hi_c(t,n)
END DO
END DO 
CLOSE (100)

OPEN(100, file="sim_wage_change_stay_nhi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) wage_change_stay_nhi_sample(t,n), wage_stay_nhi_c(t,n)
END DO
END DO 
CLOSE (100)

OPEN(100, file="sim_wage_ue_hi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) wage_ue_hi_sample(t,n), wage_ue_hi_c(t,n)
END DO
END DO 
CLOSE (100)

OPEN(100, file="sim_wage_ue_nhi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) wage_ue_nhi_sample(t,n), wage_ue_nhi_c(t,n)
END DO 
END DO
CLOSE (100)


OPEN(100, file="sim_std_wage_change_jj_hihi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) std_wage_change_jj_hihi_sample(t,n), std_wage_jj_hihi_c(t,n)
END DO 
END DO
CLOSE (100)    

OPEN(100, file="sim_std_wage_change_jj_nhihi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) std_wage_change_jj_nhihi_sample(t,n), std_wage_jj_nhihi_c(t,n)
END DO 
END DO
CLOSE (100)    

OPEN(100, file="sim_std_wage_change_jj_hinhi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) std_wage_change_jj_hinhi_sample(t,n), std_wage_jj_hinhi_c(t,n)
END DO
END DO 
CLOSE (100)    

OPEN(100, file="sim_std_wage_change_jj_nhinhi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) std_wage_change_jj_nhinhi_sample(t,n), std_wage_jj_nhinhi_c(t,n)
END DO 
END DO
CLOSE (100)

OPEN(100, file="sim_std_wage_change_stay_hi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) std_wage_change_stay_hi_sample(t,n), std_wage_stay_hi_c(t,n)
END DO 
END DO
CLOSE (100)

OPEN(100, file="sim_std_wage_change_stay_nhi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) std_wage_change_stay_nhi_sample(t,n), std_wage_stay_nhi_c(t,n)
END DO 
END DO
CLOSE (100)

OPEN(100, file="sim_std_wage_ue_hi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) std_wage_ue_hi_sample(t,n), std_wage_ue_hi_c(t,n)
END DO 
END DO
CLOSE (100)

OPEN(100, file="sim_std_wage_ue_nhi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) std_wage_ue_nhi_sample(t,n), std_wage_ue_nhi_c(t,n)
END DO
END DO 
CLOSE (100)

OPEN(100, file="sim_health.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) health_sample(t,n), health_c(t,n)
END DO
END DO 
CLOSE (100)

OPEN(100, file="sim_health_transition_hh.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) health_transition_hh_sample(t,n), health_transit_hh_c(t,n)
END DO
END DO 
CLOSE (100)

OPEN(100, file="sim_health_transition_uu.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) health_transition_uu_sample(t,n), health_transit_uu_c(t,n)
END DO 
END DO
CLOSE (100)

OPEN(100, file="sim_med_exp_sample_h.txt")
DO n=1, 2
DO t=1, 3

 write(100, *) med_exp_sample_h_sample(t,n), med_exp_h_c(t,n)
END DO
END DO 
CLOSE (100)

OPEN(100, file="sim_med_exp_sample_u.txt")
DO n=1, 2
DO t=1, 3

 write(100, *) med_exp_sample_u_sample(t,n), med_exp_u_c(t,n)
END DO
END DO 
CLOSE (100)

OPEN(100, file="sim_med_exp_all.txt")
DO n=1, 2
DO t=1, 3
 write(100, *) med_exp_sample_h_hi(t,n,1,1), med_exp_h_hi_c(t,n,1,1)
END DO
END DO
DO n=1, 2
DO t=1, 3
 write(100, *) med_exp_sample_h_hi(t,n,2,1), med_exp_h_hi_c(t,n,2,1)
END DO
END DO
DO n=1, 2
DO t=1, 3
 write(100, *) med_exp_sample_h_hi(t,n,1,2), med_exp_h_hi_c(t,n,1,2)
END DO
END DO
DO n=1, 2
DO t=1, 3
 write(100, *) med_exp_sample_h_hi(t,n,2,2), med_exp_h_hi_c(t,n,2,2)
END DO
END DO    
CLOSE (100)

OPEN(100, file="sim_std_med_exp_all.txt")
DO n=1, 2
DO t=1, 3
 write(100, *) std_med_exp_sample_h_hi(t,n,1,1), std_med_exp_h_hi_c(t,n,1,1)
END DO
END DO
DO n=1, 2
DO t=1, 3
 write(100, *) std_med_exp_sample_h_hi(t,n,2,1), std_med_exp_h_hi_c(t,n,2,1)
END DO
END DO
DO n=1, 2
DO t=1, 3
 write(100, *) std_med_exp_sample_h_hi(t,n,1,2), std_med_exp_h_hi_c(t,n,1,2)
END DO
END DO
DO n=1, 2
DO t=1, 3
 write(100, *) std_med_exp_sample_h_hi(t,n,2,2), std_med_exp_h_hi_c(t,n,2,2)
END DO
END DO    
CLOSE (100)

OPEN(100, file="sim_positive_med_expense_all.txt")
DO n=1, 2
DO t=1, 3
 write(100, *) positive_sample_h_hi(t,n,1,1), positive_h_hi_c(t,n,1,1)
END DO
END DO
DO n=1, 2
DO t=1, 3
 write(100, *) positive_sample_h_hi(t,n,2,1), positive_h_hi_c(t,n,2,1)
END DO
END DO
DO n=1, 2
DO t=1, 3
 write(100, *) positive_sample_h_hi(t,n,1,2), positive_h_hi_c(t,n,1,2)
END DO
END DO
DO n=1, 2
DO t=1, 3
 write(100, *) positive_sample_h_hi(t,n,2,2), positive_h_hi_c(t,n,2,2)
END DO
END DO    
CLOSE (100)




OPEN(100, file="sim_std_med_exp_sample_h.txt")
DO n=1, 2
DO t=1, 3

 write(100, *) std_med_exp_sample_h_sample(t,n), std_med_exp_h_c(t,n)
END DO 
END DO
CLOSE (100)

OPEN(100, file="sim_std_med_exp_sample_u.txt")
DO n=1, 2
DO t=1, 3
 write(100, *) std_med_exp_sample_u_sample(t,n), std_med_exp_u_c(t,n)
END DO
END DO 
CLOSE (100)

OPEN(100, file="sim_health_hi.txt")
DO n=1, 2
 write(100, *) health_hi(n), health_hi_sim(n)
END DO
CLOSE (100)

OPEN(100, file="sim_health_nhi.txt")
DO n=1, 2
 write(100, *) health_nhi(n), health_nhi_sim(n)
END DO
CLOSE (100)

OPEN(100, file="sim_health_unemp.txt")
DO n=1, 2
 write(100, *) health_unemp(n), health_unemp_sim(n)
END DO
CLOSE (100)

!OPEN(100, file="productivity.txt")
!write(100, *) productivity
!CLOSE (100)

OPEN(100, file="emp_hinsured_c.txt")
DO t=1, 5
write(100, *) emp_hinsured_c(t,1), emp_hinsured_c(t,2)
END DO 
CLOSE (100)





OPEN(100, file="sim_health_comparison.txt")
DO n=1, 2
 write(100, *) health_hi_sim(n), health_ii_sim(n), health_unins_sim(n)
END DO
CLOSE (100)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

OPEN(100, file="sim_ump_rate.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) ump_rate_sample(t,n), ump_rate_c(t,n)
END DO
END DO
 
CLOSE (100)


OPEN(100, file="sim_eshi_rate.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) eshi_rate_sample(t,n), eshi_rate_c(t,n)
END DO 
END DO

CLOSE (100)

OPEN(100, file="sim_ii_rate.txt")
DO n=1, 2
DO t=1, 5
! write(100, *) ii_rate_sample(t,n), ii_rate_c(t,n)
write(100, *) ii_rate_all_sample(t,n), ii_rate_c(t,n)
END DO 
END DO

CLOSE (100)

OPEN(100, file="sim_ii_u_rate.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) ii_u_rate_sample(t,n), ii_u_rate_c(t,n)
END DO 
END DO

CLOSE (100)




OPEN(100, file="sim_wage_hi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) wage_hi_sample(t,n), wage_average_hi_c(t,n)
END DO 
END DO
CLOSE (100)

OPEN(100, file="sim_wage_average.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) wage_average_sample(t,n), wage_average_c(t,n)
END DO 
END DO
CLOSE (100)

OPEN(100, file="sim_wage_nhi.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) wage_nhi_sample(t,n), wage_average_nhi_c(t,n)
END DO 
END DO
CLOSE (100)

OPEN(100, file="sim_wage_ii.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) wage_ii_sample(t,n), wage_average_ii_c(t,n)
END DO 
END DO
CLOSE (100)

OPEN(100, file="sim_quality.txt")
DO n=1, 2
DO t=1, 5

 write(100, *) quality1(t,n),quality2(t,n)
END DO 
END DO
CLOSE (100)


OPEN(100, file="ag_sim_med_exp_all.txt")
DO t=1, 3
 write(100, *) med_exp_sample_h_hi_1(t,1,1), sim_med_exp_sample_h_hi_1(t,1,1)
END DO
DO t=1, 3
 write(100, *) med_exp_sample_h_hi_1(t,2,1), sim_med_exp_sample_h_hi_1(t,2,1)
END DO
DO t=1, 3
 write(100, *) med_exp_sample_h_hi_1(t,1,2), sim_med_exp_sample_h_hi_1(t,1,2)
END DO
DO t=1, 3
 write(100, *) med_exp_sample_h_hi_1(t,2,2), sim_med_exp_sample_h_hi_1(t,2,2)
END DO   
CLOSE (100)

OPEN(100, file="ag_sim_std_med_exp_all.txt")
DO t=1, 3
 write(100, *) std_med_exp_sample_h_hi_1(t,1,1), sim_std_med_exp_sample_h_hi_1(t,1,1)
END DO
DO t=1, 3
 write(100, *) std_med_exp_sample_h_hi_1(t,2,1), sim_std_med_exp_sample_h_hi_1(t,2,1) 
END DO
DO t=1, 3
 write(100, *) std_med_exp_sample_h_hi_1(t,1,2), sim_std_med_exp_sample_h_hi_1(t,1,2)
END DO
DO t=1, 3
 write(100, *) std_med_exp_sample_h_hi_1(t,2,2), sim_std_med_exp_sample_h_hi_1(t,2,2)
END DO   
CLOSE (100)

OPEN(100, file="ag_sim_positive_med_expense_all.txt")
DO t=1, 3
 write(100, *) positive_sample_h_hi_1(t,1,1), sim_positive_sample_h_hi_1(t,1,1)
END DO
DO t=1, 3
 write(100, *) positive_sample_h_hi_1(t,2,1), sim_positive_sample_h_hi_1(t,2,1)
END DO
DO t=1, 3
 write(100, *) positive_sample_h_hi_1(t,1,2), sim_positive_sample_h_hi_1(t,1,2)
END DO
DO t=1, 3
 write(100, *) positive_sample_h_hi_1(t,2,2), sim_positive_sample_h_hi_1(t,2,2)
END DO    
CLOSE (100)

END IF

END SUBROUTINE