SUBROUTINE std_error

use params
use mod_dp
use matrix

implicit none

LOGICAL ISNAN

integer num_param
REAL(DP) obj_res(num_moment1*5*2+num_moment2*2+num_moment4*3+num_moment3), obs_res_v(num_moment1*5*2+num_moment2*2+num_moment4*3+num_moment3, num_moment1*5*2+num_moment2*2+num_moment4*3+num_moment3)
REAL(DP) obj_mm_dv(num_moment1*5*2+num_moment2*2+num_moment4*3+num_moment3, num_param_est), objective_value, diff_param(num_param_est), moment_firm(13), firm_moment_bench(num_moment3), firm_moment_diff(num_moment3), firm_moment_deriv(num_moment3, num_param_est)
REAL(DP) matrix_all(num_param_est, num_moment1*5*2+num_moment2*2+num_moment4*3+num_moment3)
REAL(DP) Hessian_inv(num_param_est,num_param_est), Hessian_mat(num_param_est,num_param_est)
REAL(DP) moments_bench(num_moment1, 5, 2), moments1_bench(num_moment2,2), moments3_bench(num_moment4, 3)
REAL(DP) moments_diff(num_moment1, 5, 2), moments1_diff(num_moment2,2), moments3_diff(num_moment4, 3)
REAL(DP) moments_deriv(num_moment1,5,2, num_param_est ), moments1_deriv(num_moment2,2, num_param_est), moments3_deriv(num_moment4, 3, num_param_est )
REAL(DP) mom_number, denom, denom_hi, denom_nhi, denom_hi_s, denom_hi_l, moment_value(num_moment3) !, obj_value
integer:: i,j,k,n,m,t,l, tt, count !index
INTEGER period, ind_type, ed_type, health_type, hi_type, firm_index, work_exp
REAL(DP) denom_wage_hi, denom_wage_nhi, firm_mean_wage_m(num_firm, 2), worker_s, worker_l , worker_hi, worker_nhi, param_std_error(num_param_est)
!calculate venchmark value

!allocate (v_cv_weight(num_moment1, 5, 2), v_cv_weight1(num_moment2, 2), v_firm(num_moment3))


!OPEN(1,file="parameter_value.txt")
!DO i=1, num_param_est
!READ(1,fmt=*)	param_est(i)
!END DO
!CLOSE(1)


DO i=1, num_moment1*5*2+num_moment2*2+num_moment4*3+num_moment3
DO j=1, num_param_est
obj_mm_dv(i, j)=0.0d0
END DO
END DO



CALL solve_eq

CALL simulate_data

call save_result



!calculate variance-covariance matrix
call variance_covariance_mat

CALL std_error_eval(moments_bench, moments1_bench, moments3_bench)
! firm sde moments
CALL std_eval_firm(firm_moment_bench)
 
 
DO i=1, num_param_est
diff_param(i)=abs(param_est(i))*0.05d0

IF (i==7 .or. i==12 .or. i==30 .or. i==46 .or. i==47 .or. i==49 .or. i==50) THEN
diff_param(i)=0.00001d0
END IF

 
END DO





DO i=1, num_param_est 
param_est(i)=param_est(i)+diff_param(i)


CALL param_read

CALL solve_eq



CALL simulate_data

call save_result

!solve employer side moments




! worker side moments
call std_error_eval(moments_diff, moments1_diff, moments3_diff)
! firm sde moments
call std_eval_firm(firm_moment_diff)



DO m=1, 2
DO n=1, num_moment2 
moments1_deriv(n,m,i)=(moments1_diff(n,m)-moments1_bench(n,m))/diff_param(i)
IF (ISNAN(moments1_deriv(n,m,i))) THEN
print*, i, n, m, diff_param(i), param_est(i), moments1_diff(n,m), moments1_bench(n,m)
stop
END IF

 
 END DO ! n
DO k=1, 5
DO j=1, num_moment1
moments_deriv(j,k,m,i)=(moments_diff(j,k,m)-moments_bench(j,k,m))/diff_param(i)
IF (ISNAN(moments_deriv(j,k,m,i))) THEN
moments_deriv(j,k,m,i)=1.0d0+i
END IF

END DO
END DO
END DO

DO k=1, 3
DO j=1, num_moment4
moments3_deriv(j,k,i)=(moments3_diff(j,k)-moments3_bench(j,k))/diff_param(i)
IF (moments3_deriv(j,k,i)==0.00d0) THEN
moments3_deriv(j,k,i)=0.01
END IF

IF (ISNAN(moments3_deriv(j,k,i))) THEN
moments3_deriv(j,k,i)=0.01
END IF


END DO
END DO


DO j=1, num_moment3
firm_moment_deriv(j, i)=(firm_moment_diff(j)-firm_moment_bench(j))/diff_param(i)
END DO

param_est(i)=param_est(i)-diff_param(i)

print*, i


END DO

!IF (data_mode==2) THEN 
!
!
!OPEN(1, file="moments1_deriv.txt")
!DO j=1, num_moment2
!DO m=1, 2
!DO i=1, num_param_est
! write(1, *) moments1_deriv(j,m,i)
!END DO
!END DO
!END DO
!CLOSE (1)
!
!OPEN(1, file="moments_deriv.txt")
!DO k=1, 5
!    DO m=1, 2
!DO j=1, num_moment1
!    DO i=1, num_param_est
!write(1, *) moments_deriv(j,k,m,i)
!    END DO
!END DO
!    END DO    
!END DO
!CLOSE (1)
!
!OPEN(1, file="moments3_deriv.txt")
!DO k=1, 3
!DO j=1, num_moment4
!    DO i=1, num_param_est
!write(1, *)     moments3_deriv(j,k,i)
!END DO
!END DO
!END DO
!CLOSE (1)
!
!
!OPEN(1, file="firm_moment_deriv.txt")
!DO j=1, num_moment3
!    DO i=1, num_param_est
!write(1, *)         firm_moment_deriv(j, i)
!END DO
!END DO
!CLOSE (1)
!
!END IF

n=0
! construct the grand matrix
DO j=1, num_moment1
DO k=1, 5
DO m=1, 2
n=n+1
obj_res(n)=moments_bench(j,k,m)
DO i=1, num_param_est
obj_mm_dv(n, i)=moments_deriv(j,k,m,i)
END DO

END DO
END DO
END DO 
 
n=num_moment1*5*2
DO j=1, num_moment2
DO m=1, 2
n=n+1
obj_res(n)=moments1_bench(j,m)
DO i=1, num_param_est
obj_mm_dv(n, i)=moments1_deriv(j,m,i)
END DO
END DO
END DO
n=num_moment1*5*2+num_moment2*2

DO j=1, num_moment4
DO m=1, 3
n=n+1
obj_res(n)=moments3_bench(j,m)
DO i=1, num_param_est
obj_mm_dv(n, i)=moments3_deriv(j,m,i)
END DO
END DO
END DO


n=num_moment1*5*2+num_moment2*2+num_moment4*3
DO j=1, num_moment3
n=n+1
obj_res(n)=firm_moment_bench(j)
DO i=1, num_param_est
obj_mm_dv(n, i)=firm_moment_deriv(j, i)

END DO
END DO

print*, 'arrive2'
! calculate standard error

 call std_weighting_matrix

print*, 'arrive3'

!IF (data_mode==2) THEN 
!
!OPEN(1, file="obj_mm_dv.txt")
!DO i=1, num_param_est
!DO j=1, num_moment1*5*2+num_moment2*2+num_moment4*3+num_moment3
! write(1, *) obj_mm_dv(j,i)
!END DO
!END DO 
!CLOSE (1)
!
!END IF





matrix_all=MATMUL(TRANSPOSE(obj_mm_dv),mat_weight)


print*, 'arrive3.5'

Hessian_mat=MATMUL(matrix_all,obj_mm_dv )

print*, 'arrive3.6'
!TAKE INVERSE
Hessian_inv = matinv(Hessian_mat)

print*, 'arrive3.7'

!intermediate matrix
residual_mat_1=MATMUL(mat_weight,residual_mat)
print*, 'arrive3.8'
residual_mat_2=MATMUL(residual_mat_1, mat_weight)
print*, 'arrive3.9'
residual_mat_3=MATMUL(obj_mm_dv, residual_mat_2)
print*, 'arrive4.5'
residual_mat_4=MATMUL(residual_mat_3,obj_mm_dv )

print*, 'arrive5.5'

!sandwitch
Hessian_inv_all=MATMUL(Hessian_inv, residual_mat_4)

print*, 'arrive6.5'

Hessian_inv_all=MATMUL(Hessian_inv_all, Hessian_inv)

Sens_mat=MATMUL(Hessian_inv,matrix_all)

DO i=1, num_param_est
DO j=1, moment_vector
Sens_mat(i,j)=Sens_mat(i,j)/(mat_weight(j,j)**(0.5d0))
END DO
END DO 


OPEN(1, file="Sens_mat.txt")
DO i=1, num_param_est
DO j=1, moment_vector
 write(1, *) Sens_mat(i,j)
END DO
END DO 
CLOSE (1)


!OPEN(1, file="Hessian1.txt")
!DO i=1, num_param_est
!DO j=1, num_param_est
! write(1, *) Hessian_mat(i,j)
!END DO
!END DO 
!CLOSE (1)

print*, 'arrive4'
 


print*, 'arrive5'



!OPEN(1, file="Hessian2.txt")
!DO i=1, num_param_est
!DO j=1, num_param_est
! write(1, *) Hessian_inv(i,j)
!END DO
!END DO 
!CLOSE (1)



DO i=1, num_param_est
param_std_error(i)=(Hessian_inv(i,i)/sample_size)**0.50d0
END DO

print*, 'arrive6'


!KEEP THE RESULT
OPEN(1, file="standard_error.txt")
DO i=1, num_param_est
 write(1, *) param_std_error(i)
END DO
CLOSE (1)

END SUBROUTINE