subroutine std_weighting_matrix

use params
use mod_dp



!REAL(DP) moments_all()

implicit none

LOGICAL ISNAN

REAL(DP) mom_number, mat_weight_1(num_moment1, 5, 2), mat_weight_11(num_moment2, 2), mat_weight_12(num_moment3), mat_weight_13(num_moment4, 3)
integer:: i,j,k,n,m,t, tt, count !index
integer, parameter:: c_size=7
 


DO n=1, 2

DO t=1, 5
mat_weight_1(1,t,n)=w_ump_rate_sample(t,n)**(-1.0d0)
mat_weight_1(2,t,n)=w_ue_hi_sample(t,n)**(-1.0d0)
mat_weight_1(3,t,n)=w_ue_nhi_sample(t,n)**(-1.0d0)
mat_weight_1(4,t,n)=w_eu_sample(t,n)**(-1.0d0)
mat_weight_1(5,t,n)=w_wage_hi_sample(t,n)**(-1.0d0)
mat_weight_1(6,t,n)=w_wage_nhi_sample(t,n)**(-1.0d0)
mat_weight_1(7,t,n)=w_wage_ii_sample(t,n)**(-1.0d0)
mat_weight_1(8,t,n)=w_std_wage_hi_sample(t,n)**(-1.0d0)
mat_weight_1(9,t,n)=w_std_wage_nhi_sample(t,n)**(-1.0d0)
mat_weight_1(10,t,n)=w_std_wage_ii_sample(t,n)**(-1.0d0)
mat_weight_1(11,t,n)=w_jj_sample(t,n)**(-1.0d0)
mat_weight_1(12,t,n)=w_jj_hihi_sample(t,n)**(-1.0d0)
mat_weight_1(13,t,n)=w_jj_hinhi_sample(t,n)**(-1.0d0)
mat_weight_1(14,t,n)=w_jj_nhihi_sample(t,n)**(-1.0d0)
mat_weight_1(15,t,n)=w_jj_nhinhi_sample(t,n)**(-1.0d0)
mat_weight_1(16,t,n)=w_wage_change_jj_hihi_sample(t,n)**(-1.0d0)
mat_weight_1(17,t,n)=w_wage_change_jj_hinhi_sample(t,n)**(-1.0d0)
mat_weight_1(18,t,n)=w_wage_change_jj_nhihi_sample(t,n)**(-1.0d0)
mat_weight_1(19,t,n)=w_wage_change_jj_nhinhi_sample(t,n)**(-1.0d0)
mat_weight_1(20,t,n)=w_std_wage_change_jj_hihi_sample(t,n)**(-1.0d0)
mat_weight_1(21,t,n)=w_std_wage_change_jj_hinhi_sample(t,n)**(-1.0d0)
mat_weight_1(22,t,n)=w_std_wage_change_jj_nhihi_sample(t,n)**(-1.0d0)
mat_weight_1(23,t,n)=w_std_wage_change_jj_nhinhi_sample(t,n)**(-1.0d0)
mat_weight_1(24,t,n)=w_wage_change_stay_hi_sample(t,n)**(-1.0d0)
mat_weight_1(25,t,n)=w_wage_change_stay_nhi_sample(t,n)**(-1.0d0)
mat_weight_1(26,t,n)=w_std_wage_change_stay_hi_sample(t,n)**(-1.0d0)
mat_weight_1(27,t,n)=w_std_wage_change_stay_nhi_sample(t,n)**(-1.0d0)
mat_weight_1(28,t,n)=w_wage_ue_hi_sample(t,n)**(-1.0d0)
mat_weight_1(29,t,n)=w_wage_ue_nhi_sample(t,n)**(-1.0d0)
mat_weight_1(30,t,n)=w_std_wage_ue_hi_sample(t,n)**(-1.0d0)
mat_weight_1(31,t,n)=w_std_wage_ue_nhi_sample(t,n)**(-1.0d0)
mat_weight_1(32,t,n)=w_eshi_rate_sample(t,n)**(-1.0d0)
mat_weight_1(33,t,n)=w_ii_rate_all_sample(t,n)**(-1.0d0)
mat_weight_1(34,t,n)=w_health_sample(t,n)**(-1.0d0)
mat_weight_1(35,t,n)=w_health_transition_hh_sample(t,n)**(-1.0d0)
mat_weight_1(36,t,n)=w_health_transition_uu_sample(t,n)**(-1.0d0)


END DO
mat_weight_11(1, n)=w_health_hi(n)**(-1.0d0)
mat_weight_11(2, n)=w_health_nhi(n)**(-1.0d0)
mat_weight_11(3, n)=w_health_unemp(n)**(-1.0d0)

END DO

DO n=1, num_moment3
mat_weight_12(n)=w_firm_mat(n)
END DO

DO t=1, 3
mat_weight_13(1,t)= w_med_exp_sample_h_hi_1(t,1,1)**(-1.0d0)
mat_weight_13(2,t)= w_med_exp_sample_h_hi_1(t,2,1)**(-1.0d0)
mat_weight_13(3,t)= w_med_exp_sample_h_hi_1(t,1,2)**(-1.0d0)
mat_weight_13(4,t)= w_med_exp_sample_h_hi_1(t,2,2)**(-1.0d0)
mat_weight_13(5,t)= w_positive_sample_h_hi_1(t,1,1)**(-1.0d0)
mat_weight_13(6,t)= w_positive_sample_h_hi_1(t,2,1)**(-1.0d0)
mat_weight_13(7,t)= w_positive_sample_h_hi_1(t,1,2)**(-1.0d0)
mat_weight_13(8,t)= w_positive_sample_h_hi_1(t,2,2)**(-1.0d0)
mat_weight_13(9,t)= w_std_med_exp_sample_h_hi_1(t,1,1)**(-1.0d0)
mat_weight_13(10,t)=w_std_med_exp_sample_h_hi_1(t,2,1)**(-1.0d0)
mat_weight_13(11,t)=w_std_med_exp_sample_h_hi_1(t,1,2)**(-1.0d0)
mat_weight_13(12,t)=w_std_med_exp_sample_h_hi_1(t,2,2)**(-1.0d0)

END DO



! construct frabd moment

DO i=1, num_moment1*5*2+num_moment2*2+num_moment4*3+num_moment3
DO j=1, num_moment1*5*2+num_moment2*2+num_moment4*3+num_moment3
mat_weight(i,j)=0.0d0
END DO
END DO

n=0

DO j=1, num_moment1
DO k=1, 5
DO m=1, 2
n=n+1
mat_weight(n,n)=mat_weight_1(j,k,m)
END DO
END DO
END DO

n=num_moment1*5*2

DO j=1, num_moment2
DO m=1, 2
n=n+1

mat_weight(n,n)=mat_weight_11(j,m)

END DO
END DO


n=num_moment1*5*2+num_moment2*2
DO j=1, num_moment4
DO m=1, 3
n=n+1
mat_weight(n,n)=mat_weight_13(j,m)
END DO
END DO



n=num_moment1*5*2+num_moment2*2+num_moment4*3
DO j=1, num_moment3
n=n+1
mat_weight(n,n)=mat_weight_12(j)

END DO




end subroutine