clear
set mem 4g
* This program is made to merge topical modules. 

use "C:\SIPP\2004\data_file\sipp04t3.dta", clear

keep esex tage wpfinwgt ssuseq  ssuid  swave   srotaton  epppnum  erace ems eeducate thhtnw thhtheq thhbeq thhvehcl thhtwlth thhtnw ehltstat tmdpay thipay

rename esex sex
rename tage age
rename wpfinwgt weight_p
rename erace race
rename ems m_status
rename eeducate ed_status
rename thhtnw net_worth
rename thhtwlth tot_wealth
rename thhtheq home_equity
rename thhbeq business_equity
rename thhvehcl vehicle_equity
* rename rhhuscbt un_debt
rename ehltstat health_status
rename tmdpay oop 
rename thipay hi_premium 

gen year=2004 if swave==1 | swave==2 | swave==3
replace year=2005 if swave==4 | swave==5 | swave==6
replace year=2006 if swave==7 | swave==8 | swave==9
replace year=2007 if swave==10 | swave==11 | swave==12


save "C:\SIPP\2004\adjusted_data_file\04t3.dta", replace

clear

use "C:\SIPP\2004\data_file\sipp04t6.dta", clear

keep esex tage wpfinwgt ssuseq  ssuid  swave srotaton  epppnum  erace ems eeducate thhtnw thhtheq thhbeq thhvehcl thhtwlth thhtnw ehltstat tmdpay thipay 

rename esex sex
rename tage age
rename wpfinwgt weight_p
rename erace race
rename ems m_status
rename eeducate ed_status
rename thhtnw net_worth
rename thhtwlth tot_wealth
rename thhtheq home_equity
rename thhbeq business_equity
rename thhvehcl vehicle_equity
* rename rhhuscbt un_debt
rename ehltstat health_status
rename tmdpay oop
rename thipay hi_premium

gen year=2004 if swave==1 | swave==2 | swave==3
replace year=2005 if swave==4 | swave==5 | swave==6
replace year=2006 if swave==7 | swave==8 | swave==9
replace year=2007 if swave==10 | swave==11 | swave==12




save "C:\SIPP\2004\adjusted_data_file\04t6.dta", replace






clear



use "C:\SIPP\2004\adjusted_data_file\04t3.dta", clear

append using "C:\SIPP\2004\adjusted_data_file\04t6.dta"


sort ssuseq  ssuid  swave  srotaton  



* bys ssuseq epppnum: egen attrition=sum(swave)
* drop if attrition<30
save "C:\SIPP\2004\adjusted_data_file\master_topical.dta", replace  

