SUBROUTINE READ_DATA


use params
use mod_dp
use random

implicit none

LOGICAL ISNAN

integer:: i,j,k,n,m,t, tt, count, x, y !index
integer:: age_index, age_low, age_high
!integer, parameter:: sample_size=9307, sample_size_meps=18704
INTEGER ue_data(sample_size,11), eu_data(sample_size,11), emp_data(sample_size,12), & 
hi_data(sample_size,12), health_data(sample_size,2), age_data(sample_size,4),jj_data(sample_size,11)  
REAL(DP) wage_data(sample_size,12),  cohort_data(40), ed(sample_size, 4), health_taransition_denom(2,5,2)
REAL(DP) denom, denom1, denom2, denom3
REAL(DP) med_exp_sample(sample_size_meps)
INTEGER age_data_meps(sample_size_meps),  health_data_meps(sample_size_meps), hi_data_meps(sample_size_meps), ed_data_meps(sample_size_meps)
INTEGER health_1_data_meps(sample_size_meps), hi_emp_data_meps(sample_size_meps), emp_data_meps(sample_size_meps)
INTEGER	   :: iseed(2),isize,in  
!READ DATA MOMENTS
 
! moments
        OPEN(1,file="ue.csv")
            do i=1,sample_size
            READ(1,fmt=*) (ue_data(i,j),j=1,11)                     
            end do
        CLOSE(1)
        OPEN(1,file="eu.csv")
            do i=1,sample_size
            READ(1,fmt=*) (eu_data(i,j),j=1,11)                     
            end do
        CLOSE(1)
        OPEN(1,file="emp.csv")
            do i=1,sample_size
            READ(1,fmt=*) (emp_data(i,j),j=1,12)                    
            end do
        CLOSE(1)
        OPEN(1,file="hi.csv")
            do i=1,sample_size
            READ(1,fmt=*) (hi_data(i,j),j=1,12)                    
            end do
        CLOSE(1)
        OPEN(1,file="wage.csv")
            do i=1,sample_size
            READ(1,fmt=*) (wage_data(i,j),j=1,12)                    
            end do
        CLOSE(1)
        OPEN(1,file="jj.csv")
            do i=1,sample_size
            READ(1,fmt=*) (jj_data(i,j),j=1,11)                    
            end do
        CLOSE(1)
        OPEN(1,file="health.csv")
            do i=1,sample_size
            READ(1,fmt=*) (health_data(i,j),j=1,2)                    
            end do
        CLOSE(1)
!        OPEN(1,file="wage_change_stay.csv")
!            do i=1,sample_size
!            READ(1,fmt=*) (wage_change_stay_data(i,j),j=1,11)                    
!            end do
!        CLOSE(1)
!        OPEN(1,file="wage_change_jj.csv")
!            do i=1,sample_size
!            READ(1,fmt=*) (wage_change_jj_data(i,j),j=1,11)                    
!            end do
!        CLOSE(1)
        OPEN(1,file="age.csv")
            do i=1,sample_size
            READ(1,fmt=*) (age_data(i,j),j=1,4)                    
            end do
        CLOSE(1)
        OPEN(1,file="ed.csv")
            do i=1,sample_size
            READ(1,fmt=*) (ed(i,j),j=1,4)                    
            end do
        CLOSE(1)
!        OPEN(1,file="cohort_size.csv")
!            do i=1,40
!            READ(1,fmt=*) cohort_data(i)                    
!            end do
!        CLOSE(1)
        OPEN(1,file="MEPS_all_04.csv")
            do i=1,sample_size_meps
            READ(1,fmt=*) med_exp_sample(i), health_data_meps(i), hi_data_meps(i), hi_emp_data_meps(i), health_1_data_meps(i), emp_data_meps(i), age_data_meps(i) , ed_data_meps(i)                   
            end do
        CLOSE(1)
        
        ! MEPS
!        

! draw measurement error
isize = 2
iseed(1) = 7755
iseed(2) = 7744
CALL RANDOM_SEED(size = isize)
CALL RANDOM_SEED(put = iseed)
DO i=1,sample_size
DO j=1, 12
wage_error(i,j)= random_normal()
END DO
END DO
! Add measurement error
DO i=1,sample_size
DO j=1, 12
 wage_data(i,j)=wage_data(i,j)*exp(wage_error(i,j)*sigma_wage_error)
END DO
END DO
        
        !create cohort weight
!        denom=0.0d0    
!        DO j=1, 9
!        cohort_weight(j)=0.0d0
!        END DO
!        
!        DO j=10, num_period, 3
!        
!        cohort_weight(j)=cohort_data((j-10)/3+1)
!        cohort_weight(j+1)=cohort_data((j-10)/3+1)
!        cohort_weight(j+2)=cohort_data((j-10)/3+1) 
!        denom=denom+3.0d0*cohort_weight(j)
!        END DO


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        denom=1.0d0
        cohort_weight(1,2)=1.0d0
        DO j=2, num_period
        cohort_weight(j,2)=1.0d0+(j-1.0d0)*0.00002d0
        denom=denom+cohort_weight(j,2)
        END DO

        
        DO j=1, num_period
        cohort_weight(j,2)=cohort_weight(j,2)/denom        
!        cohort_weight(j)=1.0d0
        END DO

        denom=0.0d0
        DO j=1, 8
        cohort_weight(j,1)=0.0d0
        denom=denom+cohort_weight(j,1)
        END DO

        denom=1.0d0
        cohort_weight(9,1)=1.0d0
        DO j=10, num_period
        cohort_weight(j,1)=1.0d0+(j-9.0d0)*0.00002d0
        denom=denom+cohort_weight(j,1)
        END DO
        DO j=9, num_period
        cohort_weight(j,1)=cohort_weight(j,1)/denom                
        END DO
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!




!                denom=0.0d0
!        cohort_weight(1,1)=0.0d0
!        cohort_weight(1,2)=0.0d0
!        DO j=2, num_period
!        cohort_weight(j,1)=1.0d0+(j-1.0d0)*0.00002d0
!        cohort_weight(j,2)=1.0d0+(j-1.0d0)*0.00002d0
!        denom=denom+cohort_weight(j,1)
!        END DO
!!       
!        DO j=1, num_period
!        cohort_weight(j,1)=cohort_weight(j,1)/denom
!        cohort_weight(j,2)=cohort_weight(j,2)/denom
!
!!        cohort_weight(j)=1.0d0
!        END DO

        
 
DO m=1, 5
! unconditional on education
DO i=1, 2
DO j=1, 2
med_exp_sample_h_hi_1(m, i,j)=0.0d0
std_med_exp_sample_h_hi_1(m, i,j)=0.0d0
positive_sample_h_hi_1(m, i,j)=0.0d0
count_sample_h_hi_1(m, i,j)=0.0d0
w_med_exp_sample_h_hi_1(m,i,j)=0.0d0
w_std_med_exp_sample_h_hi_1(m,i,j)=0.0d0
w_positive_sample_h_hi_1(m,i,j)=0.0d0
END DO
END DO

DO n=1, 2

ump_rate_sample(m,n)=0.0d0
emp_sample(m,n)=0.0d0
emp_rate_sample(m,n)=0.0d0
hi_rate_sample(m,n)=0.0d0
wage_hi_sample(m,n)=0.0d0
wage_nhi_sample(m,n)=0.0d0
wage_average_sample(m,n)=0.0d0
std_wage_hi_sample(m,n)=0.0d0
std_wage_nhi_sample(m,n)=0.0d0
ue_sample(m,n)=0.0d0
ue_hi_sample(m,n)=0.0d0
ue_nhi_sample(m,n)=0.0d0
eu_sample(m,n)=0.0d0
jj_sample(m,n)=0.0d0
jj_hihi_sample(m,n)=0.0d0
jj_nhihi_sample(m,n)=0.0d0
jj_hinhi_sample(m,n)=0.0d0
jj_nhinhi_sample(m,n)=0.0d0
wage_change_jj_hihi_sample(m,n)=0.0d0
wage_change_jj_nhinhi_sample(m,n)=0.0d0
wage_change_jj_hinhi_sample(m,n)=0.0d0
wage_change_jj_nhihi_sample(m,n)=0.0d0
wage_change_stay_sample(m,n)=0.0d0
wage_change_stay_hi_sample(m,n)=0.0d0
wage_change_stay_nhi_sample(m,n)=0.0d0
wage_change_stay_sample_count(m,n)=0.0d0
wage_change_stay_hi_sample_count(m,n)=0.0d0
wage_change_stay_nhi_sample_count(m,n)=0.0d0
wage_ue_hi_sample(m,n)=0.0d0
wage_ue_nhi_sample(m,n)=0.0d0
std_wage_change_jj_hihi_sample(m,n)=0.0d0
std_wage_change_jj_nhinhi_sample(m,n)=0.0d0
std_wage_change_jj_hinhi_sample(m,n)=0.0d0
std_wage_change_jj_nhihi_sample(m,n)=0.0d0
std_wage_change_stay_sample(m,n)=0.0d0
std_wage_change_stay_hi_sample(m,n)=0.0d0
std_wage_change_stay_nhi_sample(m,n)=0.0d0
std_wage_ue_hi_sample(m,n)=0.0d0
std_wage_ue_nhi_sample(m,n)=0.0d0
health_sample_all(m,n)=0.0d0
health_sample(m,n)=0.0d0
health_transition_hh_sample(m,n)=0.0d0
health_transition_uu_sample(m,n)=0.0d0
health_taransition_denom(1,m,n)=0.0d0
health_taransition_denom(2,m,n)=0.0d0
med_exp_sample_h_sample(m,n)=0.0d0
med_exp_sample_u_sample(m,n)=0.0d0
health_sample_meps(m,n)=0.0d0
health_sample_all_meps(m,n)=0.0d0
std_med_exp_sample_h_sample(m,n)=0.0d0
std_med_exp_sample_u_sample(m,n)=0.0d0
ue_sample_count(m,n)=0.0d0
ue_hi_sample_count(m,n)=0.0d0
ue_nhi_sample_count(m,n)=0.0d0
eu_sample_count(m,n)=0.0d0
jj_sample_count(m,n)=0.0d0
jj_hihi_sample_count(m,n)=0.0d0
jj_nhihi_sample_count(m,n)=0.0d0
jj_hinhi_sample_count(m,n)=0.0d0
jj_nhinhi_sample_count(m,n)=0.0d0
emp_rate_sample_count(m,n)=0.0d0
hi_rate_sample_count(m,n)=0.0d0
DO i=1, 2
DO j=1, 2
med_exp_sample_h_hi(m,n, i,j)=0.0d0
std_med_exp_sample_h_hi(m,n, i,j)=0.0d0
positive_sample_h_hi(m,n, i,j)=0.0d0
count_sample_h_hi(m,n, i,j)=0.0d0
END DO
END DO

! weight 
w_ump_rate_sample(m,n)=0.0d0
w_emp_rate_sample(m,n)=0.0d0
w_hi_rate_sample(m,n)=0.0d0
w_wage_hi_sample(m,n)=0.0d0
w_wage_nhi_sample(m,n)=0.0d0
w_std_wage_hi_sample(m,n)=0.0d0
w_std_wage_nhi_sample(m,n)=0.0d0
w_ue_sample(m,n)=0.0d0
w_ue_hi_sample(m,n)=0.0d0
w_ue_nhi_sample(m,n)=0.0d0
w_eu_sample(m,n)=0.0d0
w_jj_sample(m,n)=0.0d0
w_jj_hihi_sample(m,n)=0.0d0
w_jj_nhihi_sample(m,n)=0.0d0
w_jj_hinhi_sample(m,n)=0.0d0
w_jj_nhinhi_sample(m,n)=0.0d0
w_wage_change_jj_hihi_sample(m,n)=0.0d0
w_wage_change_jj_nhinhi_sample(m,n)=0.0d0
w_wage_change_jj_hinhi_sample(m,n)=0.0d0
w_wage_change_jj_nhihi_sample(m,n)=0.0d0
w_wage_change_stay_sample(m,n)=0.0d0
w_wage_change_stay_hi_sample(m,n)=0.0d0
w_wage_change_stay_nhi_sample(m,n)=0.0d0
w_wage_ue_hi_sample(m,n)=0.0d0
w_wage_ue_nhi_sample(m,n)=0.0d0
w_std_wage_change_jj_hihi_sample(m,n)=0.0d0
w_std_wage_change_jj_nhinhi_sample(m,n)=0.0d0
w_std_wage_change_jj_hinhi_sample(m,n)=0.0d0
w_std_wage_change_jj_nhihi_sample(m,n)=0.0d0
w_std_wage_change_stay_sample(m,n)=0.0d0
w_std_wage_change_stay_hi_sample(m,n)=0.0d0
w_std_wage_change_stay_nhi_sample(m,n)=0.0d0
w_std_wage_ue_hi_sample(m,n)=0.0d0
w_std_wage_ue_nhi_sample(m,n)=0.0d0
w_health_sample(m,n)=0.0d0
w_health_transition_hh_sample(m,n)=0.0d0
w_health_transition_uu_sample(m,n)=0.0d0
w_med_exp_sample_h_sample(m,n)=0.0d0
w_med_exp_sample_u_sample(m,n)=0.0d0
w_std_med_exp_sample_h_sample(m,n)=0.0d0
w_std_med_exp_sample_u_sample(m,n)=0.0d0
DO i=1, 2
DO j=1, 2
w_med_exp_sample_h_hi(m,n, i,j)=0.0d0
w_std_med_exp_sample_h_hi(m,n, i,j)=0.0d0
w_positive_sample_h_hi(m,n, i,j)=0.0d0
END DO
END DO
! create moments by age !state evaluation
DO j=1, 12 !all data periods
DO i=1, sample_size
age_index=floor((j-1)/3.0)+1 
age_index=age_data(i,age_index)

! education
IF (ed(i,1)==n .or. ed(i,2)==n .or. ed(i,3)==n .or. ed(i,4)==n) THEN

IF (age_index>=25+7*(m-1) .and. age_index<25+7*m) THEN 

    IF ((emp_data(i,j)==1 .and. wage_data(i,j)>=0.0d0) .or. emp_data(i,j)==0) THEN
        emp_sample(m,n)=emp_sample(m,n)+1.0d0
    END IF
    IF (emp_data(i,j)==1 .and. wage_data(i,j)>=0.0d0 ) THEN
        emp_rate_sample_count(m,n)=emp_rate_sample_count(m,n)+1.0d0
        wage_average_sample(m,n)=wage_average_sample(m,n)+wage_data(i,j)
    END IF
    IF (hi_data(i,j)==1 .and. emp_data(i,j)==1 .and. wage_data(i,j)>=0.0d0 ) THEN
        hi_rate_sample_count(m,n)=hi_rate_sample_count(m,n)+1.0d0
    END IF
    IF (emp_data(i,j)==1 .and. wage_data(i,j)>=0.0d0 .and. hi_data(i,j)==1) THEN
        wage_hi_sample(m,n)=wage_hi_sample(m,n)+wage_data(i,j)
    END IF    
    IF (emp_data(i,j)==1 .and. wage_data(i,j)>=0.0d0 .and. hi_data(i,j)==0) THEN
        wage_nhi_sample(m,n)=wage_nhi_sample(m,n)+wage_data(i,j)
    END IF    


END IF

END IF !education
    
END DO !i
END DO !j


wage_hi_sample(m,n)=wage_hi_sample(m,n)/hi_rate_sample_count(m,n)
wage_nhi_sample(m,n)=wage_nhi_sample(m,n)/(emp_rate_sample_count(m,n)-hi_rate_sample_count(m,n))
wage_average_sample(m,n)=wage_average_sample(m,n)/emp_rate_sample_count(m,n)
!standard deviation of wage
DO j=1, 12 !all data periods
DO i=1, sample_size

! education
IF (ed(i,1)==n .or. ed(i,2)==n .or. ed(i,3)==n .or. ed(i,4)==n) THEN


age_index=floor((j-1)/3.0)+1 
age_index=age_data(i,age_index)

IF (age_index>=25+7*(m-1) .and. age_index<25+7*m) THEN 

    IF (emp_data(i,j)==1 .and. wage_data(i,j)>=0.0d0 .and. hi_data(i,j)==1) THEN
        std_wage_hi_sample(m,n)=std_wage_hi_sample(m,n)+(wage_data(i,j)-wage_hi_sample(m,n))**2.0d0
    END IF    
    IF (emp_data(i,j)==1 .and. wage_data(i,j)>=0.0d0 .and. hi_data(i,j)==0) THEN
        std_wage_nhi_sample(m,n)=std_wage_nhi_sample(m,n)+(wage_data(i,j)-wage_nhi_sample(m,n))**2.0d0
    END IF    

END IF

END IF !education

END DO !i
END DO !j

! calculate the moments

ump_rate_sample(m,n)=emp_sample(m,n)-emp_rate_sample_count(m,n)
std_wage_hi_sample(m,n)=(std_wage_hi_sample(m,n)/hi_rate_sample_count(m,n))**0.50d0
std_wage_nhi_sample(m,n)=(std_wage_nhi_sample(m,n)/(emp_rate_sample_count(m,n)-hi_rate_sample_count(m,n)))**0.50d0
hi_rate_sample(m,n)=hi_rate_sample_count(m,n)/emp_rate_sample_count(m,n)
emp_rate_sample(m,n)=emp_rate_sample_count(m,n)/emp_sample(m,n)
ump_rate_sample(m,n)=ump_rate_sample(m,n)/emp_sample(m,n)



!create moments by age: transition evaluation
DO j=1, 11 !all data periods
DO i=1, sample_size

! education
IF (ed(i,1)==n .or. ed(i,2)==n .or. ed(i,3)==n .or. ed(i,4)==n) THEN



age_index=floor((j-1)/3.0)+1 
age_index=age_data(i,age_index)

IF (age_index>=25+7*(m-1) .and. age_index<25+7*m) THEN 

    IF (ue_data(i,j)==1 ) THEN
        ue_sample_count(m,n)=ue_sample_count(m,n)+1.0d0
    END IF
    IF (ue_data(i,j)==1 .and. hi_data(i,j+1)==1 .and. wage_data(i,j+1)>=0.0d0) THEN
        ue_hi_sample_count(m,n)=ue_hi_sample_count(m,n)+1.0d0
        wage_ue_hi_sample(m,n)=wage_ue_hi_sample(m,n)+wage_data(i,j+1)
    END IF
    IF (ue_data(i,j)==1 .and. hi_data(i,j+1)==0 .and. wage_data(i,j+1)>=0.0d0) THEN
        ue_nhi_sample_count(m,n)=ue_nhi_sample_count(m,n)+1.0d0
        wage_ue_nhi_sample(m,n)=wage_ue_nhi_sample(m,n)+wage_data(i,j+1)
        
    END IF
    IF (eu_data(i,j)==1) THEN
        eu_sample_count(m,n)=eu_sample_count(m,n)+1.0d0
    END IF
    IF (jj_data(i,j)==1) THEN
        jj_sample_count(m,n)=jj_sample_count(m,n)+1.0d0
    END IF  
    IF (jj_data(i,j)==1 .and. hi_data(i,j)==1 .and. hi_data(i,j+1)==1 .and. wage_data(i,j)>=0.0d0 .and. wage_data(i,j+1)>=0.0d0) THEN
        wage_change_jj_hihi_sample(m,n)=wage_change_jj_hihi_sample(m,n)+wage_data(i,j+1)-wage_data(i,j)
        jj_hihi_sample_count(m,n)=jj_hihi_sample_count(m,n)+1.0d0
    END IF
    IF (jj_data(i,j)==1 .and. hi_data(i,j)==0 .and. hi_data(i,j+1)==0 .and. wage_data(i,j)>=0.0d0  .and. wage_data(i,j+1)>=0.0d0) THEN
        wage_change_jj_nhinhi_sample(m,n)=wage_change_jj_nhinhi_sample(m,n)+wage_data(i,j+1)-wage_data(i,j)
        jj_nhinhi_sample_count(m,n)=jj_nhinhi_sample_count(m,n)+1.0d0
    END IF   
    IF (jj_data(i,j)==1 .and. hi_data(i,j)==1 .and. hi_data(i,j+1)==0 .and. wage_data(i,j)>=0.0d0 .and. wage_data(i,j+1)>=0.0d0) THEN
        wage_change_jj_hinhi_sample(m,n)=wage_change_jj_hinhi_sample(m,n)+wage_data(i,j+1)-wage_data(i,j)
        jj_hinhi_sample_count(m,n)=jj_hinhi_sample_count(m,n)+1.0d0
    END IF
    IF (jj_data(i,j)==1 .and. hi_data(i,j)==0 .and. hi_data(i,j+1)==1 .and. wage_data(i,j)>=0.0d0 .and. wage_data(i,j+1)>=0.0d0) THEN
        wage_change_jj_nhihi_sample(m,n)=wage_change_jj_nhihi_sample(m,n)+wage_data(i,j+1)-wage_data(i,j)
        jj_nhihi_sample_count(m,n)=jj_nhihi_sample_count(m,n)+1.0d0
    END IF
    IF (emp_data(i,j)==1 .and. emp_data(i,j+1)==1 .and. jj_data(i,j)==0) THEN
        wage_change_stay_sample_count(m,n)=wage_change_stay_sample_count(m,n)+1.0d0
        wage_change_stay_sample(m,n)=wage_change_stay_sample(m,n)+ wage_data(i,j+1)-wage_data(i,j)
    END IF     
    IF (emp_data(i,j)==1 .and. emp_data(i,j+1)==1 .and. jj_data(i,j)==0 .and. hi_data(i,j)==1) THEN
        wage_change_stay_hi_sample_count(m,n)=wage_change_stay_hi_sample_count(m,n)+1.0d0
        wage_change_stay_hi_sample(m,n)=wage_change_stay_hi_sample(m,n)+ wage_data(i,j+1)-wage_data(i,j)
    END IF  
    IF (emp_data(i,j)==1 .and. emp_data(i,j+1)==1 .and. jj_data(i,j)==0 .and. hi_data(i,j)==0) THEN
        wage_change_stay_nhi_sample_count(m,n)=wage_change_stay_nhi_sample_count(m,n)+1.0d0
        wage_change_stay_nhi_sample(m,n)=wage_change_stay_nhi_sample(m,n)+ wage_data(i,j+1)-wage_data(i,j)
    END IF   
END IF    

END IF !education
            
END DO !i
END DO !j
wage_change_jj_hihi_sample(m,n)=wage_change_jj_hihi_sample(m,n)/jj_hihi_sample_count(m,n)
wage_change_jj_hinhi_sample(m,n)=wage_change_jj_hinhi_sample(m,n)/jj_hinhi_sample_count(m,n)
wage_change_jj_nhihi_sample(m,n)=wage_change_jj_nhihi_sample(m,n)/jj_nhihi_sample_count(m,n)
wage_change_jj_nhinhi_sample(m,n)=wage_change_jj_nhinhi_sample(m,n)/jj_nhinhi_sample_count(m,n)
wage_ue_hi_sample(m,n)=wage_ue_hi_sample(m,n)/ue_hi_sample_count(m,n)
wage_ue_nhi_sample(m,n)=wage_ue_nhi_sample(m,n)/ue_nhi_sample_count(m,n)
wage_change_stay_sample(m,n)=wage_change_stay_sample(m,n)/wage_change_stay_sample_count(m,n)
wage_change_stay_hi_sample(m,n)=wage_change_stay_hi_sample(m,n)/wage_change_stay_hi_sample_count(m,n)
wage_change_stay_nhi_sample(m,n)=wage_change_stay_nhi_sample(m,n)/wage_change_stay_nhi_sample_count(m,n)
!rate
ue_sample(m,n)=ue_sample_count(m,n)/((1.0d0-emp_rate_sample(m,n))*emp_sample(m,n))
ue_nhi_sample(m,n)=ue_nhi_sample_count(m,n)/((1.0d0-emp_rate_sample(m,n))*emp_sample(m,n))
ue_hi_sample(m,n)=ue_hi_sample_count(m,n)/((1.0d0-emp_rate_sample(m,n))*emp_sample(m,n))
eu_sample(m,n)=eu_sample_count(m,n)/emp_rate_sample_count(m,n)
jj_sample(m,n)=jj_sample_count(m,n)/emp_rate_sample_count(m,n)
jj_hihi_sample(m,n)=jj_hihi_sample_count(m,n)/emp_rate_sample_count(m,n)
jj_hinhi_sample(m,n)=jj_hinhi_sample_count(m,n)/emp_rate_sample_count(m,n)
jj_nhihi_sample(m,n)=jj_nhihi_sample_count(m,n)/emp_rate_sample_count(m,n)
jj_nhinhi_sample(m,n)=jj_nhinhi_sample_count(m,n)/emp_rate_sample_count(m,n)

! STANDARD DEVIATION FOR WAGE
DO j=1, 11 !all data periods
DO i=1, sample_size

! education
IF (ed(i,1)==n .or. ed(i,2)==n .or. ed(i,3)==n .or. ed(i,4)==n) THEN


age_index=floor((j-1)/3.0)+1 
age_index=age_data(i,age_index)

IF (age_index>=25+7*(m-1) .and. age_index<25+7*m) THEN 

    IF (ue_data(i,j)==1 .and. hi_data(i,j+1)==1 .and. wage_data(i,j+1)>=0.0d0) THEN
        std_wage_ue_hi_sample(m,n)=std_wage_ue_hi_sample(m,n)+(wage_data(i,j+1)-wage_ue_hi_sample(m,n))**2.0d0
    END IF
    IF (ue_data(i,j)==1 .and. hi_data(i,j+1)==0 .and. wage_data(i,j+1)>=0.0d0) THEN
        std_wage_ue_nhi_sample(m,n)=std_wage_ue_nhi_sample(m,n)+(wage_data(i,j+1)-wage_ue_nhi_sample(m,n))**2.0d0
    END IF
        IF (jj_data(i,j)==1 .and. hi_data(i,j)==1 .and. hi_data(i,j+1)==1 .and. wage_data(i,j)>=0.0d0 .and. wage_data(i,j+1)>=0.0d0) THEN
        std_wage_change_jj_hihi_sample(m,n)=std_wage_change_jj_hihi_sample(m,n)+(wage_data(i,j+1)-wage_data(i,j)-wage_change_jj_hihi_sample(m,n))**2.0d0
    END IF
    IF (jj_data(i,j)==1 .and. hi_data(i,j)==0 .and. hi_data(i,j+1)==0 .and. wage_data(i,j)>=0.0d0  .and. wage_data(i,j+1)>=0.0d0) THEN
        std_wage_change_jj_nhinhi_sample(m,n)=std_wage_change_jj_nhinhi_sample(m,n)+(wage_data(i,j+1)-wage_data(i,j)-wage_change_jj_nhinhi_sample(m,n))**2.0d0
    END IF   
    IF (jj_data(i,j)==1 .and. hi_data(i,j)==1 .and. hi_data(i,j+1)==0 .and. wage_data(i,j)>=0.0d0 .and. wage_data(i,j+1)>=0.0d0) THEN
        std_wage_change_jj_hinhi_sample(m,n)=std_wage_change_jj_hinhi_sample(m,n)+(wage_data(i,j+1)-wage_data(i,j)-wage_change_jj_hinhi_sample(m,n))**2.0d0
    END IF
    IF (jj_data(i,j)==1 .and. hi_data(i,j)==0 .and. hi_data(i,j+1)==1 .and. wage_data(i,j)>=0.0d0 .and. wage_data(i,j+1)>=0.0d0) THEN
        std_wage_change_jj_nhihi_sample(m,n)=std_wage_change_jj_nhihi_sample(m,n)+(wage_data(i,j+1)-wage_data(i,j)-wage_change_jj_nhihi_sample(m,n))**2.0d0
    END IF
    IF (emp_data(i,j)==1 .and. emp_data(i,j+1)==1 .and. jj_data(i,j)==0) THEN
        std_wage_change_stay_sample(m,n)=std_wage_change_stay_sample(m,n)+ (wage_data(i,j+1)-wage_data(i,j)-wage_change_stay_sample(m,n))**2.0d0
    END IF     
    IF (emp_data(i,j)==1 .and. emp_data(i,j+1)==1 .and. jj_data(i,j)==0 .and. hi_data(i,j)==1) THEN
        std_wage_change_stay_hi_sample(m,n)=std_wage_change_stay_hi_sample(m,n)+ (wage_data(i,j+1)-wage_data(i,j)-wage_change_stay_sample(m,n))**2.0d0
    END IF  
    IF (emp_data(i,j)==1 .and. emp_data(i,j+1)==1 .and. jj_data(i,j)==0 .and. hi_data(i,j)==0) THEN
        std_wage_change_stay_nhi_sample(m,n)=std_wage_change_stay_nhi_sample(m,n)+ (wage_data(i,j+1)-wage_data(i,j)-wage_change_stay_nhi_sample(m,n))**2.0d0
    END IF  

END IF    

END IF !education
    
END DO  !i
END DO  !j
! standard deviation
std_wage_change_jj_hihi_sample(m,n)=(std_wage_change_jj_hihi_sample(m,n)/jj_hihi_sample_count(m,n))**0.50d0
std_wage_change_jj_hinhi_sample(m,n)=(std_wage_change_jj_hinhi_sample(m,n)/jj_hinhi_sample_count(m,n))**0.50d0
std_wage_change_jj_nhihi_sample(m,n)=(std_wage_change_jj_nhihi_sample(m,n)/jj_nhihi_sample_count(m,n))**0.50d0
std_wage_change_jj_nhinhi_sample(m,n)=(std_wage_change_jj_nhinhi_sample(m,n)/jj_nhinhi_sample_count(m,n))**0.50d0
std_wage_ue_hi_sample(m,n)=(std_wage_ue_hi_sample(m,n)/ue_hi_sample_count(m,n))**0.50d0
std_wage_ue_nhi_sample(m,n)=(std_wage_ue_nhi_sample(m,n)/ue_nhi_sample_count(m,n))**0.50d0
std_wage_change_stay_sample(m,n)=(std_wage_change_stay_sample(m,n)/wage_change_stay_sample_count(m,n))**0.50d0
std_wage_change_stay_hi_sample(m,n)=(std_wage_change_stay_hi_sample(m,n)/wage_change_stay_hi_sample_count(m,n))**0.50d0
std_wage_change_stay_nhi_sample(m,n)=(std_wage_change_stay_nhi_sample(m,n)/wage_change_stay_nhi_sample_count(m,n))**0.50d0    
    




     



! health status and medical expenditure
DO j=1, 2
DO i=1, sample_size

! education
IF (ed(i,1)==n .or. ed(i,2)==n .or. ed(i,3)==n .or. ed(i,4)==n) THEN


age_index=age_data(i,j)

IF (age_index>=25+7*(m-1) .and. age_index<25+7*m) THEN 

    IF (health_data(i,j)==1 .or. health_data(i,j)==2) THEN
        health_sample_all(m,n)=health_sample_all(m,n)+1.0d0
    END IF
    IF (health_data(i,j)==1 ) THEN
        health_sample(m,n)=health_sample(m,n)+1.0d0
    END IF

END IF    

END IF !education


    
END DO !i
END DO !j

health_sample(m,n)=health_sample(m,n)/health_sample_all(m,n)




! health status transition
DO j=1, 1
DO i=1, sample_size

! education
IF (ed(i,1)==n .or. ed(i,2)==n .or. ed(i,3)==n .or. ed(i,4)==n) THEN


age_index=age_data(i,j)

IF (age_index>=25+7*(m-1) .and. age_index<25+7*m) THEN 

    IF (health_data(i,j)==1 .and. health_data(i,j+1)==1) THEN
        health_transition_hh_sample(m,n)=health_transition_hh_sample(m,n)+1.0d0
    END IF
    IF (health_data(i,j)==2 .and. health_data(i,j+1)==2) THEN
        health_transition_uu_sample(m,n)=health_transition_uu_sample(m,n)+1.0d0
    END IF
    IF (health_data(i,j)==1 .and. (health_data(i,j+1)==1 .or. health_data(i,j+1)==2) ) THEN
        health_taransition_denom(1,m,n)=health_taransition_denom(1,m,n)+1.0d0
    END IF
    IF (health_data(i,j)==2 .and. (health_data(i,j+1)==1 .or. health_data(i,j+1)==2) ) THEN
        health_taransition_denom(2,m,n)=health_taransition_denom(2,m,n)+1.0d0
    END IF
    
END IF    
    
END IF !education

END DO !i  
END DO !j

health_transition_hh_sample(m,n)=health_transition_hh_sample(m,n)/health_taransition_denom(1,m,n)
health_transition_uu_sample(m,n)=health_transition_uu_sample(m,n)/health_taransition_denom(2,m,n)






!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! calculate weight for the moments
DO j=1, 12 !all data periods
DO i=1, sample_size

! education
IF (ed(i,1)==n .or. ed(i,2)==n .or. ed(i,3)==n .or. ed(i,4)==n) THEN


age_index=floor((j-1)/3.0)+1 
age_index=age_data(i,age_index)

IF (age_index>=25+7*(m-1) .and. age_index<25+7*m) THEN 

    IF (emp_data(i,j)==1 .and. wage_data(i,j)>=0.0d0 .and. hi_data(i,j)==1) THEN
        w_wage_hi_sample(m,n)=w_wage_hi_sample(m,n)+(wage_data(i,j)-wage_hi_sample(m,n))**2.0d0
    END IF    
    IF (emp_data(i,j)==1.and. wage_data(i,j)>=0.0d0 .and. hi_data(i,j)==0) THEN
        w_wage_nhi_sample(m,n)=w_wage_nhi_sample(m,n)+(wage_data(i,j)-wage_nhi_sample(m,n))**2.0d0
    END IF    


END IF

END IF !education
    
END DO !i
END DO !j

! proportion
w_hi_rate_sample(m,n)=hi_rate_sample(m,n)*(1.0d0-hi_rate_sample(m,n))
w_emp_rate_sample(m,n)=emp_rate_sample(m,n)*(1.0d0-emp_rate_sample(m,n))
w_ump_rate_sample(m,n)=ump_rate_sample(m,n)*(1.0d0-ump_rate_sample(m,n))
w_wage_hi_sample(m,n)=w_wage_hi_sample(m,n)/hi_rate_sample_count(m,n)
w_wage_nhi_sample(m,n)=w_wage_nhi_sample(m,n)/(emp_rate_sample_count(m,n)-hi_rate_sample_count(m,n))

!standard deviation of wage
DO j=1, 12 !all data periods
DO i=1, sample_size

! education
IF (ed(i,1)==n .or. ed(i,2)==n .or. ed(i,3)==n .or. ed(i,4)==n) THEN


age_index=floor((j-1)/3.0)+1 
age_index=age_data(i,age_index)

IF (age_index>=25+7*(m-1) .and. age_index<25+7*m) THEN 

    IF (emp_data(i,j)==1 .and. wage_data(i,j)>=0.0d0 .and. hi_data(i,j)==1) THEN
        w_std_wage_hi_sample(m,n)=w_std_wage_hi_sample(m,n)+(wage_data(i,j)-wage_hi_sample(m,n))**4.0d0
    END IF    
    IF (emp_data(i,j)==1.and. wage_data(i,j)>=0.0d0 .and. hi_data(i,j)==0) THEN
        w_std_wage_nhi_sample(m,n)=w_std_wage_nhi_sample(m,n)+(wage_data(i,j)-wage_nhi_sample(m,n))**4.0d0
    END IF    

END IF

END IF !education

END DO !i
END DO !j


w_std_wage_hi_sample(m,n)=(w_std_wage_hi_sample(m,n)**0.50d0)/hi_rate_sample_count(m,n)
w_std_wage_nhi_sample(m,n)=(w_std_wage_nhi_sample(m,n)**0.50d0)/(emp_rate_sample_count(m,n)-hi_rate_sample_count(m,n))

!




w_ue_sample(m,n)= ue_sample(m,n)*(1.0d0-ue_sample(m,n)) 
w_ue_hi_sample(m,n)= ue_hi_sample(m,n)*(1.0d0-ue_hi_sample(m,n)) 
w_ue_nhi_sample(m,n)= ue_nhi_sample(m,n)*(1.0d0-ue_nhi_sample(m,n)) 
w_eu_sample(m,n)=eu_sample(m,n)*(1.0d0-eu_sample(m,n))
w_jj_sample(m,n)=jj_sample(m,n)*(1.0d0-jj_sample(m,n))
w_jj_hihi_sample(m,n)=jj_hihi_sample(m,n)*(1.0d0-jj_hihi_sample(m,n))
w_jj_nhihi_sample(m,n)=jj_nhihi_sample(m,n)*(1.0d0-jj_nhihi_sample(m,n))
w_jj_hinhi_sample(m,n)=jj_hinhi_sample(m,n)*(1.0d0-jj_hinhi_sample(m,n))
w_jj_nhinhi_sample(m,n)=jj_nhinhi_sample(m,n)*(1.0d0-jj_nhinhi_sample(m,n))


w_wage_change_jj_hihi_sample(m,n)=std_wage_change_jj_hihi_sample(m,n)**2.0d0
w_wage_change_jj_hinhi_sample(m,n)=std_wage_change_jj_hinhi_sample(m,n)**2.0d0
w_wage_change_jj_nhihi_sample(m,n)=std_wage_change_jj_nhihi_sample(m,n)**2.0d0
w_wage_change_jj_nhinhi_sample(m,n)=std_wage_change_jj_nhinhi_sample(m,n)**2.0d0
w_wage_ue_hi_sample(m,n)=std_wage_ue_hi_sample(m,n)**2.0d0
w_wage_ue_nhi_sample(m,n)=std_wage_ue_nhi_sample(m,n)**2.0d0
w_wage_change_stay_sample(m,n)=std_wage_change_stay_sample(m,n)**2.0d0
w_wage_change_stay_hi_sample(m,n)=std_wage_change_stay_hi_sample(m,n)**2.0d0
w_wage_change_stay_nhi_sample(m,n)=std_wage_change_stay_nhi_sample(m,n)**2.0d0


! STANDARD DEVIATION FOR WAGE
DO j=1, 11 !all data periods
DO i=1, sample_size

! education
IF (ed(i,1)==n .or. ed(i,2)==n .or. ed(i,3)==n .or. ed(i,4)==n) THEN


age_index=floor((j-1)/3.0)+1 
age_index=age_data(i,age_index)

IF (age_index>=25+7*(m-1) .and. age_index<25+7*m) THEN 

    IF (ue_data(i,j)==1 .and. hi_data(i,j+1)==1 .and. wage_data(i,j+1)>=0.0d0) THEN
        w_std_wage_ue_hi_sample(m,n)=w_std_wage_ue_hi_sample(m,n)+(wage_data(i,j+1)-wage_ue_hi_sample(m,n))**4.0d0
    END IF
    IF (ue_data(i,j)==1 .and. hi_data(i,j+1)==0 .and. wage_data(i,j+1)>=0.0d0) THEN
        w_std_wage_ue_nhi_sample(m,n)=w_std_wage_ue_nhi_sample(m,n)+(wage_data(i,j+1)-wage_ue_nhi_sample(m,n))**4.0d0
    END IF
        IF (jj_data(i,j)==1 .and. hi_data(i,j)==1 .and. hi_data(i,j+1)==1 .and. wage_data(i,j)>=0.0d0 .and. wage_data(i,j+1)>=0.0d0) THEN
        w_std_wage_change_jj_hihi_sample(m,n)=w_std_wage_change_jj_hihi_sample(m,n)+(wage_data(i,j+1)-wage_data(i,j)-wage_change_jj_hihi_sample(m,n))**4.0d0
    END IF
    IF (jj_data(i,j)==1 .and. hi_data(i,j)==0 .and. hi_data(i,j+1)==0 .and. wage_data(i,j)>=0.0d0  .and. wage_data(i,j+1)>=0.0d0) THEN
        w_std_wage_change_jj_nhinhi_sample(m,n)=w_std_wage_change_jj_nhinhi_sample(m,n)+(wage_data(i,j+1)-wage_data(i,j)-wage_change_jj_nhinhi_sample(m,n))**4.0d0
    END IF   
    IF (jj_data(i,j)==1 .and. hi_data(i,j)==1 .and. hi_data(i,j+1)==0 .and. wage_data(i,j)>=0.0d0 .and. wage_data(i,j+1)>=0.0d0) THEN
        w_std_wage_change_jj_hinhi_sample(m,n)=w_std_wage_change_jj_hinhi_sample(m,n)+(wage_data(i,j+1)-wage_data(i,j)-wage_change_jj_hinhi_sample(m,n))**4.0d0
    END IF
    IF (jj_data(i,j)==1 .and. hi_data(i,j)==0 .and. hi_data(i,j+1)==1 .and. wage_data(i,j)>=0.0d0 .and. wage_data(i,j+1)>=0.0d0) THEN
        w_std_wage_change_jj_nhihi_sample(m,n)=w_std_wage_change_jj_nhihi_sample(m,n)+(wage_data(i,j+1)-wage_data(i,j)-wage_change_jj_nhihi_sample(m,n))**4.0d0
    END IF
    IF (emp_data(i,j)==1 .and. emp_data(i,j+1)==1 .and. jj_data(i,j)==0) THEN
        w_std_wage_change_stay_sample(m,n)=w_std_wage_change_stay_sample(m,n)+ (wage_data(i,j+1)-wage_data(i,j)-wage_change_stay_sample(m,n))**4.0d0
    END IF     
    IF (emp_data(i,j)==1 .and. emp_data(i,j+1)==1 .and. jj_data(i,j)==0 .and. hi_data(i,j)==1) THEN
        w_std_wage_change_stay_hi_sample(m,n)=w_std_wage_change_stay_hi_sample(m,n)+ (wage_data(i,j+1)-wage_data(i,j)-wage_change_stay_sample(m,n))**4.0d0
    END IF  
    IF (emp_data(i,j)==1 .and. emp_data(i,j+1)==1 .and. jj_data(i,j)==0 .and. hi_data(i,j)==0) THEN
        w_std_wage_change_stay_nhi_sample(m,n)=w_std_wage_change_stay_nhi_sample(m,n)+ (wage_data(i,j+1)-wage_data(i,j)-wage_change_stay_nhi_sample(m,n))**4.0d0
    END IF  

END IF    

END IF !education
    
END DO  !i
END DO  !j
! standard deviation
w_std_wage_change_jj_hihi_sample(m,n)=(w_std_wage_change_jj_hihi_sample(m,n)/jj_hihi_sample_count(m,n))**0.50d0
w_std_wage_change_jj_hinhi_sample(m,n)=(w_std_wage_change_jj_hinhi_sample(m,n)/jj_hinhi_sample_count(m,n))**0.50d0
w_std_wage_change_jj_nhihi_sample(m,n)=(w_std_wage_change_jj_nhihi_sample(m,n)/jj_nhihi_sample_count(m,n))**0.50d0
w_std_wage_change_jj_nhinhi_sample(m,n)=(w_std_wage_change_jj_nhinhi_sample(m,n)/jj_nhinhi_sample_count(m,n))**0.50d0
w_std_wage_ue_hi_sample(m,n)=(w_std_wage_ue_hi_sample(m,n)/ue_hi_sample_count(m,n))**0.50d0
w_std_wage_ue_nhi_sample(m,n)=(w_std_wage_ue_nhi_sample(m,n)/ue_nhi_sample_count(m,n))**0.50d0
w_std_wage_change_stay_sample(m,n)=(w_std_wage_change_stay_sample(m,n)/wage_change_stay_sample_count(m,n))**0.50d0
w_std_wage_change_stay_hi_sample(m,n)=(w_std_wage_change_stay_hi_sample(m,n)/wage_change_stay_hi_sample_count(m,n))**0.50d0
w_std_wage_change_stay_nhi_sample(m,n)=(w_std_wage_change_stay_nhi_sample(m,n)/wage_change_stay_nhi_sample_count(m,n))**0.50d0    
    


! health status and medical expenditure
w_health_sample(m,n)=health_sample(m,n)*(1.0d0-health_sample(m,n))

w_health_transition_hh_sample(m,n)=health_transition_hh_sample(m,n)*(1.0d0-health_transition_hh_sample(m,n))
w_health_transition_uu_sample(m,n)=health_transition_uu_sample(m,n)*(1.0d0-health_transition_uu_sample(m,n))



END DO !n

END DO !m


!!!!!!!!!!!!!!!!!!!!!!  medical expenditure from MEPS !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

DO m=1, 3

DO n=1, num_ed

IF (m==1) THEN
age_low=25
age_high=40
ELSE IF (m==2) THEN
age_low=40
age_high=50
ELSE
age_low=50
age_high=60
END IF

!medical expenditure
DO i=1, sample_size_meps

IF (ed_data_meps(i)==n) THEN

age_index=age_data_meps(i)

IF (age_index>=age_low .and. age_index<age_high ) THEN 
    IF (health_data_meps(i)==1 .or. health_data_meps(i)==2) THEN
        health_sample_all_meps(m,n)=health_sample_all_meps(m,n)+1.0d0 
    END IF           
    IF (health_data_meps(i)==1 ) THEN
        med_exp_sample_h_sample(m,n)=med_exp_sample_h_sample(m,n)+med_exp_sample(i)  
        health_sample_meps(m,n)=health_sample_meps(m,n)+1.0d0 
    END IF
    IF (health_data_meps(i)==2 ) THEN
        med_exp_sample_u_sample(m,n)=med_exp_sample_u_sample(m,n)+med_exp_sample(i)   
    END IF
    DO x=1, 2
    DO y=0,1 
    IF (health_data_meps(i)==x .and. hi_data_meps(i)==y) THEN
        count_sample_h_hi(m,n,y+1,x)=count_sample_h_hi(m,n,y+1,x)+1.0d0
        med_exp_sample_h_hi(m,n,y+1,x)=med_exp_sample_h_hi(m,n,y+1,x)+med_exp_sample(i) 
        IF  (med_exp_sample(i)>0.0d0) THEN
        positive_sample_h_hi(m,n,y+1,x)=positive_sample_h_hi(m,n,y+1,x)+1.0d0
        END IF
    END IF
    END DO !x
    END DO !y    
            
END IF    

END IF !ed
    
END DO !i




!mean
DO i=1, 2 !hi
DO j=1, 2 !health
med_exp_sample_h_hi(m,n,i,j)=med_exp_sample_h_hi(m,n,i,j)/count_sample_h_hi(m,n,i,j)
positive_sample_h_hi(m,n,i,j)=positive_sample_h_hi(m,n,i,j)/count_sample_h_hi(m,n,i,j)
END DO
END DO


med_exp_sample_h_sample(m,n)=med_exp_sample_h_sample(m,n)/health_sample_meps(m,n)
med_exp_sample_u_sample(m,n)=med_exp_sample_u_sample(m,n)/(health_sample_all_meps(m,n)-health_sample_meps(m,n))

END DO ! education n


! aggregate medical expenditure
DO i=1, 2 !hi
DO j=1, 2 !health
med_exp_sample_h_hi_1(m,i,j)=0.0d0
positive_sample_h_hi_1(m,i,j)=0.0d0
DO n=1, 2
med_exp_sample_h_hi_1(m,i,j)=med_exp_sample_h_hi_1(m,i,j)+med_exp_sample_h_hi(m,n,i,j)*count_sample_h_hi(m,n,i,j)
positive_sample_h_hi_1(m,i,j)=positive_sample_h_hi_1(m,i,j)+positive_sample_h_hi(m,n,i,j)*count_sample_h_hi(m,n,i,j) 
END DO
med_exp_sample_h_hi_1(m,i,j)=med_exp_sample_h_hi_1(m,i,j)/sum(count_sample_h_hi(m,:,i,j))
positive_sample_h_hi_1(m,i,j)=positive_sample_h_hi_1(m,i,j)/sum(count_sample_h_hi(m,:,i,j))
count_sample_h_hi_1(m,i,j)=sum(count_sample_h_hi(m,:,i,j))
END DO 
END DO

 
!standard deviation
DO i=1, sample_size_meps

age_index=age_data_meps(i)

IF (age_index>=age_low .and. age_index<age_high ) THEN 

    DO x=1, 2
    DO y=0,1      
    IF (health_data_meps(i)==x .and. hi_data_meps(i)==y) THEN
        std_med_exp_sample_h_hi_1(m,y+1,x)=std_med_exp_sample_h_hi_1(m,y+1,x)+(med_exp_sample(i)- med_exp_sample_h_hi_1(m,y+1,x))**2.0d0
    END IF
    END DO
    END DO

END IF


DO n=1, num_ed

IF (ed_data_meps(i)==n) THEN


IF (age_index>=age_low .and. age_index<age_high ) THEN 

    IF (health_data_meps(i)==1 ) THEN
        std_med_exp_sample_h_sample(m,n)=std_med_exp_sample_h_sample(m,n)+(med_exp_sample(i)-med_exp_sample_h_sample(m,n))**2.0d0  
    ELSE IF (health_data_meps(i)==2 ) THEN
        std_med_exp_sample_u_sample(m,n)=std_med_exp_sample_u_sample(m,n)+(med_exp_sample(i)-med_exp_sample_u_sample(m,n))**2.0d0   
    END IF
    DO x=1, 2
    DO y=0,1      
    IF (health_data_meps(i)==x .and. hi_data_meps(i)==y) THEN
        std_med_exp_sample_h_hi(m,n,y+1,x)=std_med_exp_sample_h_hi(m,n,y+1,x)+(med_exp_sample(i)- med_exp_sample_h_hi(m,n,y+1,x))**2.0d0
    END IF
    END DO
    END DO    
    
    
    
END IF    

END IF !education

END DO !education
    
END DO !i


DO n=1, num_ed
    
std_med_exp_sample_h_sample(m,n)=(std_med_exp_sample_h_sample(m,n)/health_sample_meps(m,n))**0.50d0
std_med_exp_sample_u_sample(m,n)=(std_med_exp_sample_u_sample(m,n)/(health_sample_all_meps(m,n)-health_sample_meps(m,n)))**0.50d0

DO i=1, 2
DO j=1, 2
w_med_exp_sample_h_hi(m,n,i,j)=std_med_exp_sample_h_hi(m,n,i,j)/count_sample_h_hi(m,n,i,j)
std_med_exp_sample_h_hi(m,n,i,j)=(std_med_exp_sample_h_hi(m,n,i,j)/count_sample_h_hi(m,n,i,j))**0.50d0
END DO
END DO

END DO ! education


DO i=1, 2
DO j=1, 2
w_med_exp_sample_h_hi_1(m,i,j)=std_med_exp_sample_h_hi_1(m,i,j)/count_sample_h_hi_1(m,i,j)
std_med_exp_sample_h_hi_1(m,i,j)=(std_med_exp_sample_h_hi_1(m,i,j)/count_sample_h_hi_1(m,i,j))**0.50d0
END DO
END DO

!medical expenditure
DO i=1, sample_size_meps

age_index=age_data_meps(i)

IF (age_index>=age_low .and. age_index<age_high ) THEN   

    DO x=1, 2
    DO y=0, 1 
    IF (health_data_meps(i)==x .and. hi_data_meps(i)==y) THEN
        w_std_med_exp_sample_h_hi_1(m,y+1,x)=w_std_med_exp_sample_h_hi_1(m,y+1,x)+(med_exp_sample(i)- med_exp_sample_h_hi_1(m,y+1,x))**4.0d0
        IF  (med_exp_sample(i)>0.0d0) THEN
        w_positive_sample_h_hi_1(m,y+1,x)=w_positive_sample_h_hi_1(m,y+1,x)+(1.0d0-positive_sample_h_hi_1(m,y+1,x))**2.0d0
        ELSE
        w_positive_sample_h_hi_1(m,y+1,x)=w_positive_sample_h_hi_1(m,y+1,x)+(0.0d0-positive_sample_h_hi_1(m,y+1,x))**2.0d0
        END IF
    END IF
    END DO
    END DO 

END IF

DO n=1, num_ed 

IF (ed_data_meps(i)==n) THEN



! Age group 25-39, 40-49, 50-59 

IF (age_index>=age_low .and. age_index<age_high ) THEN          
    IF (health_data_meps(i)==1 ) THEN
        w_med_exp_sample_h_sample(m,n)=w_med_exp_sample_h_sample(m,n)+(med_exp_sample(i)-med_exp_sample_h_sample(m,n))**2.0d0  
        w_std_med_exp_sample_h_sample(m,n)=w_std_med_exp_sample_h_sample(m,n)+(med_exp_sample(i)-med_exp_sample_h_sample(m,n))**4.0d0   
    END IF
    IF (health_data_meps(i)==2 ) THEN
       w_med_exp_sample_u_sample(m,n)=w_med_exp_sample_u_sample(m,n)+(med_exp_sample(i)-med_exp_sample_u_sample(m,n))**2.0d0
        w_std_med_exp_sample_u_sample(m,n)=w_std_med_exp_sample_u_sample(m,n)+(med_exp_sample(i)-med_exp_sample_u_sample(m,n))**4.0d0      
    END IF
    DO x=1, 2
    DO y=0, 1 
    IF (health_data_meps(i)==x .and. hi_data_meps(i)==y) THEN
        w_std_med_exp_sample_h_hi(m,n,y+1,x)=w_std_med_exp_sample_h_hi(m,n,y+1,x)+(med_exp_sample(i)- med_exp_sample_h_hi(m,n,y+1,x))**4.0d0
        IF  (med_exp_sample(i)>0.0d0) THEN
        w_positive_sample_h_hi(m,n,y+1,x)=w_positive_sample_h_hi(m,n,y+1,x)+(1.0d0-positive_sample_h_hi(m,n,y+1,x))**2.0d0
        ELSE
        w_positive_sample_h_hi(m,n,y+1,x)=w_positive_sample_h_hi(m,n,y+1,x)+(0.0d0-positive_sample_h_hi(m,n,y+1,x))**2.0d0
        END IF
    END IF
    END DO
    END DO    
    
END IF    

END IF !education

END DO ! education

    
END DO !i


DO n=1, num_ed

!mean
w_med_exp_sample_h_sample(m,n)=w_med_exp_sample_h_sample(m,n)/health_sample_meps(m,n)
w_med_exp_sample_u_sample(m,n)=w_med_exp_sample_u_sample(m,n)/(health_sample_all_meps(m,n)-health_sample_meps(m,n))    
w_std_med_exp_sample_h_sample(m,n)=(w_std_med_exp_sample_h_sample(m,n)/health_sample_meps(m,n))**0.50d0
w_std_med_exp_sample_u_sample(m,n)=(w_std_med_exp_sample_u_sample(m,n)/(health_sample_all_meps(m,n)-health_sample_meps(m,n)))**0.50d0

DO i=1, 2
DO j=1, 2
w_std_med_exp_sample_h_hi(m,n,i,j)=w_std_med_exp_sample_h_hi(m,n,i,j)/count_sample_h_hi(m,n,i,j)
w_positive_sample_h_hi(m,n,i,j)=w_positive_sample_h_hi(m,n,i,j)/count_sample_h_hi(m,n,i,j)
END DO
END DO


END DO !n

! calculate aggregate education variabele

DO i=1, 2
DO j=1, 2
w_std_med_exp_sample_h_hi_1(m,i,j)=w_std_med_exp_sample_h_hi_1(m,i,j)/count_sample_h_hi_1(m,i,j)
w_positive_sample_h_hi_1(m,i,j)=w_positive_sample_h_hi_1(m,i,j)/count_sample_h_hi_1(m,i,j)
END DO
END DO



END DO !m



DO m=1, 3
DO i=1, 2
DO j=1, 2
IF (w_positive_sample_h_hi_1(m,i,j)==0.0d0 ) THEN
w_positive_sample_h_hi_1(m,i,j)=1000000000.0d0 !ignore
END IF
DO n=1, 2
IF (w_positive_sample_h_hi(m,n,i,j)==0.0d0 ) THEN
w_positive_sample_h_hi(m,n,i,j)=1000000000.0d0 !ignore
END IF
END DO
END DO
END DO
END DO

!!!!!!!!!!!!!!!!!  fraction of health !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

DO n=1, 2
health_hi(n)=0.0d0
health_nhi(n)=0.0d0
health_unemp(n)=0.0d0
w_health_hi(n)=0.0d0
w_health_nhi(n)=0.0d0
w_health_unemp(n)=0.0d0
denom1=0.0d0
denom2=0.0d0
denom3=0.0d0
DO j=1, 2
DO i=1, sample_size
!health fraction

IF (ed(i,j)==n) THEN

    IF ( hi_data(i,j*3+1)==1 .and. emp_data(i,j*3+1)==1) THEN
    denom1=denom1+1.0d0
    ELSE IF ( hi_data(i,j*3+1)==0 .and. emp_data(i,j*3+1)==1) THEN
    denom2=denom2+1.0d0
    ELSE IF (  emp_data(i,j*3+1)==0) THEN
    denom3=denom3+1.0d0
    END IF
    
    IF (health_data(i,j)==1 .and. hi_data(i,j*3+1)==1 .and. emp_data(i,j*3+1)==1) THEN
    health_hi(n)=health_hi(n)+1.0d0
    ELSE IF (health_data(i,j)==1 .and. hi_data(i,j*3+1)==0 .and. emp_data(i,j*3+1)==1) THEN
    health_nhi(n)=health_nhi(n)+1.0d0
    ELSE IF (health_data(i,j)==1 .and. emp_data(i,j*3+1)==0) THEN
    health_unemp(n)=health_unemp(n)+1.0d0
    END IF

END IF

END DO
END DO
    
health_hi(n)=health_hi(n)/denom1    
health_nhi(n)=health_nhi(n)/denom2   
health_unemp(n)=health_unemp(n)/denom3      

w_health_hi(n)=health_hi(n)*(1.0d0-health_hi(n))
w_health_nhi(n)=health_nhi(n)*(1.0d0-health_nhi(n))
w_health_unemp(n)=health_unemp(n)*(1.0d0-health_unemp(n))



END DO

!EMPLOYER SIDE MOMENTS
emp_size_mean_data=2.081982  
sample_frac_small_firm=0.92955d0      
sample_wage_ratio=0.9090d0        
sample_firm_size_hi=2.96444d0  
sample_firm_size_nhi=0.7890277d0  
sample_ehi_small=0.5686196d0   
sample_ehi_large=0.9338051d0   
sample_firm_mean_wage_nhi=0.6777024d0
sample_firm_mean_wage_hi=0.9730109d0
sample_firm_std_wage_nhi=0.7572715d0
sample_firm_std_wage_hi=0.8340561d0
sample_mean_offer_rate=0.5943492d0
sample_emp_age_s=32.39d0
sample_emp_age_l=34.98d0
sample_emp_age_hi=42.00299d0
sample_emp_age_nhi=40.50354d0
 
w_emp_size_mean_data=5.38675d0**(-2.0d0) !moment (4)
w_sample_frac_small_firm=0.2559d0**(-2.0d0)
w_sample_wage_ratio=1.0d0         !moment(6)
w_sample_firm_size_hi=6.772771d0**(-2.0d0)  !moment_value(7)
w_sample_firm_size_nhi=1.230435d0**(-2.0d0)  !moment_value(8)
w_sample_ehi_small=0.4953996d0**(-2.0d0)   !moment_value(9)
w_sample_ehi_large=0.2486473d0**(-2.0d0)   !moment_value(10)
w_sample_mean_offer_rate=0.4910532d0**(-2.0d0) !moment 11
w_sample_firm_mean_wage_nhi=0.7572715d0**(-2.0d0)
w_sample_firm_mean_wage_hi=0.8340561d0**(-2.0d0)
w_sample_firm_std_wage_nhi=3.67272d0**(-2.0d0) 
w_sample_firm_std_wage_hi=3.428864d0**(-2.0d0)
w_sample_emp_age_s=29.25d0**(-2.0d0)
w_sample_emp_age_l=24.65d0**(-2.0d0) 
w_sample_emp_age_hi=7.120735d0**(-2.0d0)
w_sample_emp_age_nhi=5.2006d0**(-2.0d0) 

w_firm_mat(1)=w_emp_size_mean_data
w_firm_mat(2)=w_sample_frac_small_firm
w_firm_mat(3)=w_sample_firm_size_hi
w_firm_mat(4)=w_sample_firm_size_nhi
w_firm_mat(5)=w_sample_ehi_small
w_firm_mat(6)=w_sample_ehi_large
w_firm_mat(7)=w_sample_mean_offer_rate


IF (data_mode==2) THEN 

! record data moments
OPEN(100, file="sample_ump_rate_sample.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) ump_rate_sample(i,n), w_ump_rate_sample(i,n)
END DO
END DO  
CLOSE (100)

OPEN(100, file="sample_hi_rate.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) hi_rate_sample(i,n), w_hi_rate_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_wage_hi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) wage_hi_sample(i,n), w_wage_hi_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_wage_nhi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) wage_nhi_sample(i,n), w_wage_nhi_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_std_wage_hi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) std_wage_hi_sample(i,n), w_std_wage_hi_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_std_wage_nhi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) std_wage_nhi_sample(i,n), w_std_wage_nhi_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_ue.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) ue_sample(i,n), w_ue_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_ue_hi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) ue_hi_sample(i,n), w_ue_hi_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_ue_nhi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) ue_nhi_sample(i,n), w_ue_nhi_sample(i,n)
END DO 
END DO 
CLOSE (100)
    
OPEN(100, file="sample_eu.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) eu_sample(i,n), w_eu_sample(i,n)
END DO 
END DO 
CLOSE (100)
    
OPEN(100, file="sample_jj.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) jj_sample(i,n), w_jj_sample(i,n)
END DO 
END DO 
CLOSE (100)    

OPEN(100, file="sample_jj_hihi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) jj_hihi_sample(i,n), w_jj_hihi_sample(i,n)
END DO 
END DO 
CLOSE (100)    

OPEN(100, file="sample_jj_nhihi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) jj_nhihi_sample(i,n), w_jj_nhihi_sample(i,n)
END DO 
END DO 
CLOSE (100)    

OPEN(100, file="sample_jj_hinhi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) jj_hinhi_sample(i,n), w_jj_hinhi_sample(i,n)
END DO 
END DO 
CLOSE (100)    

OPEN(100, file="sample_jj_nhinhi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) jj_nhinhi_sample(i,n), w_jj_nhinhi_sample(i,n)
END DO 
END DO 
CLOSE (100)    


OPEN(100, file="sample_wage_change_jj_hihi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) wage_change_jj_hihi_sample(i,n), w_wage_change_jj_hihi_sample(i,n)
END DO 
END DO 
CLOSE (100)    

OPEN(100, file="sample_wage_change_jj_nhihi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) wage_change_jj_nhihi_sample(i,n), w_wage_change_jj_nhihi_sample(i,n)
END DO 
END DO 
CLOSE (100)    

OPEN(100, file="sample_wage_change_jj_hinhi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) wage_change_jj_hinhi_sample(i,n), w_wage_change_jj_hinhi_sample(i,n)
END DO 
END DO 
CLOSE (100)    

OPEN(100, file="sample_wage_change_jj_nhinhi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) wage_change_jj_nhinhi_sample(i,n),  w_wage_change_jj_nhinhi_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_wage_change_stay.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) wage_change_stay_sample(i,n), w_wage_change_stay_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_wage_change_stay_hi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) wage_change_stay_hi_sample(i,n), w_wage_change_stay_hi_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_wage_change_stay_nhi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) wage_change_stay_nhi_sample(i,n), w_wage_change_stay_nhi_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_wage_ue_hi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) wage_ue_hi_sample(i,n), w_wage_ue_hi_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_wage_ue_nhi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) wage_ue_nhi_sample(i,n), w_wage_ue_nhi_sample(i,n)
END DO 
END DO 
CLOSE (100)


OPEN(100, file="sample_std_wage_change_jj_hihi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) std_wage_change_jj_hihi_sample(i,n), w_std_wage_change_jj_hihi_sample(i,n)
END DO 
END DO 
CLOSE (100)    

OPEN(100, file="sample_std_wage_change_jj_nhihi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) std_wage_change_jj_nhihi_sample(i,n), w_std_wage_change_jj_nhihi_sample(i,n)
END DO 
END DO 
CLOSE (100)    

OPEN(100, file="sample_std_wage_change_jj_hinhi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) std_wage_change_jj_hinhi_sample(i,n), w_std_wage_change_jj_hinhi_sample(i,n)
END DO 
END DO 
CLOSE (100)    

OPEN(100, file="sample_std_wage_change_jj_nhinhi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) std_wage_change_jj_nhinhi_sample(i,n), w_std_wage_change_jj_nhinhi_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_std_wage_change_stay.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) std_wage_change_stay_sample(i,n), w_std_wage_change_stay_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_std_wage_change_stay_hi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) std_wage_change_stay_hi_sample(i,n), w_std_wage_change_stay_hi_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_std_wage_change_stay_nhi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) std_wage_change_stay_nhi_sample(i,n), w_std_wage_change_stay_nhi_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_std_wage_ue_hi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) std_wage_ue_hi_sample(i,n),  w_std_wage_ue_hi_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_std_wage_ue_nhi.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) std_wage_ue_nhi_sample(i,n), w_std_wage_ue_nhi_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_health.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) health_sample(i,n), w_health_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_health_transition_hh.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) health_transition_hh_sample(i,n), w_health_transition_hh_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_health_transition_uu.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) health_transition_uu_sample(i,n), w_health_transition_uu_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_med_exp_sample_h.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) med_exp_sample_h_sample(i,n), w_med_exp_sample_h_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_med_exp_sample_u.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) med_exp_sample_u_sample(i,n), w_med_exp_sample_u_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_std_med_exp_sample_h.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) std_med_exp_sample_h_sample(i,n), w_std_med_exp_sample_h_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_std_med_exp_sample_u.txt")
DO n=1, 2
DO i=1, 5
 write(100, *) std_med_exp_sample_u_sample(i,n), w_std_med_exp_sample_u_sample(i,n)
END DO 
END DO 
CLOSE (100)

OPEN(100, file="sample_health_hi.txt")
DO n=1, 2
 write(100, *) health_hi(n), w_health_hi(n)
END DO 
CLOSE (100)

OPEN(100, file="sample_health_nhi.txt")
DO n=1, 2
 write(100, *) health_nhi(n), w_health_nhi(n)
END DO 
CLOSE (100)
OPEN(100, file="sample_health_unemp.txt")
DO n=1, 2
 write(100, *) health_unemp(n), w_health_unemp(n)
END DO 
CLOSE (100)


END IF

!calculate second moments

END SUBROUTINE