SUBROUTINE ev_moments(param,objective_value )


use params
use mod_dp
use probability


implicit none

LOGICAL ISNAN

integer num_param
REAL (dp), INTENT(IN)  :: param(num_param_est)
!REAL (dp), INTENT(IN)  :: param(:)
REAL (dp), INTENT(OUT) :: objective_value
REAL(DP) obj_value, denom
integer i, k, counter



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! read parameters
counter=1
prob_type1(1)=param(counter) !type 1 prob. for high educated
counter=counter+1
prob_type1(2)=param(counter) !type 1 prob. for low educated
counter=counter+1
gamma(1)=param(counter)	!-CARA high educated
counter=counter+1
gamma(2)=param(counter)	!-CARA low educated
counter=counter+1
theta(2,1)=param(counter)    !  -disutlity from bad health
counter=counter+1
theta(2,2)=param(counter)    !  -disutlity from bad health
counter=counter+1
eta=param(counter)  !, 	-disutility from labor
counter=counter+1
ump_flow=param(counter) !, -disutility from working
counter=counter+1
alpha_m(1)=param(counter) !, 	-the coeff. in med_need shock: good health
counter=counter+1
 alpha_m(2)=param(counter) !, 	-the coeff. in med_need shock: bad health
counter=counter+1
 beta_m(1)=param(counter) !, 	-the coeff. in med_need shock 
counter=counter+1
gamma_m(1)=param(counter)  !, 	-the coeff. in med_need shock 
counter=counter+1
sigma_m(1)=param(counter)	 !-std. dev for medical needs shock
counter=counter+1
kappa(1)=param(counter)	 !the medical expenditure shifter
counter=counter+1
sigma_prod=param(counter) !std of prodctuvitiy dist.
counter=counter+1
 delta(1)=param(counter) !, & 	-layoff probability
counter=counter+1
 lambda_u(1,1)=param(counter)	!	arrival rate of job offer to unemployed
 counter=counter+1
 lambda_e(1,1)=param(counter)	!	arrival rate of job offer to employed
 counter=counter+1
 delta(2)=param(counter) !, & 	-layoff probability
 counter=counter+1
 lambda_u(1,2)=param(counter)	!	arrival rate of job offer to unemployed
 counter=counter+1
 lambda_e(1,2)=param(counter)	!	arrival rate of job offer to employed
 counter=counter+1
 alpha_w_1(1)=param(counter) ! 	-coeff. in const. term wage equation for type 1
 counter=counter+1
 alpha_w_1_ed(1)=param(counter) ! 	-coeff. in const. term wage equation for high skilled
 counter=counter+1
 alpha_w_1_ed(2)=param(counter) ! 	-coeff. in const. term wage equation for low skilled 
 counter=counter+1
 alpha_w_4(1)=param(counter) ! 	-coeff. in exp term wage equation for type 1
 counter=counter+1
 alpha_w_4_ed(1)=param(counter) ! 	-coeff. in exp term wage equation for high skilled
 counter=counter+1
 alpha_w_4_ed(2)=param(counter) ! 	-coeff. in exp term wage equation for low skilled
 counter=counter+1
 alpha_w_5(1)=param(counter) ! 	-coeff. in exp**2 term wage equation for type 1
 counter=counter+1
 alpha_w_5_ed(1)=param(counter) ! 	-coeff. in exp**2 term wage equation for high skilled
 counter=counter+1
 alpha_w_5_ed(2)=param(counter) ! 	-coeff. in exp**2 term wage equation for low skilled
 counter=counter+1
 alpha_1_k(1,1)=param(counter)  ! the coeff in health transition where current health is 1 and tomorrow is 1
 counter=counter+1
alpha_1_k(2,2)=param(counter)  ! the coeff in health transition where current health is 2 and tomorrow is 2
 counter=counter+1
alpha_2_k(2,1)=param(counter)  ! the coeff in health transition: medical care dummy
 counter=counter+1
alpha_3_k(2,1)=param(counter)  ! the coeff in health transition: idiosyncratic shock
 counter=counter+1
alpha_4_k(2,1)=param(counter)  ! the coeff in health transition: age
 counter=counter+1
alpha_5_k(2,2)=param(counter)  ! the coeff in health transition to next period unhealthy: type=1
 counter=counter+1
alpha_6_k(2,1)=param(counter)    !interaction between exp and shock 
 counter=counter+1
alpha_2_k(2,2)=param(counter)  ! the coeff in health transition: medical care dummy
 counter=counter+1
alpha_3_k(2,2)=param(counter)  ! the coeff in health transition: idiosyncratic shock
 counter=counter+1
alpha_4_k(2,2)=param(counter)  ! the coeff in health transition: age
 counter=counter+1
alpha_6_k(2,2)=param(counter)    !interaction between exp and shock 
 counter=counter+1
term_health(2)=param(counter)   !terminal value for unhealthy
counter=counter+1
loading_ehi=param(counter)   ! loading factor for EHI
counter=counter+1
worker_size1=param(counter) !worker size
counter=counter+1
scale_prof=param(counter)  !scale parameter for choice specific shocks.
counter=counter+1
eta_u=param(counter)  !, 	-disutility from labor
counter=counter+1
pref_scale=param(counter)  !, 	-disutility from labor
counter=counter+1
alpha_w_6(2)=param(counter) ! 	productivity effect of bad health
counter=counter+1
beta_m(2)=param(counter)
counter=counter+1
gamma_m(2)=param(counter)
counter=counter+1
kappa(2)=param(counter)
counter=counter+1
sigma_m(2)=param(counter)	 !-std. dev for medical needs shock
counter=counter+1
sigma_wage_error=param(counter)
counter=counter+1
lambda_e(2,1)=param(counter)
counter=counter+1
lambda_e(2,2)=param(counter)
counter=counter+1
lambda_u(2,1)=param(counter)
counter=counter+1
lambda_u(2,2)=param(counter)
counter=counter+1
cons_floor=param(counter)
counter=counter+1
pref_ii=param(counter)

!!! The support of Firm productivity grid !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
firm_prod(1)=0.10d0

firm_prod(num_firm)=exp(2.00d0)  
 
DO i=2, num_firm-1
firm_prod(i)=firm_prod(1)+(i-1)*(firm_prod(num_firm)-firm_prod(1))/(num_firm-1)
END DO

!! productivity distribution !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!probability
denom=0.0d0 

DO i=1, num_firm


prob_meet(i)= LOGNORMPDF(firm_prod(i),0.00d0,(sigma_prod)**2.0d0)

denom=denom+prob_meet(i)
END DO
 
DO i=1, num_firm
prob_meet(i)=prob_meet(i)/denom
END DO
  

!create cumulative distribution
cum_meet(1)=prob_meet(1)
DO k=2, num_firm
cum_meet(k)=cum_meet(k-1)+prob_meet(k)
END DO

IF (data_mode==2) THEN 

OPEN(100, file="firm_prod.txt")
DO i=1, num_firm
 write(100, *) firm_prod(i)
END DO 
CLOSE (100)



!
OPEN(100, file="prob_meet.txt")
DO i=1, num_firm
 write(100, *) cum_meet(i), prob_meet(i)
END DO 
CLOSE (100)

END IF


!!!!!!!!!!!!!!! discretize z_sim grid !!!!!!!!!!!!!!!!!!!!!!!!!!
z_sim(1)=0.01d0
z_sim(num_firm_sim)=firm_prod(1)

DO i=2, num_firm_sim-1
z_sim(i)=z_sim(1)+(i-1)*(z_sim(num_firm_sim)-z_sim(1))/(num_firm_sim-1.0d0)
END DO



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! solve equilibrium
CALL solve_eq

!create simulation data
CALL simulate_data

call save_result




!evaluate employer side moments

CALL firm_prod_est(obj_value)

! EVALUATE worker-side MOMENTS
CALL sim_moments(objective_value)

! sum up the moment value
objective_value=objective_value+obj_value

IF (non_converge==1) THEN
objective_value=1000.0d0
END IF




OPEN(100, file="parameter_value_updates.txt",position='append')
write(100, *) objective_value, 'obj_value'
DO i=1, num_param_est
 write(100, *) param(i)
END DO
CLOSE (100)



END SUBROUTINE

