subroutine matrix_weight

!use params
!use mod_dp
!implicit none
!
!LOGICAL ISNAN
!
!REAL(DP) mom_number
!integer:: i,j,k,n,m,t, tt, count !index
!integer, parameter:: c_size=7
!REAL(DP) moments(num_moment1, 5, 2), moments1(num_moment2,2)
!! employment rate


!DO n=1, 2
!
!DO t=1, 5
!v_cv_weight(1,t,n)=w_ump_rate_sample(t,n)**(-1.0d0)
!v_cv_weight(2,t,n)=w_ue_hi_sample(t,n)**(-1.0d0)
!v_cv_weight(3,t,n)=w_ue_nhi_sample(t,n)**(-1.0d0)
!v_cv_weight(4,t,n)=w_eu_sample(t,n)**(-1.0d0)
!v_cv_weight(5,t,n)=w_wage_hi_sample(t,n)**(-1.0d0)
!v_cv_weight(6,t,n)=w_wage_nhi_sample(t,n)**(-1.0d0)
!v_cv_weight(7,t,n)=w_std_wage_hi_sample(t,n)**(-1.0d0)
!v_cv_weight(8,t,n)=w_std_wage_nhi_sample(t,n)**(-1.0d0)
!!print*, wage_average_hi_c(t,n), wage_hi_sample(t,n), 'mean_hi'
!!print*, wage_average_nhi_c(t,n), wage_nhi_sample(t,n), 'mean_nhi'
!!print*, std_wage_average_hi_c(t,n), std_wage_hi_sample(t,n), 'std_hi'
!!print*, std_wage_average_nhi_c(t,n), std_wage_nhi_sample(t,n), 'std_nhi'
!!print*, w_std_wage_hi_sample(t,n), w_std_wage_nhi_sample(t,n), 'w_std'
!!print*, w_wage_hi_sample(t,n), w_wage_nhi_sample(t,n), 'w_mean'
!v_cv_weight(9,t,n)=w_jj_sample(t,n)**(-1.0d0)
!v_cv_weight(10,t,n)=w_jj_hihi_sample(t,n)**(-1.0d0)
!v_cv_weight(11,t,n)=w_jj_hinhi_sample(t,n)**(-1.0d0)
!v_cv_weight(12,t,n)=w_jj_nhihi_sample(t,n)**(-1.0d0)
!v_cv_weight(13,t,n)=w_jj_nhinhi_sample(t,n)**(-1.0d0)
!v_cv_weight(14,t,n)=w_wage_change_jj_hihi_sample(t,n)**(-1.0d0)
!v_cv_weight(15,t,n)=w_wage_change_jj_hinhi_sample(t,n)**(-1.0d0)
!v_cv_weight(16,t,n)=w_wage_change_jj_nhihi_sample(t,n)**(-1.0d0)
!v_cv_weight(17,t,n)=w_wage_change_jj_nhinhi_sample(t,n)**(-1.0d0)
!v_cv_weight(18,t,n)=w_std_wage_change_jj_hihi_sample(t,n)**(-1.0d0)
!v_cv_weight(19,t,n)=w_std_wage_change_jj_hinhi_sample(t,n)**(-1.0d0)
!v_cv_weight(20,t,n)=w_std_wage_change_jj_nhihi_sample(t,n)**(-1.0d0)
!v_cv_weight(21,t,n)=w_std_wage_change_jj_nhinhi_sample(t,n)**(-1.0d0)
!v_cv_weight(22,t,n)=w_wage_change_stay_hi_sample(t,n)**(-1.0d0)
!v_cv_weight(23,t,n)=w_wage_change_stay_nhi_sample(t,n)**(-1.0d0)
!v_cv_weight(24,t,n)=w_std_wage_change_stay_hi_sample(t,n)**(-1.0d0)
!v_cv_weight(25,t,n)=w_std_wage_change_stay_nhi_sample(t,n)**(-1.0d0)
!v_cv_weight(26,t,n)=w_wage_ue_hi_sample(t,n)**(-1.0d0)
!v_cv_weight(27,t,n)=w_wage_ue_nhi_sample(t,n)**(-1.0d0)
!v_cv_weight(28,t,n)=w_std_wage_ue_hi_sample(t,n)**(-1.0d0)
!v_cv_weight(29,t,n)=w_std_wage_ue_nhi_sample(t,n)**(-1.0d0)
!v_cv_weight(30,t,n)=w_hi_rate_sample(t,n)**(-1.0d0)
!v_cv_weight(31,t,n)=w_health_sample(t,n)**(-1.0d0)
!v_cv_weight(32,t,n)=w_health_transition_hh_sample(t,n)**(-1.0d0)
!v_cv_weight(33,t,n)=w_health_transition_uu_sample(t,n)**(-1.0d0)
!v_cv_weight(34,t,n)=w_med_exp_sample_h_sample(t,n)**(-1.0d0)
!v_cv_weight(35,t,n)=w_med_exp_sample_u_sample(t,n)**(-1.0d0)
!v_cv_weight(36,t,n)=w_std_med_exp_sample_h_sample(t,n)**(-1.0d0)
!v_cv_weight(37,t,n)=w_std_med_exp_sample_u_sample(t,n)**(-1.0d0)
!v_cv_weight(38,t,n)=w_med_exp_sample_h_hi(t,n,1,1)**(-1.0d0)
!v_cv_weight(39,t,n)=w_med_exp_sample_h_hi(t,n,2,1)**(-1.0d0)
!v_cv_weight(40,t,n)=w_med_exp_sample_h_hi(t,n,1,2)**(-1.0d0)
!v_cv_weight(41,t,n)=w_med_exp_sample_h_hi(t,n,2,2)**(-1.0d0)
!v_cv_weight(42,t,n)=w_std_med_exp_sample_h_hi(t,n,1,1)**(-1.0d0)
!v_cv_weight(43,t,n)=w_std_med_exp_sample_h_hi(t,n,2,1)**(-1.0d0)
!v_cv_weight(44,t,n)=w_std_med_exp_sample_h_hi(t,n,1,2)**(-1.0d0)
!v_cv_weight(45,t,n)=w_std_med_exp_sample_h_hi(t,n,2,2)**(-1.0d0)
!v_cv_weight(46,t,n)=w_positive_sample_h_hi(t,n,1,1)**(-1.0d0)
!v_cv_weight(47,t,n)=w_positive_sample_h_hi(t,n,2,1)**(-1.0d0)
!v_cv_weight(48,t,n)=w_positive_sample_h_hi(t,n,1,2)**(-1.0d0)
!v_cv_weight(49,t,n)=w_positive_sample_h_hi(t,n,2,2)**(-1.0d0)
!
!END DO
!v_cv_weight1(1, n)=w_health_hi(n)**(-1.0d0)
!v_cv_weight1(2, n)=w_health_nhi(n)**(-1.0d0)
!v_cv_weight1(3, n)=w_health_unemp(n)**(-1.0d0)
!
!END DO
!
!DO j=1, 13
!v_firm(j)=w_firm_mat(j)
!END DO


END SUBROUTINE