SUBROUTINE param_reverse

use params
use mod_dp

integer counter

	!ALLOCATE ARRAYS

counter=1
param_est(counter)=prob_type1(1) !type 1 prob. for high educated
counter=counter+1
param_est(counter)=prob_type1(2) !type 1 prob. for low educated
counter=counter+1
param_est(counter)=gamma(1)	!-CARA high educated
counter=counter+1
param_est(counter)=gamma(2)	!-CARA low educated
counter=counter+1
param_est(counter)=theta(2,1)    !  -disutlity from bad health
counter=counter+1
param_est(counter)=theta(2,2)    !  -disutlity from bad health
counter=counter+1
param_est(counter)=eta  !, 	-disutility from labor
counter=counter+1
param_est(counter)=ump_flow !, -disutility from working
counter=counter+1
param_est(counter)=alpha_m(1) !, 	-the coeff. in med_need shock: good health
counter=counter+1
 param_est(counter)=alpha_m(2) !, 	-the coeff. in med_need shock: bad health
counter=counter+1
 param_est(counter)=beta_m(1) !, 	-the coeff. in med_need shock 
counter=counter+1
param_est(counter)=gamma_m(1)  !, 	-the coeff. in med_need shock 
counter=counter+1
param_est(counter)=sigma_m(1)	 !-std. dev for medical needs shock
counter=counter+1
param_est(counter)=kappa(1)	 !the medical expenditure shifter
counter=counter+1
param_est(counter)=sigma_prod !std of prodctuvitiy dist.
counter=counter+1
 param_est(counter)=delta(1) !, & 	-layoff probability (Kaplan, 20 year experience)
counter=counter+1
 param_est(counter)=lambda_u(1,1)	!	arrival rate of job offer to unemployed
 counter=counter+1
 param_est(counter)=lambda_e(1,1)	!	arrival rate of job offer to employed
 counter=counter+1
 param_est(counter)=delta(2) !, & 	-layoff probability (Kaplan, 20 year experience)
 counter=counter+1
 param_est(counter)=lambda_u(1,2)	!	arrival rate of job offer to unemployed
 counter=counter+1
 param_est(counter)=lambda_e(1,2)	!	arrival rate of job offer to employed
 counter=counter+1
 param_est(counter)=alpha_w_1(1) ! 	-coeff. in const. term wage equation for type 1
 counter=counter+1
 param_est(counter)=alpha_w_1_ed(1) ! 	-coeff. in const. term wage equation for high skilled
 counter=counter+1
 param_est(counter)=alpha_w_1_ed(2) ! 	-coeff. in const. term wage equation for low skilled 
 counter=counter+1
 param_est(counter)=alpha_w_4(1) ! 	-coeff. in exp term wage equation for type 1
  step_est(counter)=param_est(counter)*0.05
 counter=counter+1
 param_est(counter)=alpha_w_4_ed(1) ! 	-coeff. in exp term wage equation for high skilled
  step_est(counter)=param_est(counter)*0.05
 counter=counter+1
 param_est(counter)=alpha_w_4_ed(2) ! 	-coeff. in exp term wage equation for low skilled
  step_est(counter)=param_est(counter)*0.05
 counter=counter+1
 param_est(counter)=alpha_w_5(1) ! 	-coeff. in exp**2 term wage equation for type 1
 step_est(counter)=param_est(counter)*0.05
 counter=counter+1
 param_est(counter)=alpha_w_5_ed(1) ! 	-coeff. in exp**2 term wage equation for high skilled
  step_est(counter)=param_est(counter)*0.05
 counter=counter+1
 param_est(counter)=alpha_w_5_ed(2) ! 	-coeff. in exp**2 term wage equation for low skilled
  step_est(counter)=param_est(counter)*0.05
 counter=counter+1
 param_est(counter)=alpha_1_k(1,1)  ! the coeff in health transition where current health is 1 and tomorrow is 1
 counter=counter+1
param_est(counter)=alpha_1_k(2,2)  ! the coeff in health transition where current health is 2 and tomorrow is 2
 counter=counter+1
param_est(counter)=alpha_2_k(2,1)  ! the coeff in health transition: medical care dummy
 counter=counter+1
param_est(counter)=alpha_3_k(2,1)  ! the coeff in health transition: idiosyncratic shock
 counter=counter+1
param_est(counter)=alpha_4_k(2,1)  ! the coeff in health transition: age
 counter=counter+1
param_est(counter)=alpha_5_k(2,2)  ! the coeff in health transition to next period unhealthy: type=1
 counter=counter+1
param_est(counter)=alpha_6_k(2,1)    !interaction between exp and shock 
 counter=counter+1
param_est(counter)=alpha_2_k(2,2)  ! the coeff in health transition: medical care dummy
 counter=counter+1
param_est(counter)=alpha_3_k(2,2)  ! the coeff in health transition: idiosyncratic shock
 counter=counter+1
param_est(counter)=alpha_4_k(2,2)  ! the coeff in health transition: age
 counter=counter+1
param_est(counter)=alpha_6_k(2,2)    !interaction between exp and shock 
 counter=counter+1
param_est(counter)=term_health(2)   !terminal value for unhealthy
counter=counter+1
param_est(counter)=loading_ehi   ! loading factor for EHI
counter=counter+1
param_est(counter)=worker_size1 !worker size
counter=counter+1
param_est(counter)=scale_prof  !scale parameter for choice specific shocks.
counter=counter+1
param_est(counter)=eta_u  !, 	-disutility from labor
counter=counter+1
param_est(counter)=pref_scale  !, 	-disutility from labor
counter=counter+1
param_est(counter)=alpha_w_6(2) ! 	productivity effect of bad health
counter=counter+1
param_est(counter)=beta_m(2)
counter=counter+1
param_est(counter)=gamma_m(2)
counter=counter+1
param_est(counter)=kappa(2)
counter=counter+1
param_est(counter)=sigma_m(2)	 !-std. dev for medical needs shock
counter=counter+1
param_est(counter)=sigma_wage_error
counter=counter+1
param_est(counter)=lambda_e(2,1)
counter=counter+1
param_est(counter)=lambda_e(2,2)
counter=counter+1
param_est(counter)=lambda_u(2,1)
counter=counter+1
param_est(counter)=lambda_u(2,2)
counter=counter+1
param_est(counter)=cons_floor
counter=counter+1
param_est(counter)=pref_ii




END SUBROUTINE