SUBROUTINE prof_hi_s(n, z_a_vec, profit_hi)

USE mod_dp
USE params


implicit none

INTEGER, INTENT(IN)    :: n
REAL(DP), INTENT(IN):: z_a_vec(:)
REAL(DP), INTENT(OUT):: profit_hi

REAL(DP)::  z_a, emp1, emp2, premium, weight 
INTEGER:: x1, x2, x3
INTEGER ind_type, ed_type, health_type, ins_status, work_exp, period

z_a=z_a_vec(n)
    x1=1
    x3=num_firm_sim    
 !       IF (wage>=wage_grid(1)) THEN
    do while (x3-x1>1)
        x2=(x1+x3)/2
        if( z_sim(x2) > z_a ) then
            x3=x2
        else
            x1=x2
        endif
    enddo

weight=(z_sim(x1+1)-z_a)/(z_sim(x1+1)-z_sim(x1))

premium=0.0d0
emp1=0.0d0  

emp1=weight*emp_dist_sim_1(x1, 2,ed_solve,skill_solve)+(1.0d0-weight)*emp_dist_sim_1(x1+1, 2,ed_solve,skill_solve)
emp2=weight*emp_dist_sim_2(x1, 2,ed_solve,skill_solve)+(1.0d0-weight)*emp_dist_sim_2(x1+1, 2,ed_solve,skill_solve)

premium=weight*med_dist_sim_1(x1,ed_solve,skill_solve)+(1.0d0-weight)*med_dist_sim_1(x1+1,ed_solve,skill_solve)

  

premium=premium

!profit_hi=emp1*(firm_prod(firm_index_fix)-z_a)-premium 
profit_hi=emp1*firm_prod(firm_index_fix)-(1.0d0+tax_f)*emp2*z_a-premium 



profit_hi=-(profit_hi*worker_size1)





END SUBROUTINE



