subroutine variance_covariance_mat

use params
use mod_dp
    
implicit none

LOGICAL ISNAN

integer:: i,j,k,n,m,t, tt, count, age_index,x, y,z, age_low, age_high !index

ind_moments=0.0d0
ind_moments1=0.0d0
ind_moments3=0.0d0
firm_moment_value=0.0d0

ind_a_moments=0.0d0
ind_a_moments1=0.0d0
ind_a_moments3=0.0d0

residual_mat=0.0d0

DO j=1, num_data_period_1 !all data periods
DO i=1, sample_size    
    
age_index=floor((j-1)/3.0)+1 
age_index=age_data(i,age_index)

! education
    
    
DO n=1, 2
DO t=1, 5

IF (ed(i,1)==n .or. ed(i,2)==n .or. ed(i,3)==n .or. ed(i,4)==n) THEN

IF (age_index>=25+7*(t-1) .and. age_index<25+7*t) THEN     



IF (emp_data(i,j)==1 .and. wage_data(i,j)>=0.0d0 ) THEN
ind_moments(i,j,1,t,n)=(ump_rate_c(t,n)-0.0d0)
ELSE IF (emp_data(i,j)==0 ) THEN
ind_moments(i,j,1,t,n)=(ump_rate_c(t,n)-1.0d0)
END IF

IF (ue_data(i,j)==1 .and. hi_data(i,j+1)==1 .and. wage_data(i,j+1)>=0.0d0) THEN
ind_moments(i,j,2,t,n)=(ue_hi_c(t,n)-1.0d0)
ind_moments(i,j,28,t,n)=(wage_ue_hi_c(t,n)-wage_data(i,j+1))
ind_moments(i,j,3,t,n)=(ue_nhi_c(t,n)-0.0d0)
ind_moments(i,j,30,t,n)=(std_wage_ue_hi_c(t,n)-wage_data(i,j+1))**2.0d0
ELSE IF (ue_data(i,j)==1 .and. hi_data(i,j+1).ne. 1 .and. wage_data(i,j+1)>=0.0d0) THEN
ind_moments(i,j,3,t,n)=(ue_nhi_c(t,n)-1.0d0)
ind_moments(i,j,2,t,n)=(ue_hi_c(t,n)-1.0d0)
ind_moments(i,j,29,t,n)=(wage_ue_nhi_c(t,n)-wage_data(i,j+1) )
ind_moments(i,j,31,t,n)=(std_wage_ue_nhi_c(t,n)-wage_data(i,j+1))**2.0d0
END IF


    IF (hi_data(i,j)==1 .and. emp_data(i,j)==1 .and. wage_data(i,j)>=0.0d0 ) THEN
        ind_moments(i,j,32,t,n)=(eshi_rate_c(t,n)-1.0d0)
        ind_moments(i,j,5,t,n)=(wage_average_hi_c(t,n)-wage_data(i,j))    
        ind_moments(i,j,33,t,n)=(ii_rate_c(t,n)-0.0d0)
        ind_moments(i,j,8,t,n)= (std_wage_average_hi_c(t,n)-wage_data(i,j))**2.0d0
    END IF    
    IF (emp_data(i,j)==1 .and. wage_data(i,j)>=0.0d0 .and. hi_data(i,j)==0  ) THEN
        ind_moments(i,j,32,t,n)=(eshi_rate_c(t,n)-0.0d0)
        ind_moments(i,j,6,t,n)=(wage_average_nhi_c(t,n)-wage_data(i,j))
        ind_moments(i,j,33,t,n)=(ii_rate_c(t,n)-0.0d0)
        ind_moments(i,j,9,t,n)= (std_wage_average_nhi_c(t,n)-wage_data(i,j))**2.0d0
        END IF    
    IF (emp_data(i,j)==1 .and. wage_data(i,j)>=0.0d0 .and. hi_data(i,j)==2  ) THEN
        ind_moments(i,j,32,t,n)=(eshi_rate_c(t,n)-0.0d0)
        ind_moments(i,j,7,t,n)=(wage_average_ii_c(t,n)-wage_data(i,j))    
        ind_moments(i,j,33,t,n)=(ii_rate_c(t,n)-1.0d0)
        ind_moments(i,j,10,t,n)= (std_wage_average_ii_c(t,n)-wage_data(i,j))**2.0d0
    END IF   



    IF (eu_data(i,j)==1) THEN
        ind_moments(i,j,4,t,n)=(eu_c(t,n)-1.0d0)
    ELSE IF  (eu_data(i,j) .ne. 0 .and. emp_data(i,j)==1) THEN  
         ind_moments(i,j,4,t,n)=(eu_c(t,n)-0.0d0)
    END IF
    
    
    
    
    IF (jj_data(i,j)==1) THEN
    ind_moments(i,j,11,t,n)=(jj_rate_c(t,n)-1.0d0)
    ELSE IF (jj_data(i,j).ne. 1 .and. emp_data(i,j)==1) THEN
    ind_moments(i,j,11,t,n)=(jj_rate_c(t,n)-0.0d0)
    END IF  
    










    
    
    IF (jj_data(i,j)==1 .and. hi_data(i,j)==1 .and. hi_data(i,j+1)==1 .and. wage_data(i,j)>=0.0d0 .and. wage_data(i,j+1)>=0.0d0) THEN
        ind_moments(i,j,16,t,n)=(wage_jj_hihi_c(t,n)-(wage_data(i,j+1)-wage_data(i,j)))
        ind_moments(i,j,12,t,n)=(jj_hihi_c(t,n)-1.0d0)
        ind_moments(i,j,20,t,n)=(std_wage_jj_hihi_c(t,n)-(wage_data(i,j+1)-wage_data(i,j)))**2.0d0
    END IF
    IF (jj_data(i,j)==1 .and. (hi_data(i,j)==0 .or. hi_data(i,j)==2) .and. (hi_data(i,j+1)==0 .or. hi_data(i,j+1)==2) .and. wage_data(i,j)>=0.0d0  .and. wage_data(i,j+1)>=0.0d0) THEN
        ind_moments(i,j,19,t,n)=(wage_jj_nhinhi_c(t,n)-(wage_data(i,j+1)-wage_data(i,j)))
        ind_moments(i,j,23,t,n)=(std_wage_jj_nhinhi_c(t,n)-(wage_data(i,j+1)-wage_data(i,j)))**2.0d0
        ind_moments(i,j,15,t,n)=(jj_nhinhi_c(t,n)-1.0d0)
    END IF   
    IF (jj_data(i,j)==1 .and. hi_data(i,j)==1 .and. (hi_data(i,j+1)==0 .or. hi_data(i,j+1)==2) .and. wage_data(i,j)>=0.0d0 .and. wage_data(i,j+1)>=0.0d0) THEN
        ind_moments(i,j,17,t,n)=(wage_jj_hinhi_c(t,n)-(wage_data(i,j+1)-wage_data(i,j)))
        ind_moments(i,j,13,t,n)=(jj_hinhi_c(t,n)-1.0d0)
        ind_moments(i,j,21,t,n)=(std_wage_jj_hinhi_c(t,n)-(wage_data(i,j+1)-wage_data(i,j)))**2.0d0
    END IF
    IF (jj_data(i,j)==1 .and. (hi_data(i,j)==0 .or. hi_data(i,j)==2) .and. hi_data(i,j+1)==1 .and. wage_data(i,j)>=0.0d0 .and. wage_data(i,j+1)>=0.0d0) THEN

        ind_moments(i,j,18,t,n)=(wage_jj_nhihi_c(t,n)-(wage_data(i,j+1)-wage_data(i,j)))
        ind_moments(i,j,22,t,n)=(std_wage_jj_nhihi_c(t,n)-(wage_data(i,j+1)-wage_data(i,j)))**2.0d0
        ind_moments(i,j,14,t,n)=(jj_nhihi_c(t,n)-jj_nhihi_sample(t,n))
    END IF
    IF (emp_data(i,j)==1 .and. emp_data(i,j+1)==1 .and. jj_data(i,j)==0 .and. hi_data(i,j)==1) THEN
        ind_moments(i,j,24,t,n)=(wage_stay_hi_c(t,n)-(wage_data(i,j+1)-wage_data(i,j)))
        ind_moments(i,j,26,t,n)=(std_wage_stay_hi_c(t,n)-(wage_data(i,j+1)-wage_data(i,j)))**2.0d0
    END IF  
    IF (emp_data(i,j)==1 .and. emp_data(i,j+1)==1 .and. jj_data(i,j)==0 .and. (hi_data(i,j)==0 .or. hi_data(i,j)==2) ) THEN
        ind_moments(i,j,25,t,n)=(wage_stay_nhi_c(t,n)-(wage_data(i,j+1)-wage_data(i,j)))  
        ind_moments(i,j,27,t,n)=(std_wage_stay_nhi_c(t,n)-(wage_data(i,j+1)-wage_data(i,j)))**2.0d0
    END IF   

END IF
END IF
    
END DO    
END DO    
   
END DO
END DO



DO j=1, 2
DO i=1, sample_size

DO n=1, 2
DO t=1, 5


! education
IF (ed(i,1)==n .or. ed(i,2)==n .or. ed(i,3)==n .or. ed(i,4)==n) THEN


age_index=age_data(i,j)

IF (age_index>=25+7*(t-1) .and. age_index<25+7*t) THEN 

    IF (health_data(i,j)==1 ) THEN
        ind_moments(i,j,34,t,n)=(health_c(t,n)-1.0d0)
    ELSE IF (health_data(i,j)==0 ) THEN    
        ind_moments(i,j,34,t,n)=(health_c(t,n)-0.0d0)
    END IF

END IF    

END IF !education


    
END DO !i
END DO !j

END DO !t   
END DO  !n




DO j=1, 1
DO i=1, sample_size


DO n=1, 2
DO t=1, 5

! education
IF (ed(i,1)==n .or. ed(i,2)==n .or. ed(i,3)==n .or. ed(i,4)==n) THEN


age_index=age_data(i,j)

IF (age_index>=25+7*(m-1) .and. age_index<25+7*m) THEN 

    IF (health_data(i,j)==1 .and. health_data(i,j+1)==1) THEN
    ind_moments(i,j,35,t,n)=(health_transit_hh_c(t,n)-1.0d0)
    END IF
    IF (health_data(i,j)==2 .and. health_data(i,j+1)==2) THEN
    ind_moments(i,j,36,t,n)=(health_transit_uu_c(t,n)-1.0d0)    
    END IF
    IF (health_data(i,j)==1 .and.  health_data(i,j+1)==2 ) THEN
    ind_moments(i,j,35,t,n)=(health_transit_hh_c(t,n)-0.0d0)
    END IF
    IF (health_data(i,j)==2 .and.  health_data(i,j+1)==2 ) THEN
    ind_moments(i,j,36,t,n)=(health_transit_uu_c(t,n)-0.0d0)
    END IF
    
END IF    
    
END IF !education

END DO !t   
END DO  !n


END DO !i  
END DO !j













DO j=1, 2
DO i=1, sample_size
!health fraction

DO n=1, 2

IF (ed(i,j)==n) THEN

    
    IF (health_data(i,j)==1 .and. (hi_data(i,j*3+1)==1 .or. hi_data(i,j*3+1)==2) .and. emp_data(i,j*3+1)==1) THEN
    ind_moments1(i,j,1, n)=(health_hi_sim(n)-1.0d0)
    ELSE IF (health_data(i,j)==2 .and. (hi_data(i,j*3+1)==1 .or. hi_data(i,j*3+1)==2) .and. emp_data(i,j*3+1)==1) THEN
    ind_moments1(i,j,1, n)=(health_hi_sim(n)-0.0d0)
    END IF
    
    IF (health_data(i,j)==1 .and. hi_data(i,j*3+1)==0 .and. emp_data(i,j*3+1)==1) THEN
    ind_moments1(i,j,2, n)=(health_nhi_sim(n)-1.0d0)
    ELSE IF (health_data(i,j)==2 .and. hi_data(i,j*3+1)==0 .and. emp_data(i,j*3+1)==1) THEN
    ind_moments1(i,j,2, n)=(health_nhi_sim(n)-0.0d0)
    END IF
    
    IF (health_data(i,j)==1 .and. emp_data(i,j*3+1)==0) THEN
    ind_moments1(i,j,3, n)=(health_unemp_sim(n)-1.0d0)
    ELSE IF (health_data(i,j)==1 .and. emp_data(i,j*3+1)==0) THEN
    ind_moments1(i,j,3, n)=(health_unemp_sim(n)-0.0d0)
    END IF
    


END IF

END DO !n

END DO
END DO








DO t=1, 3

DO n=1, num_ed

IF (t==1) THEN
age_low=25
age_high=40
ELSE IF (t==2) THEN
age_low=40
age_high=50
ELSE
age_low=50
age_high=60
END IF

!medical expenditure
DO i=1, sample_size_meps

age_index=age_data_meps(i)

IF (age_index>=age_low .and. age_index<age_high ) THEN 

IF (health_1_data_meps(i)==1 .and. ins_1_data_meps(i)==2) THEN
ind_moments3(i,2,t)= (sim_med_exp_sample_h_hi_1(t,2,1)-med_exp_sample(i))
ind_moments3(i,10,t)= (sim_std_med_exp_sample_h_hi_1(t,2,1)--med_exp_sample(i))**2.0d0

    IF  (med_exp_sample(i)>0.0d0) THEN 
    ind_moments3(i,6,t)= (sim_positive_sample_h_hi_1(t,2,1)-1.0d0)
    ELSE IF (med_exp_sample(i)==0.0d0) THEN
    ind_moments3(i,6,t)= (sim_positive_sample_h_hi_1(t,2,1)-0.0d0)
    END IF

ELSE IF (health_1_data_meps(i)==1 .and. ins_1_data_meps(i)==1) THEN
ind_moments3(i,1,t)= (sim_med_exp_sample_h_hi_1(t,1,1)-med_exp_sample(i))
ind_moments3(i,9,t)= (sim_std_med_exp_sample_h_hi_1(t,1,1)-med_exp_sample(i))**2.0d0

    IF  (med_exp_sample(i)>0.0d0) THEN 
    ind_moments3(i,5,t)= (sim_positive_sample_h_hi_1(t,1,1)-1.0d0)
    ELSE IF (med_exp_sample(i)==0.0d0) THEN
    ind_moments3(i,5,t)= (sim_positive_sample_h_hi_1(t,1,1)-0.0d0)
    END IF
ELSE IF (health_1_data_meps(i)==2 .and. ins_1_data_meps(i)==1) THEN
ind_moments3(i,3,t)= (sim_med_exp_sample_h_hi_1(t,1,2)-med_exp_sample(i))
ind_moments3(i,11,t)= (sim_std_med_exp_sample_h_hi_1(t,1,2)-med_exp_sample(i))**2.0d0

    IF  (med_exp_sample(i)>0.0d0) THEN 
    ind_moments3(i,7,t)= (sim_positive_sample_h_hi_1(t,1,2)-1.0d0)
    ELSE IF (med_exp_sample(i)==0.0d0) THEN
    ind_moments3(i,7,t)= (sim_positive_sample_h_hi_1(t,1,2)-0.0d0)    
    END IF



ELSE IF (health_1_data_meps(i)==2 .and. ins_1_data_meps(i)==2) THEN
ind_moments3(i,4,t)= (sim_med_exp_sample_h_hi_1(t,2,2)-med_exp_sample(i))
ind_moments3(i,12,t)= (sim_std_med_exp_sample_h_hi_1(t,2,2)-med_exp_sample(i))**2.0d0


    IF  (med_exp_sample(i)>0.0d0) THEN 
    ind_moments3(i,8,t)= (sim_positive_sample_h_hi_1(t,2,2)-1.0d0)
    ELSE IF (med_exp_sample(i)==0.0d0) THEN
    ind_moments3(i,8,t)= (sim_positive_sample_h_hi_1(t,2,2)-0.0d0)
    END IF


END IF

END IF 

END DO !i

END DO !n

END DO !t









!firm_side_moments


DO i=1, sample_size_firm
firm_moment_value(i,1)=m_mean_size-firm_size_sample(i)
IF (firm_size_sample(i)<5.0d0) THEN
firm_moment_value(i,2)=size_frac_50-1.0d0

IF (ESHI_offer_sample(i)==1) THEN
firm_moment_value(i,5)=m_hioffer_s-1.0d0
ELSE IF (ESHI_offer_sample(i)==0) THEN
firm_moment_value(i,5)=m_hioffer_s-0.0d0
END IF



ELSE
firm_moment_value(i,2)=size_frac_50-0.0d0

IF (ESHI_offer_sample(i)==1) THEN
firm_moment_value(i,6)=m_hioffer_l-1.0d0
ELSE IF (ESHI_offer_sample(i)==0) THEN
firm_moment_value(i,6)=m_hioffer_l-0.0d0
END IF



END IF

IF (ESHI_offer_sample(i)==1) THEN
firm_moment_value(i,7)=mean_offer_rate-1.0d0
firm_moment_value(i,3)=m_size_hi-firm_size_sample(i)
!firm_moment_value(i,8)=emp_age_hi-sample_emp_age(i)
ELSE IF (ESHI_offer_sample(i)==0) THEN
firm_moment_value(i,7)=mean_offer_rate-0.0d0
firm_moment_value(i,4)=m_size_nhi-firm_size_sample(i)
!firm_moment_value(i,9)=emp_age_nhi-sample_emp_age(i)
END IF


END DO !i



!DO i=1, sample_size
!DO n=1, num_mom_w
!IF (ISNAN(residual_worker(i, n))) THEN
!residual_worker(i, n)=0.0d0
!END IF
!END DO
!END DO
!
!DO i=1, sample_size_firm
!DO n=1+num_mom_w, num_mom
!IF (ISNAN(residual_firm(i, n-num_mom_w))) THEN
!residual_firm(i, n-num_mom_w)=0.0d0
!END IF
!END DO
!END DO



!!!!!!!!!!!!! create residual matrix !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!




n=0

DO j=1, num_moment1
DO k=1, 5
DO m=1, 2
n=n+1

DO x=1, num_data_period_1 !all data periods
DO i=1, sample_size


ind_a_moments(i,x,n)=ind_moments(i,x,j,k,m)

END DO
END DO


END DO
END DO
END DO

n=0

DO j=1, num_moment2
DO m=1, 2
n=n+1

DO x=1, num_data_period_1 !all data periods
DO i=1, sample_size


ind_a_moments1(i,x,n)=ind_moments1(i,x,j, m)


END DO
END DO


END DO
END DO


n=0

DO j=1, num_moment4
DO m=1, 3

n=n+1


DO i=1, sample_size_meps

ind_a_moments3(i,n)=ind_moments3(i,j,m)

END DO

END DO
END DO







!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!! Creat cross moments !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!




DO n=1, num_moment1*5*2
DO m=1, num_moment1*5*2


DO x=1, num_data_period_1 !all data periods
DO i=1, sample_size
residual_mat(n,m)=residual_mat(n,m)+ind_a_moments(i,x,n)*ind_a_moments(i,x,m)
END DO
END DO


residual_mat(n,m)=residual_mat(n,m)/(num_data_period_1*sample_size)


END DO
END DO








DO n=num_moment1*5*2+1, num_moment1*5*2+num_moment2*2
DO m=num_moment1*5*2+1, num_moment1*5*2+num_moment2*2


DO x=1, num_data_period_1 !all data periods
DO i=1, sample_size
residual_mat(n,m)=residual_mat(n,m)+ind_a_moments1(i,x,n-num_moment1*5*2)*ind_a_moments1(i,x,m-num_moment1*5*2)
END DO
END DO
residual_mat(n,m)=residual_mat(n,m)/(num_data_period_1*sample_size)


END DO
END DO









DO n=num_moment1*5*2+num_moment2*2+1, num_moment1*5*2+num_moment2*2+num_moment4*3
DO m=num_moment1*5*2+num_moment2*2+1, num_moment1*5*2+num_moment2*2+num_moment4*3

DO i=1, sample_size_meps
residual_mat(n,m)=residual_mat(n,m)+ind_a_moments3(i,n-(num_moment1*5*2+num_moment2*2))*ind_a_moments3(i,m-(num_moment1*5*2+num_moment2*2))
END DO
residual_mat(n,m)=residual_mat(n,m)/sample_size_meps

END DO
END DO









DO n=num_moment1*5*2+num_moment2*2+num_moment4*3+1, num_moment1*5*2+num_moment2*2+num_moment4*3+num_moment3
DO m=num_moment1*5*2+num_moment2*2+num_moment4*3+1, num_moment1*5*2+num_moment2*2+num_moment4*3+num_moment3

DO i=1, sample_size_firm
residual_mat(n,m)=residual_mat(n,m)+firm_moment_value(i,n-(num_moment1*5*2+num_moment2*2+num_moment4*3))*firm_moment_value(i,m-(num_moment1*5*2+num_moment2*2+num_moment4*3))*weight_firm_sample(i)
END DO
residual_mat(n,m)=residual_mat(n,m)/sum(weight_firm_sample)
END DO
END DO



END subroutine
