clear
set mem 4g


use "\\tsclient\Y\SIPP\2004\adjusted_data_file\tabulation_data_jmp.dta", clear


*Aggregate health into 2 categories

gen health_status_ag1=-99
gen health_status_ag13=-99


replace health_status_ag1=1 if health_status1==1 | health_status1==2 | health_status1==3
replace health_status_ag1=2 if health_status1==4 | health_status1==5  

replace health_status_ag13=1 if health_status13==1 | health_status13==2 | health_status13==3
replace health_status_ag13=2 if health_status13==4 | health_status13==5  


gen emp1=-99
gen emp2=-99
gen emp3=-99
gen emp4=-99
gen emp5=-99
gen emp6=-99
gen emp7=-99
gen emp8=-99
gen emp9=-99
gen emp10=-99
gen emp11=-99
gen emp12=-99


replace emp1=0 if (emp_status1>5 & emp_status1<=8) 
replace emp2=0 if (emp_status5>5 & emp_status5<=8) 
replace emp3=0 if (emp_status9>5 & emp_status9<=8) 
replace emp4=0 if (emp_status13>5 & emp_status13<=8) 
replace emp5=0 if (emp_status17>5 & emp_status17<=8) 
replace emp6=0 if (emp_status21>5 & emp_status21<=8) 
replace emp7=0 if (emp_status25>5 & emp_status25<=8) 
replace emp8=0 if (emp_status29>5 & emp_status29<=8) 
replace emp9=0 if (emp_status33>5 & emp_status33<=8) 
replace emp10=0 if (emp_status37>5 & emp_status37<=8) 
replace emp11=0 if (emp_status41>5 & emp_status41<=8) 
replace emp12=0 if (emp_status45>5 & emp_status45<=8) 

replace emp1=1 if (emp_status1>=1 & emp_status1<=5)
replace emp2=1 if (emp_status5>=1 & emp_status5<=5) 
replace emp3=1 if (emp_status9>=1 & emp_status9<=5) 
replace emp4=1 if (emp_status13>=1 & emp_status13<=5) 
replace emp5=1 if (emp_status17>=1 & emp_status17<=5) 
replace emp6=1 if (emp_status21>=1 & emp_status21<=5) 
replace emp7=1 if (emp_status25>=1 & emp_status25<=5) 
replace emp8=1 if (emp_status29>=1 & emp_status29<=5) 
replace emp9=1 if (emp_status33>=1 & emp_status33<=5) 
replace emp10=1 if (emp_status37>=1 & emp_status37<=5) 
replace emp11=1 if (emp_status41>=1 & emp_status41<=5) 
replace emp12=1 if (emp_status45>=1 & emp_status45<=5) 




* 1. gen ue transition
gen ue1=-99
gen ue2=-99
gen ue3=-99
gen ue4=-99
gen ue5=-99
gen ue6=-99
gen ue7=-99
gen ue8=-99
gen ue9=-99
gen ue10=-99
gen ue11=-99
replace ue1=1 if emp1==0 & emp2==1
replace ue2=1 if emp2==0 & emp3==1
replace ue3=1 if emp3==0 & emp4==1
replace ue4=1 if emp4==0 & emp5==1
replace ue5=1 if emp5==0 & emp6==1
replace ue6=1 if emp6==0 & emp7==1
replace ue7=1 if emp7==0 & emp8==1
replace ue8=1 if emp8==0 & emp9==1
replace ue9=1 if emp9==0 & emp10==1
replace ue10=1 if emp10==0 & emp11==1
replace ue11=1 if emp11==0 & emp12==1
replace ue1=0 if emp1==0 & emp2==0
replace ue2=0 if emp2==0 & emp3==0
replace ue3=0 if emp3==0 & emp4==0
replace ue4=0 if emp4==0 & emp5==0
replace ue5=0 if emp5==0 & emp6==0
replace ue6=0 if emp6==0 & emp7==0
replace ue7=0 if emp7==0 & emp8==0
replace ue8=0 if emp8==0 & emp9==0
replace ue9=0 if emp9==0 & emp10==0
replace ue10=0 if emp10==0 & emp11==0
replace ue11=0 if emp11==0 & emp12==0


* 2. gen eu transition
gen eu1=-99
gen eu2=-99
gen eu3=-99
gen eu4=-99
gen eu5=-99
gen eu6=-99
gen eu7=-99
gen eu8=-99
gen eu9=-99
gen eu10=-99
gen eu11=-99
replace eu1=1 if emp1==1 & emp2==0
replace eu2=1 if emp2==1 & emp3==0
replace eu3=1 if emp3==1 & emp4==0
replace eu4=1 if emp4==1 & emp5==0
replace eu5=1 if emp5==1 & emp6==0
replace eu6=1 if emp6==1 & emp7==0
replace eu7=1 if emp7==1 & emp8==0
replace eu8=1 if emp8==1 & emp9==0
replace eu9=1 if emp9==1 & emp10==0
replace eu10=1 if emp10==1 & emp11==0
replace eu11=1 if emp11==1 & emp12==0

replace eu1=0 if emp1==1 & emp2==1
replace eu2=0 if emp2==1 & emp3==1
replace eu3=0 if emp3==1 & emp4==1
replace eu4=0 if emp4==1 & emp5==1
replace eu5=0 if emp5==1 & emp6==1
replace eu6=0 if emp6==1 & emp7==1
replace eu7=0 if emp7==1 & emp8==1
replace eu8=0 if emp8==1 & emp9==1
replace eu9=0 if emp9==1 & emp10==1
replace eu10=0 if emp10==1 & emp11==1
replace eu11=0 if emp11==1 & emp12==1



 * 3. gen ee transition
 gen jj1=-99
gen jj2=-99
gen jj3=-99
gen jj4=-99
gen jj5=-99
gen jj6=-99
gen jj7=-99
gen jj8=-99
gen jj9=-99
gen jj10=-99
gen jj11=-99
replace jj1=0 if eu1==0 & (job_id1==job_id5)
replace jj2=0 if eu2==0 & (job_id5==job_id9)
replace jj3=0 if eu3==0 & (job_id9==job_id13)
replace jj4=0 if eu4==0 & (job_id13==job_id17)
replace jj5=0 if eu5==0 & (job_id17==job_id21)
replace jj6=0 if eu6==0 & (job_id21==job_id25)
replace jj7=0 if eu7==0 & (job_id25==job_id29)
replace jj8=0 if eu8==0 & (job_id29==job_id33)
replace jj9=0 if eu9==0 & (job_id33==job_id37)
replace jj10=0 if eu10==0 & (job_id37==job_id41)
replace jj11=0 if eu11==0 & (job_id41==job_id45)

replace jj1=1 if eu1==0 & (job_id1!=job_id5)
replace jj2=1 if eu2==0 & (job_id5!=job_id9)
replace jj3=1 if eu3==0 & (job_id9!=job_id13)
replace jj4=1 if eu4==0 & (job_id13!=job_id17)
replace jj5=1 if eu5==0 & (job_id17!=job_id21)
replace jj6=1 if eu6==0 & (job_id21!=job_id25)
replace jj7=1 if eu7==0 & (job_id25!=job_id29)
replace jj8=1 if eu8==0 & (job_id29!=job_id33)
replace jj9=1 if eu9==0 & (job_id33!=job_id37)
replace jj10=1 if eu10==0 & (job_id37!=job_id41)
replace jj11=1 if eu11==0 & (job_id41!=job_id45)

* coverage rate for employed
gen hi_1=-99
gen hi_5=-99
gen hi_9=-99
gen hi_13=-99
gen hi_17=-99
gen hi_21=-99
gen hi_25=-99
gen hi_29=-99
gen hi_33=-99
gen hi_37=-99
gen hi_41=-99
gen hi_45=-99

replace hi_1=0 if hi_status1==0 & emp1==1
replace hi_1=1 if hi_status1==1 & emp1==1
replace hi_1=2 if hi_status1==2 & emp1==1
replace hi_5=0 if hi_status5==0 & emp2==1
replace hi_5=1 if hi_status5==1 & emp2==1
replace hi_5=2 if hi_status5==2 & emp2==1
replace hi_9=0 if hi_status9==0 & emp3==1
replace hi_9=1 if hi_status9==1 & emp3==1
replace hi_9=2 if hi_status9==2 & emp3==1
replace hi_13=0 if hi_status13==0 & emp4==1
replace hi_13=1 if hi_status13==1 & emp4==1
replace hi_13=2 if hi_status13==2 & emp4==1
replace hi_17=0 if hi_status17==0 & emp5==1
replace hi_17=1 if hi_status17==1 & emp5==1
replace hi_17=2 if hi_status17==2 & emp5==1
replace hi_21=0 if hi_status21==0 & emp6==1
replace hi_21=1 if hi_status21==1 & emp6==1
replace hi_21=2 if hi_status21==2 & emp6==1
replace hi_25=0 if hi_status25==0 & emp7==1
replace hi_25=1 if hi_status25==1 & emp7==1
replace hi_25=2 if hi_status25==2 & emp7==1
replace hi_29=0 if hi_status29==0 & emp8==1
replace hi_29=1 if hi_status29==1 & emp8==1
replace hi_29=2 if hi_status29==2 & emp8==1
replace hi_33=0 if hi_status33==0 & emp9==1
replace hi_33=1 if hi_status33==1 & emp9==1
replace hi_33=2 if hi_status33==2 & emp9==1
replace hi_37=0 if hi_status37==0 & emp10==1
replace hi_37=1 if hi_status37==1 & emp10==1
replace hi_37=2 if hi_status37==2 & emp10==1
replace hi_41=0 if hi_status41==0 & emp11==1
replace hi_41=1 if hi_status41==1 & emp11==1
replace hi_41=2 if hi_status41==2 & emp11==1
replace hi_45=0 if hi_status45==0 & emp12==1
replace hi_45=1 if hi_status45==1 & emp12==1
replace hi_45=2 if hi_status45==2 & emp12==1

gen hi_1_u=-99
gen hi_5_u=-99
gen hi_9_u=-99
gen hi_13_u=-99
gen hi_17_u=-99
gen hi_21_u=-99
gen hi_25_u=-99
gen hi_29_u=-99
gen hi_33_u=-99
gen hi_37_u=-99
gen hi_41_u=-99
gen hi_45_u=-99

replace hi_1_u=0 if hi_status1==0 & emp1==0
replace hi_1_u=1 if hi_status1==1 & emp1==0
replace hi_1_u=2 if hi_status1==2 & emp1==0
replace hi_5_u=0 if hi_status5==0 & emp2==0
replace hi_5_u=1 if hi_status5==1 & emp2==0
replace hi_5_u=2 if hi_status5==2 & emp2==0
replace hi_9_u=0 if hi_status9==0 & emp3==0
replace hi_9_u=1 if hi_status9==1 & emp3==0
replace hi_9_u=2 if hi_status9==2 & emp3==0
replace hi_13_u=0 if hi_status13==0 & emp4==0
replace hi_13_u=1 if hi_status13==1 & emp4==0
replace hi_13_u=2 if hi_status13==2 & emp4==0
replace hi_17_u=0 if hi_status17==0 & emp5==0
replace hi_17_u=1 if hi_status17==1 & emp5==0
replace hi_17_u=2 if hi_status17==2 & emp5==0
replace hi_21_u=0 if hi_status21==0 & emp6==0
replace hi_21_u=1 if hi_status21==1 & emp6==0
replace hi_21_u=2 if hi_status21==2 & emp6==0
replace hi_25_u=0 if hi_status25==0 & emp7==0
replace hi_25_u=1 if hi_status25==1 & emp7==0
replace hi_25_u=2 if hi_status25==2 & emp7==0
replace hi_29_u=0 if hi_status29==0 & emp8==0
replace hi_29_u=1 if hi_status29==1 & emp8==0
replace hi_29_u=2 if hi_status29==2 & emp8==0
replace hi_33_u=0 if hi_status33==0 & emp9==0
replace hi_33_u=1 if hi_status33==1 & emp9==0
replace hi_33_u=2 if hi_status33==2 & emp9==0
replace hi_37_u=0 if hi_status37==0 & emp10==0
replace hi_37_u=1 if hi_status37==1 & emp10==0
replace hi_37_u=2 if hi_status37==2 & emp10==0
replace hi_41_u=0 if hi_status41==0 & emp11==0
replace hi_41_u=1 if hi_status41==1 & emp11==0
replace hi_41_u=2 if hi_status41==2 & emp11==0
replace hi_45_u=0 if hi_status45==0 & emp12==0
replace hi_45_u=1 if hi_status45==1 & emp12==0
replace hi_45_u=2 if hi_status45==2 & emp12==0

rename hi_1 hi1
rename hi_5 hi2
rename hi_9 hi3
rename hi_13 hi4
rename hi_17 hi5
rename hi_21 hi6
rename hi_25 hi7
rename hi_29 hi8
rename hi_33 hi9
rename hi_37 hi10
rename hi_41 hi11
rename hi_45 hi12

rename hi_1_u hi1_u
rename hi_5_u hi2_u
rename hi_9_u hi3_u
rename hi_13_u hi4_u
rename hi_17_u hi5_u
rename hi_21_u hi6_u
rename hi_25_u hi7_u
rename hi_29_u hi8_u
rename hi_33_u hi9_u
rename hi_37_u hi10_u
rename hi_41_u hi11_u
rename hi_45_u hi12_u



* replace wage lavel
* multiply wage by 4
* normalized at 2004 value using GDP implicit price deflator
*need to be price deflated
replace wage_month1=wage_month1*4/(0.911101*10000)
replace wage_month5=wage_month5*4/(0.911101*10000)
replace wage_month9=wage_month9*4/(0.911101*10000)
replace wage_month13=wage_month13*4/(0.941359*10000)
replace wage_month17=wage_month17*4/(0.941359*10000)
replace wage_month21=wage_month21*4/(0.941359*10000)
replace wage_month25=wage_month25*4/(0.971814*10000)
replace wage_month29=wage_month29*4/(0.971814*10000)
replace wage_month33=wage_month33*4/(0.971814*10000)
replace wage_month37=wage_month37*4/(1.0000*10000)
replace wage_month41=wage_month41*4/(1.0000*10000)
replace wage_month45=wage_month45*4/(1.0000*10000)
replace wage_month1=-99 if wage_month1==. | wage_month1==0
replace wage_month5=-99 if wage_month5==. | wage_month5==0
replace wage_month9=-99 if wage_month9==. | wage_month9==0
replace wage_month13=-99 if wage_month13==. | wage_month13==0
replace wage_month17=-99 if wage_month17==. | wage_month17==0
replace wage_month21=-99 if wage_month21==. | wage_month21==0
replace wage_month25=-99 if wage_month25==. | wage_month25==0
replace wage_month29=-99 if wage_month29==. | wage_month29==0
replace wage_month33=-99 if wage_month33==. | wage_month33==0
replace wage_month37=-99 if wage_month37==. | wage_month37==0
replace wage_month41=-99 if wage_month41==. | wage_month41==0
replace wage_month45=-99 if wage_month45==. | wage_month45==0

gen wage_change1=-99
gen wage_change2=-99
gen wage_change3=-99
gen wage_change4=-99
gen wage_change5=-99
gen wage_change6=-99
gen wage_change7=-99
gen wage_change8=-99
gen wage_change9=-99
gen wage_change10=-99
gen wage_change11=-99

replace wage_change1=wage_month5-wage_month1 if wage_month5>0 & wage_month1>0

replace wage_change2=wage_month9-wage_month5 if wage_month9>0 & wage_month5>0

replace wage_change3=wage_month13-wage_month9 if wage_month13>0 & wage_month9>0

replace wage_change4=wage_month17-wage_month13 if wage_month17>0 & wage_month13>0

replace wage_change5=wage_month21-wage_month17 if wage_month21>0 & wage_month17>0

replace wage_change6=wage_month25-wage_month21 if wage_month25>0 & wage_month21>0

replace wage_change7=wage_month29-wage_month25 if wage_month29>0 & wage_month25>0

replace wage_change8=wage_month33-wage_month29 if wage_month33>0 & wage_month29>0

replace wage_change9=wage_month37-wage_month33 if wage_month37>0 & wage_month33>0

replace wage_change10=wage_month41-wage_month37 if wage_month41>0 & wage_month37>0

replace wage_change11=wage_month45-wage_month41 if wage_month45>0 & wage_month41>0

gen wage_change_stay1=-99
gen wage_change_stay2=-99
gen wage_change_stay3=-99
gen wage_change_stay4=-99
gen wage_change_stay5=-99
gen wage_change_stay6=-99
gen wage_change_stay7=-99
gen wage_change_stay8=-99
gen wage_change_stay9=-99
gen wage_change_stay10=-99
gen wage_change_stay11=-99

replace wage_change_stay1=wage_change1 if eu1==0  
replace wage_change_stay2=wage_change2 if eu2==0  
replace wage_change_stay3=wage_change3 if eu3==0  
replace wage_change_stay4=wage_change4 if eu4==0  
replace wage_change_stay5=wage_change5 if eu5==0  
replace wage_change_stay6=wage_change6 if eu6==0  
replace wage_change_stay7=wage_change7 if eu7==0  
replace wage_change_stay8=wage_change8 if eu8==0  
replace wage_change_stay9=wage_change9 if eu9==0  
replace wage_change_stay10=wage_change10 if eu10==0  
replace wage_change_stay11=wage_change11 if eu11==0  

gen wage_change_jj1=-99
gen wage_change_jj2=-99
gen wage_change_jj3=-99
gen wage_change_jj4=-99
gen wage_change_jj5=-99
gen wage_change_jj6=-99
gen wage_change_jj7=-99
gen wage_change_jj8=-99
gen wage_change_jj9=-99
gen wage_change_jj10=-99
gen wage_change_jj11=-99

replace wage_change_jj1=wage_change1 if jj1==1  
replace wage_change_jj2=wage_change2 if jj2==1  
replace wage_change_jj3=wage_change3 if jj3==1  
replace wage_change_jj4=wage_change4 if jj4==1  
replace wage_change_jj5=wage_change5 if jj5==1  
replace wage_change_jj6=wage_change6 if jj6==1  
replace wage_change_jj7=wage_change7 if jj7==1  
replace wage_change_jj8=wage_change8 if jj8==1  
replace wage_change_jj9=wage_change9 if jj9==1  
replace wage_change_jj10=wage_change10 if jj10==1  
replace wage_change_jj11=wage_change11 if jj11==1

gen wage_change_jj_hi1=-99
gen wage_change_jj_hi2=-99
gen wage_change_jj_hi3=-99
gen wage_change_jj_hi4=-99
gen wage_change_jj_hi5=-99
gen wage_change_jj_hi6=-99
gen wage_change_jj_hi7=-99
gen wage_change_jj_hi8=-99
gen wage_change_jj_hi9=-99
gen wage_change_jj_hi10=-99
gen wage_change_jj_hi11=-99

replace wage_change_jj_hi1=wage_change1 if jj1==1  & hi1==1 & hi2==1
replace wage_change_jj_hi2=wage_change2 if jj2==1  & hi2==1 & hi3==1  
replace wage_change_jj_hi3=wage_change3 if jj3==1  & hi3==1 & hi4==1
replace wage_change_jj_hi4=wage_change4 if jj4==1  & hi4==1 & hi5==1  
replace wage_change_jj_hi5=wage_change5 if jj5==1  & hi5==1 & hi6==1  
replace wage_change_jj_hi6=wage_change6 if jj6==1  & hi6==1 & hi7==1  
replace wage_change_jj_hi7=wage_change7 if jj7==1  & hi7==1 & hi8==1  
replace wage_change_jj_hi8=wage_change8 if jj8==1  & hi8==1 & hi9==1  
replace wage_change_jj_hi9=wage_change9 if jj9==1  & hi9==1 & hi10==1  
replace wage_change_jj_hi10=wage_change10 if jj10==1  & hi10==1 & hi11==1  
replace wage_change_jj_hi11=wage_change11 if jj11==1  & hi11==1 & hi12==1

gen wage_change_jj_nhi1=-99
gen wage_change_jj_nhi2=-99
gen wage_change_jj_nhi3=-99
gen wage_change_jj_nhi4=-99
gen wage_change_jj_nhi5=-99
gen wage_change_jj_nhi6=-99
gen wage_change_jj_nhi7=-99
gen wage_change_jj_nhi8=-99
gen wage_change_jj_nhi9=-99
gen wage_change_jj_nhi10=-99
gen wage_change_jj_nhi11=-99

replace wage_change_jj_nhi1=wage_change1 if jj1==1  & (hi1==0 | hi1==2) & (hi2==0 | hi2==2)
replace wage_change_jj_nhi2=wage_change2 if jj2==1  & (hi2==0 | hi2==2) & (hi3==0 | hi3==2)  
replace wage_change_jj_nhi3=wage_change3 if jj3==1  & (hi3==0 | hi3==2)  & (hi4==0 | hi4==2) 
replace wage_change_jj_nhi4=wage_change4 if jj4==1  & (hi4==0 | hi4==2) & (hi5==0 | hi5==2)  
replace wage_change_jj_nhi5=wage_change5 if jj5==1  & (hi5==0 | hi5==2) & (hi6==0 | hi6==2) 
replace wage_change_jj_nhi6=wage_change6 if jj6==1  & (hi6==0 | hi6==2) & (hi7==0 | hi7==2)  
replace wage_change_jj_nhi7=wage_change7 if jj7==1  & (hi7==0 | hi7==2) & (hi8==0 | hi8==2)  
replace wage_change_jj_nhi8=wage_change8 if jj8==1  & (hi8==0 | hi8==2) & (hi9==0 | hi9==2)  
replace wage_change_jj_nhi9=wage_change9 if jj9==1  & (hi9==0 | hi9==2) & (hi10==0 | hi10==2)  
replace wage_change_jj_nhi10=wage_change10 if jj10==1  & (hi10==0 | hi10==2) & (hi11==0 | hi11==2)  
replace wage_change_jj_nhi11=wage_change11 if jj11==1  & (hi11==0 | hi11==2)& (hi12==0 | hi12==2)


gen healthy_1=1 if health_status_ag1==1
replace healthy_1=0 if health_status_ag1==2

sum healthy_1 if healthy_1>=0

rename health_status_ag1 health1
rename health_status_ag13 health2


gen ed1=-99
gen ed2=-99
gen ed3=-99
gen ed4=-99

replace ed1=2 if ed_status1>=0 & ed_status1<=40
replace ed1=1 if ed_status1>40 & ed_status1<.
replace ed2=2 if ed_status13>=0 & ed_status13<=40
replace ed2=1 if ed_status13>40 & ed_status13<. 
replace ed3=2 if ed_status25>=0 & ed_status25<=40
replace ed3=1 if ed_status25>40 & ed_status25<.
replace ed4=2 if ed_status37>=0 & ed_status37<=40
replace ed4=1 if ed_status37>40 & ed_status37<.



replace age1=-99 if age1==.
replace age13=-99 if age13==.
replace age25=-99 if age25==.
replace age37=-99 if age37==.

* drop additional samples

centile wage_month1  if wage_month1>0, centile(1 99)
centile wage_month5  if wage_month5>0, centile(1 99)
centile wage_month9  if wage_month9>0, centile(1 99)
centile wage_month13  if wage_month13>0, centile(1 99)
centile wage_month17  if wage_month17>0, centile(1 99)
centile wage_month21  if wage_month21>0, centile(1 99)
centile wage_month25  if wage_month25>0, centile(1 99)
centile wage_month29  if wage_month29>0, centile(1 99)
centile wage_month33  if wage_month33>0, centile(1 99)
centile wage_month37  if wage_month37>0, centile(1 99)
centile wage_month41  if wage_month41>0, centile(1 99)
centile wage_month45  if wage_month45>0, centile(1 99)

* drop top and bottom 2% wage and  
drop if wage_month1>=5.853577 | (wage_month1<0.2381207 & wage_month1>0)
drop if wage_month5>=5.832065 | (wage_month5<0.2943603 & wage_month5>0)
drop if wage_month9>=5.70299 | (wage_month9<0.2892764  & wage_month9>0)
drop if wage_month13>=5.847036  | (wage_month13<0.288944  & wage_month13>0)
drop if wage_month17>=6.019808  | (wage_month17<0.3305859 & wage_month17>0)
drop if wage_month21>=5.842617  | (wage_month21<0.3589874 & wage_month21>0)
drop if wage_month25>=5.913214  | (wage_month25<0.3117963 & wage_month25>0)
drop if wage_month29>=6.174021  | (wage_month29<0.3417938  & wage_month29>0)
drop if wage_month33>=5.899483 | (wage_month33<0.3471775 & wage_month33>0)
drop if wage_month37>=5.8332 | (wage_month37<0.278152 & wage_month37>0)
drop if wage_month41>=6.000 | (wage_month41<0.3456 & wage_month41>0)
drop if wage_month45>6.032536 | (wage_month45<0.336 & wage_month45>0)


* drop top and bottom 1% wage  
* drop if wage_month1>= 16.57335  | (wage_month1<0.1677399 & wage_month1>0)
* drop if wage_month5>= 16.57335  | (wage_month5<0.1900997 & wage_month5>0)
* drop if wage_month9>= 16.57335  | (wage_month9<0.2011193  & wage_month9>0)
* drop if wage_month13>=16.04064   | (wage_month13<0.1929126  & wage_month13>0)
* drop if wage_month17>=16.04064   | (wage_month17<0.2124588  & wage_month17>0)
* drop if wage_month21>=16.04064   | (wage_month21<0.2124588  & wage_month21>0)
* drop if wage_month25>=15.53795  | (wage_month25<0.1965479 & wage_month25>0)
* drop if wage_month29>=15.53795  | (wage_month29<0.2160907  & wage_month29>0)
* drop if wage_month33>=15.53795| (wage_month33<0.2168975  & wage_month33>0)
* drop if wage_month37>=15.1 | (wage_month37<0.1600 & wage_month37>0)
* drop if wage_month41>=15.1 | (wage_month41<0.20104 & wage_month41>0)
* drop if wage_month45>15.1 | (wage_month45<0.200 & wage_month45>0)


* data generating

drop if emp1==1 & wage_month1<0
drop if emp2==1 & wage_month5<0
drop if emp3==1 & wage_month9<0
drop if emp4==1 & wage_month13<0
drop if emp5==1 & wage_month17<0
drop if emp6==1 & wage_month21<0
drop if emp7==1 & wage_month25<0
drop if emp8==1 & wage_month29<0
drop if emp9==1 & wage_month33<0
drop if emp10==1 & wage_month37<0
drop if emp11==1 & wage_month41<0
drop if emp12==1 & wage_month45<0

drop if emp1==1 & hi1<0
drop if emp2==1 & hi2<0
drop if emp3==1 & hi3<0
drop if emp4==1 & hi4<0
drop if emp5==1 & hi5<0
drop if emp6==1 & hi6<0
drop if emp7==1 & hi7<0
drop if emp8==1 & hi8<0
drop if emp9==1 & hi9<0
drop if emp10==1 & hi10<0
drop if emp11==1 & hi11<0
drop if emp12==1 & hi12<0

drop if hi1_u==1
drop if hi2_u==1
drop if hi3_u==1
drop if hi4_u==1
drop if hi5_u==1
drop if hi6_u==1
drop if hi7_u==1
drop if hi8_u==1
drop if hi9_u==1
drop if hi10_u==1
drop if hi11_u==1
drop if hi12_u==1

gen hi_all1=-99
replace hi_all1=0 if hi1_u==0 | hi1==0
replace hi_all1=1 if hi1==1
replace hi_all1=2 if hi1_u==2 | hi1==2

gen hi_all2=-99
replace hi_all2=0 if hi2_u==0 | hi2==0
replace hi_all2=1 if hi2==1
replace hi_all2=2 if hi2_u==2 | hi2==2

gen hi_all3=-99
replace hi_all3=0 if hi3_u==0 | hi3==0
replace hi_all3=1 if hi3==1
replace hi_all3=2 if hi3_u==2 | hi3==2

gen hi_all4=-99
replace hi_all4=0 if hi4_u==0 | hi4==0
replace hi_all4=1 if hi4==1
replace hi_all4=2 if hi4_u==2 | hi4==2

gen hi_all5=-99
replace hi_all5=0 if hi5_u==0 | hi5==0
replace hi_all5=1 if hi5==1
replace hi_all5=2 if hi5_u==2 | hi5==2

gen hi_all6=-99
replace hi_all6=0 if hi6_u==0 | hi6==0
replace hi_all6=1 if hi6==1
replace hi_all6=2 if hi6_u==2 | hi6==2

gen hi_all7=-99
replace hi_all7=0 if hi7_u==0 | hi7==0
replace hi_all7=1 if hi7==1
replace hi_all7=2 if hi7_u==2 | hi7==2

gen hi_all8=-99
replace hi_all8=0 if hi8_u==0 | hi8==0
replace hi_all8=1 if hi8==1
replace hi_all8=2 if hi8_u==2 | hi8==2

gen hi_all9=-99
replace hi_all9=0 if hi9_u==0 | hi9==0
replace hi_all9=1 if hi9==1
replace hi_all9=2 if hi9_u==2 | hi9==2

gen hi_all10=-99
replace hi_all10=0 if hi10_u==0 | hi10==0
replace hi_all10=1 if hi10==1
replace hi_all10=2 if hi10_u==2 | hi10==2

gen hi_all11=-99
replace hi_all11=0 if hi11_u==0 | hi11==0
replace hi_all11=1 if hi11==1
replace hi_all11=2 if hi11_u==2 | hi11==2

gen hi_all12=-99
replace hi_all12=0 if hi12_u==0 | hi12==0
replace hi_all12=1 if hi12==1
replace hi_all12=2 if hi12_u==2 | hi12==2


save "\\tsclient\Y\SIPP\2004\adjusted_data_file\Aizawa_JMP_SIPP.dta", replace

outsheet emp1 emp2 emp3 emp4 emp5 emp6 emp7 emp8 emp9 emp10 emp11 emp12 using "\\tsclient\Y\SIPP\2004\adjusted_data_file\emp.csv", comma replace noname

outsheet ue1 ue2 ue3 ue4 ue5 ue6 ue7 ue8 ue9 ue10 ue11 using "\\tsclient\Y\SIPP\2004\adjusted_data_file\ue.csv", comma replace noname

outsheet eu1 eu2 eu3 eu4 eu5 eu6 eu7 eu8 eu9 eu10 eu11 using "\\tsclient\Y\SIPP\2004\adjusted_data_file\eu.csv", comma replace noname

outsheet jj1 jj2 jj3 jj4 jj5 jj6 jj7 jj8 jj9 jj10 jj11 using "\\tsclient\Y\SIPP\2004\adjusted_data_file\jj.csv",comma replace noname

outsheet hi1 hi2 hi3 hi4 hi5 hi6 hi7 hi8 hi9 hi10 hi11 hi12 using "\\tsclient\Y\SIPP\2004\adjusted_data_file\hi.csv", comma replace noname

outsheet hi1_u hi2_u hi3_u hi4_u hi5_u hi6_u hi7_u hi8_u hi9_u hi10_u hi11_u hi12_u using "\\tsclient\Y\SIPP\2004\adjusted_data_file\hi_u.csv", comma replace noname

outsheet hi_all1 hi_all2 hi_all3 hi_all4 hi_all5 hi_all6 hi_all7 hi_all8 hi_all9 hi_all10 hi_all11 hi_all12 using "\\tsclient\Y\SIPP\2004\adjusted_data_file\hi_all.csv", comma replace noname

outsheet wage_month1 wage_month5 wage_month9 wage_month13 wage_month17 wage_month21 wage_month25 wage_month29 wage_month33 wage_month37 wage_month41 wage_month45 using "\\tsclient\Y\SIPP\2004\adjusted_data_file\wage.csv",comma replace noname

outsheet health1 health2 using "\\tsclient\Y\SIPP\2004\adjusted_data_file\health.csv",comma replace noname

outsheet age1 age13 age25 age37 using "\\tsclient\Y\SIPP\2004\adjusted_data_file\age.csv",comma replace noname 

outsheet ed1 ed2 ed3 ed4 using "\\tsclient\Y\SIPP\2004\adjusted_data_file\ed.csv",comma replace noname 

outsheet wage_change_stay1 wage_change_stay2 wage_change_stay3 wage_change_stay4 wage_change_stay5 wage_change_stay6 wage_change_stay7 wage_change_stay8 wage_change_stay9 wage_change_stay10 wage_change_stay11 using "\\tsclient\Y\SIPP\2004\adjusted_data_file\wage_change_stay.csv",comma replace noname

outsheet wage_change_jj1 wage_change_jj2 wage_change_jj3 wage_change_jj4 wage_change_jj5 wage_change_jj6 wage_change_jj7 wage_change_jj8 wage_change_jj9 wage_change_jj10 wage_change_jj11 using "\\tsclient\Y\SIPP\2004\adjusted_data_file\wage_change_jj.csv",comma replace noname

outsheet wage_change_jj_hi1 wage_change_jj_hi2 wage_change_jj_hi3 wage_change_jj_hi4 wage_change_jj_hi5 wage_change_jj_hi6 wage_change_jj_hi7 wage_change_jj_hi8 wage_change_jj_hi9 wage_change_jj_hi10 wage_change_jj_hi11 using "\\tsclient\Y\SIPP\2004\adjusted_data_file\wage_change_jj_hi.csv",comma replace noname

outsheet wage_change_jj_nhi1 wage_change_jj_nhi2 wage_change_jj_nhi3 wage_change_jj_nhi4 wage_change_jj_nhi5 wage_change_jj_nhi6 wage_change_jj_nhi7 wage_change_jj_nhi8 wage_change_jj_nhi9 wage_change_jj_nhi10 wage_change_jj_nhi11 using "\\tsclient\Y\SIPP\2004\adjusted_data_file\wage_change_jj_nhi.csv",comma replace noname

* summary statistics
* 
gen college=1 if ed1==1
replace college=0 if ed1==2
sum college [aw=weight_p1]
sum age1 if age1>0 [aw=weight_p1]
tab hi_status1 [aw=weight_p1]
sum wage_month1 if wage_month1>=0 [aw=weight_p1]
bys hi1: sum wage_month1 if wage_month1>=0 [aw=weight_p1]
sum emp1 if emp1>=0 [aw=weight_p1]
gen healthy1=1 if health1==1
replace healthy1=0 if health1==2
sum healthy1 [aw=weight_p5]

sum healthy1 if hi_status5==0 [aw=weight_p5]



gen ins=0
replace ins=1 if hi1==1| hi1==2
bys ins: sum healthy1 [aw=weight_p5]
gen ins_all=0 if hi_all3==0
replace ins_all=1 if hi_all3==1 |hi_all3==2

bys ins_all: sum healthy1 [aw=weight_p5] 

sum ins if emp1==1 [aw=weight_p1]

gen eshi=0
replace eshi=1 if hi1==1
sum eshi if emp1==1 [aw=weight_p1]

gen indhi=0
replace indhi=1 if hi1==2
sum indhi if emp1==1 [aw=weight_p1]

gen hi_u=0
replace hi_u=1 if hi1_u==2
sum hi_u if emp1==0 & hi1_u>=0 [aw=weight_p1]





***** tax simulation **********************************
gen state_dummy=1 if state3==1
replace state_dummy=2 if state3==2
replace state_dummy=3 if state3==4
replace state_dummy=4 if state3==5
replace state_dummy=5 if state3==6
replace state_dummy=6 if state3==8
replace state_dummy=7 if state3==9
replace state_dummy=8 if state3==10
replace state_dummy=9 if state3==11
replace state_dummy=10 if state3==12
replace state_dummy=11 if state3==13
replace state_dummy=12 if state3==15
replace state_dummy=13 if state3==16
replace state_dummy=14 if state3==17
replace state_dummy=15 if state3==18
replace state_dummy=16 if state3==19
replace state_dummy=17 if state3==20
replace state_dummy=18 if state3==21
replace state_dummy=19 if state3==22
replace state_dummy=21 if state3==24
replace state_dummy=22 if state3==25
replace state_dummy=23 if state3==26
replace state_dummy=24 if state3==27
replace state_dummy=25 if state3==28
replace state_dummy=26 if state3==29
replace state_dummy=27 if state3==30
replace state_dummy=28 if state3==31
replace state_dummy=29 if state3==32
replace state_dummy=30 if state3==33
replace state_dummy=31 if state3==34
replace state_dummy=32 if state3==35
replace state_dummy=33 if state3==36
replace state_dummy=34 if state3==37
replace state_dummy=36 if state3==39
replace state_dummy=37 if state3==40
replace state_dummy=38 if state3==41
replace state_dummy=39 if state3==42
replace state_dummy=40 if state3==44
replace state_dummy=41 if state3==45
replace state_dummy=43 if state3==47
replace state_dummy=44 if state3==48
replace state_dummy=45 if state3==49
replace state_dummy=47 if state3==51
replace state_dummy=48 if state3==53
replace state_dummy=49 if state3==54
replace state_dummy=50 if state3==55


gen pwages=wage_month1*3*10000
gen year=2004
gen mstat=1
gen state=state_dummy
taxsim9, full wages replace







log close
